#INAOE --- Package for IRAF routines developed at INAOE

cl < "inaoe$lib/zzsetenv.def"
package inaoe

reset obsdb = "inaoe$obsdb.dat"

reset observatory = "oagh"
#observatory set "oagh"

task canica.pkg     = "canica$canica.cl"
task camila.pkg     = "camila$camila.cl"
task spanal.pkg     = "spanal$spanal.cl"
task imanal.pkg     = "imanal$imanal.cl"
task osiris.pkg     = "osiris$osiris.cl"
task misc.pkg       = "misc$misc.cl"

#Load some of the stsdas packages
cl < inaoe$load.cl
#keep

print(" ")
print("     +-------------------- INAOE IRAF Package -------------------+")
print("     |             Version 1.0, APR 24, 2016                     |")
print("     |            Tested with IRAF v2.16 on Fedora               |")
print("     |    Developed by Divakara Mayya at INAOE, Puebla, Mexico   |")
print("     |                                                           |")
print("     |    Type  help  before using it for the first time         |")
print("     |                                                           |")
#print("     | User's guide is available at                              |")
#print("     |   file:///iraf/iraf/extern/gtcmos/html/mos_reduction.html |")
print("     |                                                           |")
print("     |Please contact ydm@inaoep.mx if you have questions/comments|")
print("     +-----------------------------------------------------------+")
print(" ")

clbye
