procedure canfind(refimno)

int     refimno  = 2         {prompt="No of the ref image (2 for as40k002 etc.)"}
bool	runref   = no        {prompt="Run canref?"}
bool	sextract = no        {prompt="Use Sextractor for star search?[if NO uses daofind]"}
string  refcoo   = "ref.coo" {prompt="file (ref.coo) with ref star position or as40k002ref"}
string  crpix    = "center"  {prompt="[center/refstar] XY pixels of RA-Dec"}
real	datamaxim   = 20000   {prompt="Maximum good data"}
real	kclip       = 1.5     {prompt="k-sigma clipping "}
real	fwhm        = 5	      {prompt="FWHM of the images"}
real    zeromag     = 0.0     {prompt="Zeropoint"}
bool	display     = yes     {prompt="Display the identified stars in each image?"}
int     nident      = 2       {prompt="Min number of stars to be identified"}
bool	skipfind    = no      {prompt="Skip find stars and only search for common stars?"}

begin

	string  imfil[99],daocoo,daomag,tmp,daomag1,logfile,cmn,froot,refim
	string	sexcmd
	real	skymed, skyrms, datamax, ksigma, fwhmpsf, zpmag
	real    xref, yref, x, y, xrel, yrel, mag, dist, distmin, distmax
	real    xrel1[99], yrel1[99], angle1[99], dist1[99], avxshi, avyshi 
	real	xpos1[99], ypos1[99], mag1[99], xshi, yshi, mshi, xnew, ynew
	real	angle,angledif,anglmin,anglmax,magref,avmag,distin,xin,yin
	real	xcen[99],ycen[99],fwhmx[99],fwhmdif,z, xxx, ymin, ymax
	int     itv, nstar, i1, i2, i3, i, id, iref, nim, im, imref, nfind
	int     im1,im2,imn,kref,j,numstar
        struct  line
	bool    runcanref, disp, skip, sextractor

	runcanref = runref; disp = display; skip = skipfind; sextractor=sextract

	if (runcanref) canref (refimno, refcoo, crpix=crpix)

#-----------------------------------------------------------
	datamax = datamaxim; ksigma = kclip; fwhmpsf = fwhm; zpmag = zeromag; imn=refimno
	xshi = 0.0; yshi = 0.0; numstar = nident

	xin = 512.0; yin = 512.0; distin = 400.0

	froot  = canobj.root
        im1 = canobj.imbeg; im2 = canobj.imend; nim = im2 - im1 + 1
        imref = imn - im1 + 1
        cmn = froot//str(imn)
        if (imn < 100) cmn = froot//"0"//str(imn)
        if (imn < 10) cmn = froot//"00"//str(imn)
	refim  = cmn//"_ref"
#-----------------------------------------------------------

	#First stars in each image and obtain the separation and angle of all the stars
	#wrt the brightest. Mark all the identified stars on the display device.


	delete("daophot.mag", ver-, >& "dev$null")
	delete("daophot2.mag", ver-, >& "dev$null")

	for (i=1;  i <= nim;  i += 1) {
        imn = im1 + i - 1
        cmn = froot//str(imn)
        if (imn < 100) cmn = froot//"0"//str(imn)
        if (imn < 10) cmn = froot//"00"//str(imn) 
	imfil[i] = cmn//"sf"
	if (!access(imfil[i]//".fits") && !skip) {
		imarith (cmn//"_I.fits", "-", froot//"_sky1", cmn//"sf", ver-)
		}
	if (skip) { daomag1 = imfil[i]//"_phot.mag"; if (!access(daomag1)){skip = no} }
	}

	logfile = imfil[imref]//"_dao.log"
	print ("------------------------------ CANFIND ---------", >> logfile)

        if (skip)goto identify_common_stars

	for (i=1;  i <= nim;  i += 1) {
	itv = mod(i,4)
	if (itv == 0) itv = 4
	daocoo = imfil[i]//"_dao.coo"; delete(daocoo, ver-, >& "dev$null")
	daomag = imfil[i]//"_dao.mag"; delete(daomag, ver-, >& "dev$null")
	daomag1 = imfil[i]//"_phot.mag"; delete(daomag1, ver-, >& "dev$null")

#-----------------------------------------------------------------------------
	imdelete("timsurfit", ver-, >& "dev$null")
	imsurfit (imfil[i], "timsurfit", xord=5, yord=5, type_ou="residual", functio="legendre", cross_t+)
	imstat ("timsurfit", fields="midpt,stddev", format- ) | scan (skymed,skyrms)

	j = 0
daofind_again:
	delete("canfind.imcur", ver-, >& "dev$null")
	delete("canfind.gcur", ver-, >& "dev$null")
	delete("psfmeasure.log", ver-, >& "dev$null")

	if (sextractor){
	if (!access("canica.sex"))copy ("home$canica.sex", "canica.sex", ver-)
	if (!access("canica.param"))copy ("home$canica.param", "canica.param", ver-)
	if (!access("default.conv"))copy ("home$default.conv", "default.conv", ver-)
	if (!access("default.nnw"))copy ("home$default.nnw", "default.nnw", ver-)
	delete("check1.fits", ver-, >& "dev$null")
	delete("canica.cat", ver-, >& "dev$null")
	#delete("", ver-, >& "dev$null")
	sexcmd =  "!sex -c canica.sex "//imfil[i]//".fits"
	#!sex -c canica.sex imfil[i]//".fits" 
	print ( sexcmd ) | cl >& "dev$null"
	#display ("check1.fits", itv, zs-, zr-, z1=-2, z2=20, >& "dev$null")
	sort ("canica.cat", column=3, reverse+, numeric+, >> daocoo)
	#goto psfmeasure 
	} else {
	daofind("timsurfit", output=daocoo, fwhmpsf=fwhmpsf, sigma=skyrms, datamin=skymed, 
		datamax=datamax, thresho=ksigma, verify-, int-)
	}
	
        i1 = 0
        list = daocoo
	dist = 31.0
        while( fscan(list, line) != EOF ) {
            tmp = substr (line, 1, 1)
            if (tmp != "#") {
		i1 = i1 + 1
                i2 = fscan(line,x,y)
		if (i1 < 99){
		xcen[i1] = x; ycen[i1] = y
		if (i1 > 1){ xrel = abs(xcen[i1] - xcen[i1-1]); yrel = abs(ycen[i1] - ycen[i1-1]);
				dist = sqrt((xrel)**2+(yrel)**2+0.01) }
		if (dist > 30.0)print (xcen[i1],ycen[i1],"101  m", >> "canfind.imcur")
		}
	}
	}
	type ("canfind.imcur") | wc | scan (i1)
	if (i1 < 4) { 
		xxx = 0.90   - 0.05*j
		#print (j,fwhmpsf,skyrms,i1,i)
		fwhmpsf= fwhmpsf-(0.1*j); j = j + 1
		if (fwhmpsf < 4.0 ){fwhmpsf = 12.0}
		if (j == 10) {print("no stars identified"); goto exit}
		delete(daocoo, ver-, >& "dev$null") 
		goto daofind_again 
		}
	if (i1 > 99 ){
		xxx = 0.95  +0.01
		fwhmpsf= fwhmpsf + (0.07*j); j = j + 1
		#print (j,fwhmpsf,skyrms,i1,i)
		if (fwhmpsf > 12.0){fwhmpsf = 4.0}
		if (j == 10) {print("no stars identified"); goto exit}
		delete(daocoo, ver-, >& "dev$null") 
		goto daofind_again 
		}
psfmeasure:
	print ("101  101  101  q", >> "canfind.imcur")
	print ("101  101  101  q", >> "canfind.gcur")
	psfmeasure("timsurfit",coords="markall",wcs="logical",display-,
		logfile="psfmeasure.log",imagecu="canfind.imcur", graphcu="canfind.gcur", >> logfile)
	wc "psfmeasure.log" | scan (i1)
	list = "psfmeasure.log"
	for (j=1;  j <= i1;  j += 1) {
        	i2 = fscan(list, line)
		if (j > 3 && j <= (i1-2)){
		i2 = fscanf(line,"%16c %f %f %f %f \n",tmp,x,y,mag,z)
		xcen[j-3] = x; ycen[j-3]=y; fwhmx[j-3] = z
		#print(x,y,z)
		}
	}
	fwhmpsf = real(substr (line, 47, 53))
	if (fwhmpsf < 4.0 || fwhmpsf > 12.0){fwhmpsf = 8.0}
	#write only those stars whose FWHM is within 50% of the mean.
	i1 = i1-5
	delete(daocoo, ver-, >& "dev$null")
	for (j=1;  j <= i1;  j += 1) { 
		fwhmdif = abs(fwhmx[j] - fwhmpsf)/fwhmpsf 
		if (fwhmdif < 0.50 ){print(xcen[j],ycen[j], >> daocoo)}
	 }
	if (access(daocoo)){type (daocoo) | wc | scan (i2)} else {i2 = 0}
	if (i2 < nident) {  
		if (fwhmpsf < 4.0 || fwhmpsf > 12.0){fwhmpsf = 8.0}
		delete(daocoo, ver-, >& "dev$null"); goto daofind_again
		    }
	#print("Mean FWHM of ",i1," stars = ",fwhmpsf,". ",i2," of these retained.")
	#if (i1 < 100) goto exit

photometry:
	# At least 2 stars identified. Do photometry
#----------------------------------------------------------------------
	phot (imfil[i], skyfile="", coords=daocoo, output=daomag1, plotfile="",
		scale=1.0, fwhmpsf=5.0, epadu=10.0, readnoise=3.0, filter="FILTER2",
		exposur="", airmass="", xairmas=1.0, itime=1.0, salgorithm="median",
		annulus =20, dannulus =10, cbox=5, calgorithm="centroid",
		apertures="5,10,14,17,20", zmag=zpmag, interactive=no, radplots=no,
		verify=no, update=no, verbose=no, graphics="stdgraph", display="stdimage",
		icommands="", gcommands="")
	delete(daocoo, ver-, >& "dev$null")
	txsort (daomag1, field="MAG[2]", ascend+)
	txdump (daomag1, "MAG[2]", "MAG[2]!=INDEF") | wc | scan (nstar)
	txdump (daomag1, "XCENTER YCENTER MAG[2]", "MAG[2]!=INDEF", headers+, paramet-, >> daomag)
	delete(daomag1, ver-, >& "dev$null")
	print("#N  XCENT     YCENT     MAG2      XREL      YREL     ANGLE      DIST   ID ", >> daomag1) 
	i1 = 0
        list = daomag
	while( fscan(list, line) != EOF ) {
	    tmp = substr (line, 1, 1)
            if (tmp != "#") {
                i2 = fscan(line,x,y,mag)
                i1=i1+1
		if (i1 == 1) {xref = x ; yref = y; magref=mag}
		xrel = abs(xref - x) ; yrel = abs(yref - y)
		angle = (180.0/3.141593)*atan2(xrel, yrel)
		dist  = sqrt((xrel)**2+(yrel)**2)
	printf("%9.3f %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f %3d \n",x,y,mag,xrel,yrel,angle,dist, i1, >> daomag1 )
	    }
	}
	if (disp){
		display (imfil[i], itv, zs+, fill+, >& "dev$null")
		tvmark (itv, daomag1, mark="circle", radii=10, number+, nxoff=3, nyoff=3, txsize=2)
		}
	if (i == 1)print(" Image         SKYMED     SKYRMS Nstar  XPOS    YPOS    MAG    FWHM")
	printf ("%c %8.3f %8.3f %d %8.3f %8.3f %8.3f %8.3f \n", imfil[i], skymed, skyrms, nstar, xref, yref, magref,fwhmpsf)
	if (i == 1)print(" Image         SKYMED     SKYRMS Nstar  XPOS    YPOS   MAG", >> logfile)
	printf ("%c %8.3f %8.3f %d %8.3f %8.3f %8.3f \n", imfil[i], skymed, skyrms, nstar, xref, yref, magref,fwhmpsf,>> logfile)
	delete(daomag, ver-, >& "dev$null")
	}
#-----------------------------------------------------------------------------

identify_common_stars:

	#Stage II: find the common stars in different images. imref is the reference image
	#and iref is the reference star.

	if (numstar == 1) {
	#print ("test")
	delete(refim//".seq", ver-, >& "dev$null")
	delete(refim//".coo", ver-, >& "dev$null")
	for (im=1;  im <= nim;  im += 1) {
        daomag1 = imfil[im]//"_phot.mag"
	list = daomag1
		i2 = fscan(list, line)
		i2 = fscan(list, line)
	        i2 = fscan(line,x,y,mag)
		if (im == 1){ymin=mag+1; ymax = mag-1
		print(im,mag) | graph (wx1=0, wx2=nim+1, wy1=ymin, wy2=ymax, pointmo+, marker="box", szmarke=0.01, xlabel="image number", ylabel="mag", overplo-, app- )
		} else {
		print(im,mag) | graph (pointmo+, marker="box", szmarke=0.01, overplo+, app+ )
		}
		printf ("%9.3f %9.3f %9.3f %20c \n",x,y,mag, imfil[im])
		printf ("%9.3f %9.3f %9.3f %20c \n",x,y,mag, imfil[im], >> refim//".seq")
		if (im == imref)printf ("%9.3f %9.3f %9.3f %20c \n",x,y,mag, imfil[im], >> refim//".coo")
	}
		goto set_canobj
	}

        daomag1 = imfil[imref]//"_phot.mag"
	type (daomag1, >> logfile)
        i1 = 0
        list = daomag1
        while( fscan(list, line) != EOF ) {
            tmp = substr (line, 1, 1)
            if (tmp != "#") {
              i2 = fscan(line,x,y,mag,xrel,yrel,angle,dist)
              i1=i1+1
	      xpos1[i1] = x; ypos1[i1] = y; mag1[i1] = mag
	      xrel1[i1] = xrel; yrel1[i1] = yrel; angle1[i1] = angle; dist1[i1] = dist
            }
        }
	nstar = i1

	iref = 0
	for (i1=1;  i1 <= nstar;  i1 += 1) {	
		dist  = sqrt((xpos1[i1]-xin)**2+(ypos1[i1]-yin)**2)
		if (dist < distin ) {iref = i1-1; break}
	}
	print(iref,dist)

	nfind = 0
	im = 0
new_ref: 
	iref = iref + 1
	delete(refim//".seq", ver-, >& "dev$null")
	if (iref < nstar && im > 1){im = im - 1}
	#if (nfind == 0 && iref < nstar && im > 1){im = im - 1}
	#print ("--------------- REFERENCE IMAGE= ",imfil[imref], " Reference star=",iref, nfind, im)
	#if (iref == 1)print("  XPOS    YPOS     MAG       XSHI     YSHI    MSHI REF Ncom    Image")
	#printf ("%9.3f %9.3f %20c \n",xpos1[iref],ypos1[iref],imfil[imref], >> refim//".seq")
	#print ("--------------- COMPARISON IMAGE= ",imfil[im])
new_image:
	im = im + 1
	if (im == imref){
	printf ("%9.3f %9.3f %20c \n",xpos1[iref],ypos1[iref],imfil[imref], >> refim//".seq")
		goto skip_ref
		}
        daomag1 = imfil[im]//"_phot.mag"
	if (im == 2 && iref == 1)type (daomag1, >> logfile)
	if (im > 2 )type (daomag1, >> logfile)
	avxshi = 0.0; avyshi = 0.0; avmag = 0.0
        i1 = 0
        i3 = 0
        list = daomag1
        while( fscan(list, line) != EOF ) {
            tmp = substr (line, 1, 1)
            if (tmp != "#") {
              i2 = fscan(line,x,y,mag,xrel,yrel,angle,dist,id)
              i1=i1+1
		if (dist < 30.0) {goto skip_this_star}
	      for (i=1;  i <= nstar;  i += 1) {
	      xrel1[i] = abs(xpos1[iref] - xpos1[i]); yrel1[i] = (ypos1[iref] - ypos1[i])
                angle1[i] = (180.0/3.141593)*atan2(xrel1[i], yrel1[i])
                dist1[i]  = sqrt((xrel1[i])**2+(yrel1[i])**2)
	if (iref > 1 && i1 == 1) printf("%9.3f %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f %4d \n", xpos1[i],ypos1[i],mag1[i],xrel1[i],yrel1[i],angle1[i],dist1[i], i, >> logfile) 
		if (dist1[i] < 30.0 ) {goto skip_this_ref_star}
	      distmin = dist1[i] - 2.0; distmax = dist1[i] + 2.0
	      anglmin = angle1[i] - 1.0; anglmax = angle1[i] + 1.0
	      if (i != iref && dist > distmin && dist < distmax && angle > anglmin && angle < anglmax) {
		i3 = i3 + 1
		xshi = xpos1[i] - x; yshi = ypos1[i] - y; mshi = mag1[i] - mag
		avxshi = avxshi + xshi; avyshi = avyshi + yshi; avmag = avmag + mshi 
	if (i3 == 1)print(" im1  im2    XPOS1    YPOS1       MAG1      XSHI     YSHI      MSHI", >> logfile)
		printf("%4d %4d %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f \n", i,i1,xpos1[i],ypos1[i],mag1[i],xshi,yshi,mshi, >> logfile) 
	      }
	      #}
skip_this_ref_star:
	      }
            }
skip_this_star:
        }
	if (i3 > 0){
	#print("Reference star found in ",imfil[imref]," Star no = ",iref)
  	nfind = nfind + 1
	if (nfind == 1){
		print("  XPOS    YPOS     MAG       XSHI     YSHI    MSHI REF Ncom    Image")
		im = 0
		goto new_image
		}
	avxshi = avxshi/real(i3); avyshi = avyshi/real(i3); avmag = avmag/real(i3)
	xnew = xpos1[iref] - avxshi; ynew = ypos1[iref] - avyshi

	#-------------------
	printf ("%9.3f %9.3f %20c \n",xnew, ynew, imfil[im], >> refim//".seq")
		i1 = i3+1
	#print(i1," common stars between ",imfil[imref]," and ",imfil[im], " found.")
	print(i1," common stars between ",imfil[imref]," and ",imfil[im], " found.", >> logfile)
	print(" XPOS1_iref YPOS1_iref  MAG1_iref XSHI     YSHI    MSHI  iref  im  ncom", >> logfile)
	printf("%7.1f %7.1f %8.3f %8.2f %8.2f %8.3f %3d %3d %c \n", xpos1[iref],ypos1[iref],mag1[iref],avxshi, avyshi,avmag,iref,i1,imfil[im])
	printf("%7.1f %7.1f %8.3f %8.2f %8.2f %8.3f %3d %3d %c \n", xpos1[iref],ypos1[iref],mag1[iref],avxshi, avyshi,avmag,iref,i1,imfil[im], >> logfile)
	#-------------------

		} else if (iref < nstar && nfind == 0) {
			i1 = iref+1
		#print("Searching with star no=", i1, " in ",imfil[imref], " as a reference" )
	print("Searching with star no=", i1, " in ",imfil[imref], " as a reference", >> logfile )
				goto new_ref
			} else {
		#print("There are no common stars between ",imfil[imref]," and ",imfil[im])
	print("There are no common stars between ",imfil[imref]," and ",imfil[im], >> logfile)
		xnew = abs(xshi) + 1025.0; ynew = abs(yshi) + 1025.0
		printf ("%9.3f %9.3f %20c \n",xnew, ynew, imfil[im], >> refim//".seq")
			}
		
skip_ref:
		if (im < nim && iref == nstar && nfind == 0) {iref = 0; goto new_ref}
		if (im < nim ) goto new_image

	#for (i=1;  i <= nim;  i += 1) {
	#	daomag1 = imfil[i]//"_phot.mag"
	#	if (i != imref)delete(daomag1, ver-, >& "dev$null")
	#}
	angledif = 0.0
	delete(refim//".coo", ver-, >& "dev$null")
	nstar = max(nstar, 8)
	printf ("%9.3f %9.3f %9.3f %c \n",xpos1[iref],ypos1[iref],mag1[iref],imfil[iref], >> refim//".coo")
	for (i=1;  i <= nstar;  i += 1) {
		#if (i > 1){dista = dist1[i] - dist1[i-1]}
		if (i > 1){angledif = abs(angle1[i] - angle1[i-1])}
                if (angledif > 2.0 ) {
	printf ("%9.3f %9.3f %9.3f %c \n",xpos1[i],ypos1[i],mag1[i],imfil[i], >> refim//".coo")
	}
	}

set_canobj:
	delete(refim//".xy", ver-, >& "dev$null")
	copy (refim//".coo", refim//".xy", ver-)
	imdelete(refim, ver-, >& "dev$null")
	imcopy (imfil[imref], refim, verbose=no)
	canobj.refimag = refim
        canobj.sequenc = refim//".seq"
        canobj.iref = imref
        canobj.seqbeg= im1
        canobj.xshi = 0
        canobj.yshi = 0
        canobj.crval1= 0.0
        canobj.crval2= 0.0
        canobj.epoch = 2000.0
        canobj.cdelt1 = 0.32/3600.0
        canobj.cdelt2 = 0.32/3600.0

exit:

	print(" ")   #**** DONE   *****"

end

