procedure canradec(root, imbeg, imend)

#canradec is a script to correct the "RA" and "DEC" keywords of the
#first image of a sequence, which are assumed to 0.0. The script replaces 
#them with the corresponding values in the next image of the sequence.
#ydm@inaoep.mx   3 Feb 2011

string  root     = "can"              {prompt="Root Image Name"}
int     imbeg    = "1"                 {prompt="First Image Number"}
int     imend    = "10"                 {prompt="Last Image Number"}


begin	
	string	froot, cmn[999], cra, cdec, ra, ra_key
	#real	ra
	int	im1, im2, i, k, nima

	froot  = root; im1 = imbeg; im2 = imend
	nima = im2 - im1 + 1

	k = 0
        for (i=1;  i <= nima;  i += 1) { 
	k = im1 + i -1
	cmn[i] = froot//str(k)
        #if (k < 1000) cmn[i] = froot//"0"//str(k) + "_I"
        #if (k < 100) cmn[i] = froot//"00"//str(k) + "_I"
        #if (k < 10) cmn[i] = froot//"000"//str(k) + "_I"
        if (k < 100) cmn[i] = froot//"0"//str(k) + "_I"
        if (k < 10) cmn[i] = froot//"00"//str(k) + "_I"
		#print(cmn[i], " ", i)
	}

	canrakey(cmn[nima], verb-)
	ra_key = canobj.rakey
	k = 0
        for (i=1;  i <= nima-1;  i += 1) { 
		#hselect(cmn[i], "RA", expr+) | scan (ra)
		hselect(cmn[i], ra_key, expr+) | scan (ra)
                  #print (ra)
		if (ra == "00:00:00.00" || ra == "/") {
	 	k = k + 1
		imgets(cmn[i+1], ra_key); cra = imgets.value
		imgets(cmn[i+1], "DEC"); cdec = imgets.value
    	hedit (cmn[i], fields=ra_key, value=cra, add+, delete-, verify-, show+, update+)
    	hedit (cmn[i], fields="DEC", value=cdec, add+, delete-, verify-, show+, update+)
		}
	}

	print ("===> ",k, " images with RA=00:00:00.00 replaced by the RA and DEC values of the next image")

end
