#CONTSUB --- Task for IRAF routines developed at INAOE

package imanal

task contsub     = "inaoe$pkg/imanal/src/contsub.cl"
task lfosc       = "inaoe$pkg/imanal/src/lfosc.cl"
task lfosc_wcs   = "inaoe$pkg/imanal/src/lfosc_wcs.cl"
task asym_par    = inaoe$pkg/imanal/src/asym_par.cl
task catimreg    = inaoe$pkg/imanal/src/catimreg.cl
task corpsf      = inaoe$pkg/imanal/src/corpsf.cl
task xytoreg     = inaoe$pkg/imanal/src/xytoreg.cl
task starcen     = inaoe$pkg/imanal/src/starcen.cl
task hstwcs      = inaoe$pkg/imanal/src/hstwcs.cl
task s0sky       = inaoe$pkg/imanal/src/s0sky.cl
task s0prof      = inaoe$pkg/imanal/src/s0prof.cl
task imcut       = inaoe$pkg/imanal/src/imcut.cl
task m82_spiral  = inaoe$pkg/imanal/src/m82_spiral.cl
task wcsmosaic   = inaoe$pkg/imanal/src/wcsmosaic.cl
task ltvhead     = inaoe$pkg/imanal/src/ltvhead.cl
task cmdplot     = inaoe$pkg/imanal/src/cmdplot.cl
task m81_stars_cmd = inaoe$pkg/imanal/src/m81_stars_cmd.cl
task m81_analyze = inaoe$pkg/imanal/src/m81_analyze.cl
task nirasym     = inaoe$pkg/imanal/src/nirasym.cl
task asym        = inaoe$pkg/imanal/src/asym.cl
task apcor       = inaoe$pkg/imanal/src/apcor.cl
task reduce      = inaoe$pkg/imanal/src/reduce.cl
task rc3head     = inaoe$pkg/imanal/src/rc3head.cl
task galphot     = inaoe$pkg/imanal/src/galphot.cl
task sedphot     = inaoe$pkg/imanal/src/sedphot.cl
task ringdisp    = inaoe$pkg/imanal/src/ringdisp.cl
task sbprof      = inaoe$pkg/imanal/src/sbprof.cl
task ringim      = inaoe$pkg/imanal/src/ringim.cl
task ha_phot     = inaoe$pkg/imanal/src/ha_phot.cl
task ringtrim    = inaoe$pkg/imanal/src/ringtrim.cl
task ringfig     = inaoe$pkg/imanal/src/ringfig.cl
task noise       = inaoe$pkg/imanal/src/noise.cl
task ringprof    = inaoe$pkg/imanal/src/ringprof.cl
task sky_stat    = inaoe$pkg/imanal/src/sky_stat.cl
task ring_ned    = inaoe$pkg/imanal/src/ring_ned.cl
task varphot     = inaoe$pkg/imanal/src/varphot.cl
task sdss_to_ubvri = inaoe$pkg/imanal/src/sdss_to_ubvri.cl
task wcsmosaic2m = inaoe$pkg/imanal/src/wcsmosaic2m.cl
task inscale     = inaoe$pkg/imanal/src/inscale.cl
task imscale     = inaoe$pkg/imanal/src/imscale.cl
task incmdprof   = inaoe$pkg/imanal/src/incmdprof.cl
task plotcmd     = inaoe$pkg/imanal/src/plotcmd.cl
task intrim      = inaoe$pkg/imanal/src/intrim.cl
task instat      = inaoe$pkg/imanal/src/instat.cl
task ingeom      = inaoe$pkg/imanal/src/ingeom.cl
task inasym      = inaoe$pkg/imanal/src/inasym.cl
task regtomask   = inaoe$pkg/imanal/src/regtomask.cl
task regtoxy     = inaoe$pkg/imanal/src/regtoxy.cl
task galasym     = inaoe$pkg/imanal/src/galasym.cl


hide galphot
hide sbprof

clbye
