procedure  apcor(datbas, xpos, ypos)

string datbas                             {prompt="Database file" }
real   xpos				  {prompt="X position of F108" }
real   ypos				  {prompt="Y position of F108" }
real   angle = 0.0 		  	  {prompt="Y position of F108" }

begin
	string  dbase, coofil, magfil, magfile
	dbase  = datbas
	coofil = dbase//".coo"
	magfil = dbase//".mag.1"
	magfile = dbase//".mag"

lintran ("m67std.coo",
xfield=1, yfield=2, min_sigdigit=3, x1=288.174, y1=386.978, xscale=1.,
yscale=1., angle=angle, x2=xpos, y2=ypos, radians=no) | cat > TEMP.COO
rename ("TEMP.COO", coofil )

phot (datbas,
"", coords=coofil, output="default", plotfile="", datapars="",
centerpars="", fitskypars="", photpars="", interactive=no, radplots=no,
verify=yes, update=no, verbose=no, graphics="stdgraph", display="stdimage",
icommands="", gcommands="")

txcalc (magfil, "MAG[5]", "MAG[1]-MAG[4]")
txdump (magfil, "ID,XCEN,YCEN,XSHIFT,YSHIFT,MAG[1],MAG[4-5]", "yes", headers=no, parameters=yes)
txcalc (magfil, "MAG[5]")
txdump (magfil, "ID,XCEN,YCEN,MSKY,MAG[1-5]", "yes", headers=no, parameters=yes)
txdump (magfil, "ID,XCEN,YCEN,MSKY,MAG[1-5]", "yes", headers=no, parameters=yes)| cat > TEMP.MAG 
rename ("TEMP.MAG", magfile )

end

