procedure inscale(infile)

string  infile = "infile"        	{prompt="Image name"}
string  units  = "arcsec"          	{prompt="Output scale units [arcsec/arcmin/degree]"}
real    scale  = 1.0       	   	{prompt="output scale"}
bool	verbose= yes		   	{prompt="Write the result on the terminal"}

begin
	string	filnam, sunit, dum1, dum2
	real	conv, im_sca
	int	nl, nw, nc
	bool	verb

	filnam = infile; sunit = strlwr(units); verb = verbose
	conv = 3600.
	if (sunit == "arcmin") {conv = 60.}
	if (sunit == "degree") {conv = 1.}

	nl = 1; nw = 1
        dum1 = ""; dum2 = ""
	#imhead (filnam, l+) | grep ("CDELT1") | scan (dum1)
        hselect (filnam, "CDELT1", yes) | scan (dum1)
	#imget (filnam, "CDELT1"); dum1 = imget.value
        if (dum1 == ""){  #print ("CDELT1=",dum1, "x")
	imget (filnam, "CD1_1"); dum1 = imget.value
	imget (filnam, "CD1_2"); dum2 = imget.value
	#imhead (filnam) | grep ("CD1_1") | scan (dum1)
	#imhead (filnam) | grep ("CD1_2") | scan (dum2)
        #hselect (filnam, "CD1_1", yes) | scan (dum1)
        #hselect (filnam, "CD1_2", yes) | scan (dum2)
        }
	#print(dum1)
        if (dum2 != ""){im_sca = conv*sqrt(real(dum1)**2 + real(dum2)**2)} else {
        im_sca = conv*abs(real(dum1))
        }

	if (verb){print("ImageScale of ",filnam, " = ",im_sca, " arcsec/pixel")}
	inscale.scale = im_sca

end
