procedure intrim(infil, xc, yc, xwin, ywin)

string  infil   = "R04V"    	{prompt="Input image to find bg"}
real    xc      = 0.0           {prompt="X to center"}
real    yc      = 0.0           {prompt="Y to center"}
int     xwin    = 100           {prompt="XWIN to trim"}
int     ywin    = 100           {prompt="YWIN to trim"}
string  name    = "obj"  	{prompt="Identification name suffix for the trimmed image"}
bool	verbose = yes		{prompt="Verbose output?"}

begin
	string	imfil, id, trimsec, trimfil
	real	x0, y0
	int	ix1, ix2, iy1, iy2, dx, dy

	imfil = infil; id = name

	x0 = xc; y0 = yc; dx = xwin; dy = ywin
	ix1 = int(x0 - dx/2.0) + 1; ix2 = int(x0 + dx/2.0)
	iy1 = int(y0 - dy/2.0) + 1; iy2 = int(y0 + dy/2.0)
	trimsec = "["//str(ix1)//":"//str(ix2)//","//str(iy1)//":"//str(iy2)//"]"
	#print(trimsec)
        trimfil = imfil//"_"//id
        imdelete(trimfil, ver-, >& "dev$null")
	imcopy (imfil//trimsec, trimfil, verb=verbose)
	#instat(trimfil)

end
