procedure nirasym(gal, gausg)

int     gal                           {prompt="UGC Number   "}
real    gausg = 1.0                   {prompt="Sigma of smoothing Gaussian"}
string  dir    = "/home/ydm/data/"     {prompt="fits data dir "}
real    starrad= 10.0                  {prompt="Aperture Radius to remove stars"}
real    bsize  = 7.0                   {prompt="Imalign boxsize"}
bool    repcen = "no"              {prompt="Neglect Center while computing A?"}
bool    align  = "yes"              {prompt="Use imalign?"}
bool    clean  = "no"                 {prompt="Delete all intermediate files?"}

begin

string ugc, fitsfil,input,tit,filt[6],beg, sec, sec2 
string im1, tarfil, repsec, imlog, edfil
real   fwhm, skyval, bg, gausig, xmag, ymag, starad
int    ugcno, n1, n2, nm1, nm2, nfil, ifil, dx, dy, dy2
bool   del

	ugcno = gal
	starad = starrad
	gausig = gausg
	del = clean
	dx = 0.0

	if (ugcno < 10) 
		ugc = "0000"//str(ugcno)
	else if (ugcno < 100) 
		ugc = "000"//str(ugcno)
	else if (ugcno < 1000) 
		ugc = "00"//str(ugcno)
	else if (ugcno < 10000) 
		ugc = "0"//str(ugcno)
	else 
		ugc = str(ugcno)

		beg  = "u"
		filt[1] = "b"
		filt[2] = "v"
		filt[3] = "r"
		filt[4] = "i"
		filt[5] = "h"
		filt[6] = "k"
		nfil = 2
	#tarfil = dir//tel//".fits.tar"
	ifil = 0
start:
	ifil = ifil + 1
	print("Analysing ",filt[ifil], " band image of ugc", ugc)
	fitsfil = dir//beg//ugc//filt[ifil]//".mt"
	#fitsfil = beg//"_n"//ugc//"_"//filt[ifil]//"_1.fits"
	#rtar "-xvf"//" "//tarfil//" "//fitsfil
	input  = beg//ugc//filt[ifil]

         imdelete (input, ver-, >& "dev$null") 

       rfits (fits_fil=fitsfil, iraf_fil=input)  
	
       #display (input, inum, zs-, xmag=1.0,ymag=1.0) 

imgets (input, "i_naxis1")
n1 = int(imgets.value)
imgets (input, "i_naxis2")
n2 = int(imgets.value)
imgets (input, "SEEING")
fwhm = real(imgets.value)
        #fwhm = 2.0
#imgets (input, "G_CENT_X")
#x0 = real(imgets.value)
#imgets (input, "G_CENT_Y")
#y0 = real(imgets.value)
imgets (input, "SKYLEV")
skyval = real(imgets.value)

	xmag = 500.0/n1
	ymag = 500.0/n2
	if (ymag < xmag)xmag = ymag
	print("xmag = ",xmag)
        display (input, ifil, zs-, xmag=xmag, ymag=xmag, ztrans="linear") 
	if (ifil > 1)print("Image Section to trim is ", sec2)
	#print("Choose the cut-off value and Image Section to sum")
	if (ifil == 1){
	print("Choose the image center [x0, y0] ")
	imexam (logfile="nirasym-imexam.log", keeplog=yes)
	scan(nm1, nm2)
        display (input, ifil, zs+, xmag=xmag, ymag=xmag, ztrans="linear") 
	print("Choose the trim section [half box size] ")
	scan(dy2)
sec2 = "["//str(nm1-dy2)//":"//str(nm1+dy2)//","//str(nm2-dy2)//":"//str(nm2+dy2)//"]"
	}

	print("Subtracting a SKY value of ", skyval)
	#print("Choose the SKY value ")
	#imexam (logfile="nirasym-imexam.log", keeplog=yes)
	#scan(skyval)

        imdelete (input//"0", ver-, >& "dev$null") 
	imcopy (input//sec2, input//"0", ver-)

	imarith (input//"0", "-", skyval, input//"0", title=" ")

#hedit (input//"0", "G_CENT_X", nm1, add=yes, delete=no, verify=no, show=yes, update=yes)
#hedit (input//"0", "G_CENT_Y", nm2, add=yes, delete=no, verify=no, show=yes, update=yes)
#hedit (input//"0", "SKY", skyval, add=yes, delete=no, verify=no, show=yes, update=yes)

         imdelete (input, ver-, >& "dev$null") 
         imdelete (input//"_t0", ver-, >& "dev$null") 


	xmag = 500.0/(2*dy2+1)
	print("xmag = ",xmag)
        display (input//"0", 2, zs+, xmag=xmag, ymag=xmag, ztrans="linear") 

otravez:

print("Choose stars to delete using imedit [radius=", starad, "]")
print("To change radius to 15 pix,  :radius 15 ; b for replacing background")

imlog = beg//ugc//"-imedit.log"
print("Name of the imedit log file [cursor|", imlog, "}")
scan(edfil)
if (edfil == "cursor"){

imedit (input//"0", input//"_t0",
cursor="", logfile=imlog, display=yes, autodisplay=yes,
autosurface=no, aperture="circular", radius=starad, search=2., buffer=1.,
width=2., xorder=2, yorder=2, value=0., sigma=INDEF, angh=-33., angv=25.,
command="display $image 1 erase=$erase zs- fill=yes order=0 >& dev$null",
graphics="stdgraph", default="b", fixpix=no)

} else {

if (edfil == " ")edfil = imlog

imedit (input//"0", input//"_t0",
cursor=edfil, logfile="nirasym-imedit.log", display=yes, autodisplay=yes,
autosurface=no, aperture="circular", radius=starad, search=2., buffer=1.,
width=2., xorder=2, yorder=2, value=0., sigma=INDEF, angh=-33., angv=25.,
command="display $image 1 erase=$erase zs- fill=yes order=0 >& dev$null",
graphics="stdgraph", default="b", fixpix=no)

}

n1  =  1 + 2*dy2
n2  =  n1

nm1 = (n1 + 1)/2
nm2 = (n2 + 1)/2

#print(input, " x0=", x0, " y0=", y0, " NX=", n1, " NY=", n2)
#print(input, " XM=", nm1, " YM=", nm2, " FWHM=", fwhm, " SKY=", skyval)

       #imexam

#xm = nm1 - x0
#ym = nm2 - y0  

        delete ("asym.coo", ver-, >& "dev$null") 
	print(nm1,nm2) | cat > "asym.coo"
        #delete ("asym.shi", ver-, >& "dev$null") 
	#print("  0.0  0.0") | cat > "asym.shi"

         imdelete (input//"gau", ver-, >& "dev$null") 

mkgauss (input//"gau",n1, n2, nm1, nm2, 
1., 0., 0., fwhm, fwhm, 0., seed=347951)

         imdelete ("rg"//input//"_t0", ver-, >& "dev$null") 

if (align) {
imalign (input//"_t0", "asym.coo", input//"gau", 
shifts="", prefix="rg", shiftimages=yes,
trimimages=no, verbose=no, boxsize=bsize, bigbox=15, negative=no,
background=INDEF, lower=INDEF, upper=INDEF, niterate=3, tolerance=0,
interp_type="spline3", boundary_typ="reflect", constant=0., list="")

} else {
		imcopy(input//"_t0", "rg"//input//"_t0")
}

         imdelete (input//"0", ver-, >& "dev$null") 

if (gausig != 0.0) {
gauss ("rg"//input//"_t0", input//"0", gausig, ratio=1., theta=0., nsigma=4., bilinear=yes, boundary="nearest",
constant=0.)
} else {

	 imcopy ("rg"//input//"_t0", input//"0")
}

print(input, " XM=", nm1, " YM=", nm2, " FWHM=", fwhm)

	#xmag = 500.0/n1
	#print("xmag = ",xmag)
        display (input//"0", ifil, zs-, xmag=xmag, ymag=xmag, ztrans="log") 
	if (ifil > 1)print("Image Section to sum is ", sec)
	#print("Choose the cut-off value and Image Section to sum")
	print("Choose the cut-off value [-99 for repeting imedit]")
	imexam (logfile="nirasym-imexam.log", keeplog=yes)
	scan(bg)
	if (bg == -99) {
         	imdelete (input//"0", ver-, >& "dev$null") 
		imrename(input//"_t0", input//"0")
		goto otravez
	}
	#imexam
	if (ifil == 1){
	#print("Select the image section for summing [x1:x2,y1:y2]")
	#scan(sec)
	print("Select the box size for summing [half box size]")
	scan(dy) 
sec = "["//str(nm1-dy)//":"//str(nm1+dy)//","//str(nm2-dy)//":"//str(nm2+dy)//"]"
	}

         imdelete (input//"_0", ver-, >& "dev$null") 

imexpr.a = input//"0"
imexpr.z = bg
print("Replace all pixels in Image a with values < z by 0")
imexpr ("(a < z) ? 0 : a", input//"_0", ver-) 

if (repcen) {

	if (ifil == 1){
print("Select the size of the central square box (half side)")
scan(dx) 
	}

if (dx > 0){
repsec = "["//str(nm1-dx)//":"//str(nm1+dx)//","//str(nm2-dx)//":"//str(nm2+dx)//"]"
print("Replace section: ", repsec)
imreplace (input//"_0"//repsec, 0., imaginary=0., lower=INDEF, upper=INDEF)
}
}

         imdelete (input//"_180", ver-, >& "dev$null") 

rotate (input//"_0", input//"_180", 
180., xin=INDEF, yin=INDEF, xout=INDEF, yout=INDEF,
ncols=INDEF, nlines=INDEF, interpolant="linear", boundary="nearest",
constant=0., nxblock=256, nyblock=256)

         imdelete (input//"_n", ver-, >& "dev$null") 

imexpr.a = input//"_0"//sec
imexpr.b = input//"_180"//sec
print("Numerator: 0.5*(a-b)**2")
imexpr ("0.5*(a-b)**2", input//"_n", ver-) 

         imdelete (input//"_d", ver-, >& "dev$null") 

print("Denominator: a**2")
imexpr ("a**2", input//"_d", ver-)

	#xmag = 2.0*xmag
       display (input//"_n", 4, zs-, xmag=xmag, ymag=xmag, ztrans="log") 

#imstat (input//"_n", fields="image,npix,mean,stddev,min,max,midpt")
print("Sum of Numerator")
imexpr.a = input//"_n"
imexpr ("sum(a)", input//"_t1", ver-)
imcopy (input//"_t1[1:1,*]", input//"_t2", ver-)
#imexpr.a = input//"_t2"
#imexpr ("sum(a)", input//"_t3")
#imstat (input//"_t3", fields="image,npix,mean,stddev,min,max,midpt")

print("Sum of Denominator")
imexpr.a = input//"_d"
imexpr ("sum(a)", input//"_t4", ver-)
imcopy (input//"_t4[1:1,*]", input//"_t5", ver-)
#imexpr.a = input//"_t5"
#imexpr ("sum(a)", input//"_t6")

print("Sqrt(a/b)")
imexpr.a = input//"_t2"
imexpr.b = input//"_t5"
imexpr ("sqrt(sum(a)/sum(b))", input//"_t7", ver-)

imstat (input//"_t7", fields="image,npix,mean", 
lower=INDEF, upper=INDEF, binwidth=0.1, format=yes)

print (input//"0"//sec, " ", n1, " x ", n2, "SKY=", skyval,"Cut-off=",bg, "Gau_Sig=", gausig, "DX=", dx) | cat >> "nirasym.sum"

if  (ifil == 1) im1 = input//"_t7"
if (ifil > 1)im1 = im1//","//input//"_t7"

         imdelete ("rg"//input//"_t0", ver-, >& "dev$null") 
         imdelete (input//"gau", ver-, >& "dev$null") 

if (ifil < nfil)goto start

imstat (im1, fields="image,npix,mean", 
lower=INDEF, upper=INDEF, binwidth=0.1, format=yes) | cat >> "nirasym.sum"
#lower=INDEF, upper=INDEF, binwidth=0.1, format=yes) | cat >> beg//ugc//".sum"

         #imdelete (input//"_t*", ver-, >& "dev$null") 
for (i=1; i<=nfil; i +=1){
         imdelete (beg//ugc//filt[i]//"_t*", ver-, >& "dev$null") 
         if (del) imdelete (beg//ugc//filt[i]//"_*", ver-, >& "dev$null") 
}
print(" **** DONE **** ")

end

