procedure ringfig(galnam)

string  galnam = "arp143"      {prompt="Ring Gal Name (arp141|arp143|VIIZw466|Izw45 etc.)"}
int     frame  = 1             {prompt="frame to be written into"}
int     filnum = 3             {prompt="Continuum Filter [1-9]"}
bool    compan = no            {prompt="Cuts passing through the companion?"}

begin

	string  rim,haim,gal,haew,disect,ls1,ls2,hfil,filnam[9],tmp,cut_im,cut_vec,galdir
	string  cutfil,lab_ring,lab_comp
	real    texp[9],skyres[9],skyrms[9],tsec[9],airmass[9],flux5sig
	real	cont[6], flux[6], count[6], scale, rz1, rz2, hz1, hz2
        real    lr1, lr2, lr3, lr4, lr5, h1, h2, h3, h4, h5, h6,pix_as,adu_16,nsigma
        real    ext[9],alpha[9],beta[9], a1, a2, a3, a4, a5, a6, a7, a8, a9, ac[9]
	real    c25[8],pix2arc,ytop, ybot, ybyx, flux16[6], ksig
	real	umu_cut[299],bmu_cut[299],vmu_cut[299],rmu_cut[299],imu_cut[299]
	real	jmu_cut[299],hmu_cut[299],kmu_cut[299],ha16_cut[299]
	real	umag_cut[299],bmag_cut[299],vmag_cut[299],rmag_cut[299],imag_cut[299]
	real	jmag_cut[299],hmag_cut[299],kmag_cut[299],hamag_cut[299]
	real	x,x_cut[299],int_cut,datamin,bvmu_cut[299],brmu_cut[299],vimu_cut[299]
	real	cutx1,cutx2,cuty1,cuty2,width,x0,xl,xr,ylab,xlab
        int     i,i1,li1,runid[9],runno,m,j,i2,x1,x2,y1,y2
	int     inum
	bool    intruder
	struct  line

	gal = galnam
	inum = frame
	m = filnum
	intruder = compan
	list = gal//".in"

	wlpars.axis1_title=" "
	wlpars.axis2_title=" "
	wlpars.label_s=2.0
        wlpars.title_size=2.0
        wlpars.axis_ti=2.0

start:
	scale = 0.85
	if (gal == "arp148" || gal == "ngc5410") {scale=0.96}
        i1 = fscan(list, line)
        for (i=1; i <=9; i +=1){
        i1 = fscanf(list, "%s %g %g %g %g %d %s %g", ls1, lr1, lr2, lr3, lr4, li1, ls2, lr5)
                filnam[i] = ls1; skyres[i] = lr1; skyrms[i] = lr2/lr3; tsec[i] = lr3
                airmass[i] = lr4; runid[i] = li1; texp[i] = lr5
		skyres[i] = 0.0
                if (i == 9)hfil=ls2
        }

        list = "ext_coef.dat"
        i1 = fscan(list, a1,a2,a3,a4,a5,a6,a7,a8,a9)
        ext[1] = a1; ext[2] = a2; ext[3] = a3; ext[4] = a4; ext[5] = a5
        ext[6] = a6; ext[7] = a7; ext[8] = a8; ext[9] = a9

        list = "trans_coef.dat"
        while( fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#") {
        i1 = fscan(line, runno, a1,a2,a3,a4,a5,a6,a7,a8,h1,h2,h3,h4,h5,h6)
        ac[1] = a1; ac[2]=a2; ac[3]=a3; ac[4]=a4; ac[5]=a5; ac[6]=a6; ac[7]=a7; ac[8]=a8
        for (i=1; i <=8; i +=1){
                if (runid[i] == runno){alpha[i] = ac[i]}
        #print (runid[i], runno, alpha[i], "a"//str(i) )
        }
        if (runid[9] == runno && hfil == "H656") alpha[9] = h1
        if (runid[9] == runno && hfil == "H662") alpha[9] = h2
        if (runid[9] == runno && hfil == "H668") alpha[9] = h3
        if (runid[9] == runno && hfil == "H674") alpha[9] = h4
        if (runid[9] == runno && hfil == "H680") alpha[9] = h5
        if (runid[9] == runno && hfil == "H686") alpha[9] = h6
        i1 = fscan(list, runno, a1,a2,a3,a4,a5,a6,a7,a8,a9)
        ac[1] = a1; ac[2]=a2; ac[3]=a3; ac[4]=a4; ac[5]=a5; ac[6]=a6; ac[7]=a7; ac[8]=a8; ac[9]=a9
        for (i=1; i <=9; i +=1){
                if (runid[i] == runno){beta[i] = ac[i]}
        }
        }
        }
	pix_as = (scale)**2 ; pix2arc = 2.5*log10(pix_as)   #-0.35
	adu_16 = (pix_as*10**(-(0.4*ext[9]*airmass[9])))*(1.0E-16)/alpha[9]
	flux5sig = 5.0*skyrms[9]*alpha[9]/(pix_as*10**(-(0.4*ext[9]*airmass[9])))
	nsigma = adu_16/skyrms[9]
	#rz1 = skyres[m] - 1.0*skyrms[m]          #arp147
	rz1 = skyres[m] - 2.5*skyrms[m]           #iizw28
	#rz1 = skyres[m] - 3.0*skyrms[m]
	rz2 = skyres[m] + 5.0*32.0*skyrms[m]    
	#rz2 = skyres[m] + 5.0*24.0*skyrms[m]     #arp147, arp148
	#rz2 = skyres[m] + 5.0*16.0*skyrms[m]
	hz1 = skyres[9] - skyrms[9]
	#hz2 = skyres[9] + 5.0*16.0*skyrms[9]
	#hz2 = skyres[9] + 5.0*48.0*skyrms[9]      #iizw28
	hz2 = skyres[9] + 5.0*32.0*skyrms[9]   #arp147, Izw45, ngc5410
	delete (gal//".cont", ver-, >& "dev$null")
	print("Galaxy= ",gal, " FILTER=",m,  " RUNID=",runid[1],runid[2],runid[3],runid[4],runid[5],runid[6],runid[7],runid[8],runid[9]) | cat > gal//".cont"
	printf("Galaxy  adu_16 flux5sig RMS Nsigma \n") | cat >> gal//".cont"
	printf("%s %6.3f %12.3e %8.5f %6.3f \n", gal, adu_16, flux5sig, skyrms[9], nsigma) | cat >> gal//".cont"
	printf("Galaxy  adu_16 flux5sig RMS Nsigma \n")
	printf("%s %6.3f %12.3e %8.5f %6.3f \n", gal, adu_16, flux5sig, skyrms[9], nsigma)
	#cont[1] = 1; cont[2] = 2; cont[3] = 4; cont[4] = 8; cont[5] = 16; cont[6] = 32
	cont[1] = 1; cont[2] = 2; cont[3] = 4; cont[4] = 8; cont[5] = 16; cont[6] = 32
	#print("Galaxy", gal, "RMS=", skyrms[9], "F(5 sigma)=",flux5sig)
	#printf ("%3f %8f %10e \n", "0", skyrms[9], flux5sig) | cat >> gal//".cont"
	print("n*5sig  counts/pix  flux/as2 ", gal) | cat >> gal//".cont"
	ksig = 5.0
	if (gal == "arp142"){ksig = 3.0}
	if (gal == "arp145"){ksig = 2.0}
	if (gal == "arp147"){ksig = 7.0}
	if (gal == "arp291"){ksig = 3.0}
	if (gal == "viizw466"){ksig = 3.0}
        for (i=1; i <=6; i +=1){
		count[i] = ksig*skyrms[9]*cont[i] + skyres[9]
		#if (gal == "arp142"){count[i] = 3.0*skyrms[9]*cont[i] + skyres[9]}
		#if (gal == "arp145"){count[i] = 2.0*skyrms[9]*cont[i] + skyres[9]}
		flux[i] = (count[i]-skyres[9])*alpha[9]/(pix_as*10**(-(0.4*ext[9]*airmass[9])))
	printf ("%5f %8f %10e \n", cont[i], count[i], flux[i]) | cat >> gal//".cont"
        }
	for (i=1; i <=8; i +=1){
	c25[i] = 10**(-0.4*(25.+ext[i]*airmass[i]-alpha[i]-beta[i]*0.0-pix2arc)) + skyres[i]
	}
	flux16 = flux*1.0E+16
	printf("Halpha contour levels in units of E-16 cgs \n") | cat >> gal//".cont"
	printf("%6.3f %6.3f %6.3f %6.3f %6.3f %6.3f \n",flux16[1],flux16[2],flux16[3],flux16[4],flux16[5],flux16[6]) | cat >> gal//".cont"
	printf("Counts/sec/pix corresponding to mu=25 mag/arcsec2 in UBVRIJHK bands \n") | cat >> gal//".cont"
	printf("%6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f \n",c25[1],c25[2],c25[3],c25[4],c25[5],c25[6],c25[7],c25[8]) | cat >> gal//".cont"

	printf("Halpha contour levels in units of E-16 cgs \n")
	printf("%6.3f %6.3f %6.3f %6.3f %6.3f %6.3f \n",flux16[1],flux16[2],flux16[3],flux16[4],flux16[5],flux16[6])
	printf("Counts/sec/pix corresponding to mu=25 mag/arcsec2 in UBVRIJHK bands \n")
	printf("%6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f \n",c25[1],c25[2],c25[3],c25[4],c25[5],c25[6],c25[7],c25[8])
	
	lab_ring = "RING"; lab_comp = "COMP"

	if (gal == "arp141") {
	galdir = "arp141/"
	x1=96; x2=250; y1=71;  y2=270    #[96:250,71:270] }
	#x1=96; x2=250; y1=30;  y2=310    #[96:250,30:310] }
	#x1=116; x2=230; y1=71; y2=230    #[116:230,71:230]
	#cutx1=89; cuty1=156; cutx2=242; cuty2=67; width=5; x0=79.; xl = -29.5; xr=41.0
	#cutx1=116; cuty1=174; cutx2=232; cuty2=64; width=5; x0=68.; xl = -23; xr=18.0
	cutx1=126; cuty1=165; cutx2=217; cuty2=77; width=5; x0=54.; xl = -23; xr=18.0
	if (intruder) {cutx1=155; cuty1=65; cutx2=192; cuty2=259; width=3; x0=61.0; xl = -25.5; xr=15.5; ylab=25.2; xlab=65.0}
	} 
	else if (gal == "arp142") {
	galdir = "arp142/"
	x1=121; x2=280; y1=91; y2=300   #[121:280,91:300]
	#cutx1=137.; cuty1=142; cutx2=266; cuty2=169; width=3; x0=72.0; xl = -7.0; xr=10.0
	cutx1=202; cuty1=105; cutx2=202; cuty2=232; width=3; x0=65.0; xl = -20.0; xr=18.0
	lab_ring = "RING"; lab_comp = "G1"
	if (intruder) {cutx1=165; cuty1=112; cutx2=251; cuty2=290; width=3; x0=80.0; xl = -12.0; xr=8.0; ylab=24.8; xlab=-70.0}
	} 
 	else if (gal == "arp143") {
	galdir = "arp143/"
	x1=36; x2=245; y1=41; y2=250    #[36:245,41:250]
	#x1=36; x2=245; y1=41; y2=250    #[36:245,41:250]
	cutx1=50; cuty1=115; cutx2=205; cuty2=115; width=5; x0=80.; xl = -29.5; xr=41.0
	if (intruder) {cutx1=116; cuty1=61; cutx2=186; cuty2=246; width=3; x0=83.0; xl = -30.0; xr=30.0; ylab=24.8; xlab=60.0}
	#ybyx = 0.5*(250.-40.)/(245.-35.); ybot = 0.5*(1.0 - ybyx); ytop = ybot + ybyx	
	#x1=55; y1=170; x2=196; y2=71; width=5; x0=90.
	#x1=50; y1=180; x2=210; y2=68; width=5; x0=100.
	#x1=40; y1=125; x2=210; y2=125; width=5; x0=90.
	} 
	else if (gal == "arp144") {
	galdir = "arp144/" 
	x1=66; x2=225; y1=66; y2=225     #[66:225,66:225]
	cutx1=166.; cuty1=99; cutx2=176; cuty2=217; width=3; x0=68.2; xl = -12.0; xr=12.0
	if (intruder) {cutx1=101; cuty1=118; cutx2=199; cuty2=190; width=3; x0=105.0; xl = -14.0; xr=14.0; ylab=24.5; xlab=-60.0}
	} 
	else if (gal == "arp145") {
	galdir = "arp145/"
	x1=85; x2=250; y1=85; y2=250 #[85:250,85:250]
	cutx1=110.; cuty1=234; cutx2=249; cuty2=135; width=3; x0=85.0; xl = -28.0; xr=28.0
	#cutx1=108.; cuty1=232; cutx2=242; cuty2=132; width=5; x0=83.7; xl = -22.0; xr=22.0
	if (intruder) {cutx1=103; cuty1=134; cutx2=225; cuty2=225; width=3; x0=92.0; xl = -19.0; xr=19.0; ylab=25.5; xlab=-60.0}
	} 
	else if (gal == "arp147") {
	galdir = "arp147_new/" 
	x1=126; x2=225; y1=121; y2=220  #[126:225,121:220]
	cutx1=163.; cuty1=195; cutx2=211; cuty2=149; width=3; x0=33.2; xl = -11.2; xr=6.5
	if (intruder) {cutx1=153; cuty1=161; cutx2=202; cuty2=183; width=3; x0=35.5; xl = -8.0; xr=8.0; ylab=24.5; xlab=-25.0}
	} 
	else if (gal == "arp148") {
	galdir = "arp148/" 
	#x1=101; x2=200; y1=111; y2=210  #[101:200,111:210]
	x1=116; x2=185; y1=126; y2=195  #[101:200,111:210]
	cutx1=157; cuty1=122; cutx2=153; cuty2=191; width=3; x0=36.0; xl = -9.0; xr=8.0
	#cutx1=157; cuty1=122; cutx2=153; cuty2=191; width=3; x0=36.0; xl = -9.0; xr=8.0
	if (intruder) {cutx1=111; cuty1=157; cutx2=187; cuty2=157; width=3; x0=42.0; xl = -7.0; xr=8.0; ylab=24.5; xlab=-24.5}
	} 
	else if (gal == "arp291") {
	galdir = "arp291/" 
	x1=101; x2=230; y1=101; y2=230  #[101:230,101:230]
	cutx1=101.; cuty1=161; cutx2=230; cuty2=161; width=3; x0=68.0; xl = -30.0; xr=30.0
	if (intruder) {cutx1=136; cuty1=124; cutx2=222; cuty2=224; width=3; x0=83.0; xl = -17.0; xr=20.0; ylab=25.0; xlab=64.0}
	} 
        else if (gal == "iihz4") {
	galdir = "hz4/" 
	x1=101; x2=230; y1=101; y2=230  #[101:230,101:230]
	cutx1=132.; cuty1=176; cutx2=212; cuty2=176; width=3; x0=38.5; xl = -16.5; xr=16.5
	#cutx1=132.; cuty1=171; cutx2=212; cuty2=171; width=3; x0=36.0; xl = -15.0; xr=17.0
	#if (intruder) {cutx1=114; cuty1=98; cutx2=193; cuty2=200; width=3; x0=96.0; xl = -12.0; xr=12.0}
	if (intruder) {cutx1=136; cuty1=222; cutx2=202; cuty2=149; width=3; x0=60.0; xl = -12.0; xr=12.0; ylab=24.8; xlab=-40.0}
	}
	else if (gal == "izw45") {
	galdir = "izw45/" 
	x1=141; x2=220; y1=141; y2=230  #[141:220,141:230]
	cutx1=141.; cuty1=175; cutx2=215; cuty2=175; width=3; x0=37.0; xl = -14.0; xr=14.0
	#cutx1=179.; cuty1=154; cutx2=179; cuty2=200; width=3; x0=23.0; xl = -7.0; xr=7.0
	#if (intruder) {cutx1=181; cuty1=154; cutx2=189; cuty2=227; width=3; x0=28.0; xl = -11.0; xr=10.0; ylab=24.5; xlab=25.0}
	if (intruder) {cutx1=181; cuty1=154; cutx2=189; cuty2=227; width=3; x0=22.0; xl = -4.0; xr=6.0; ylab=24.5; xlab=30.0}
	}
        else if (gal == "iizw28") {
	galdir = "iizw28/" 
	#x1=184; x2=233; y1=143; y2=192  #[184:233,143:192]   only ring galaxy
	#x1=131; x2=290; y1=61; y2=220  #[131:290,61:220]   much larger area
	x1=161; x2=250; y1=131; y2=220  #[161:250,131:220]  intermediate area
	cutx1=188.; cuty1=167; cutx2=226; cuty2=167; width=3; x0=20.5; xl = -7.0; xr=7.0
	if (intruder) {cutx1=199; cuty1=156; cutx2=244; cuty2=217; width=3; x0=16.0; xl = -6.0; xr=5.0; ylab=24.0; xlab=41.0}
	#if (intruder) {cutx1=144; cuty1=94; cutx2=244; cuty2=217; width=3; x0=100.0; xl = -12.0; xr=12.0}
	} 
	else if (gal == "viizw466") {
	lab_ring = "G1"; lab_comp = "G2"
	galdir = "viizw466/" 
	x1=96; x2=205; y1=101; y2=210    #[96:205,101:210]
	cutx1=176.; cuty1=156; cutx2=176; cuty2=207; width=3; x0=25.5; xl = -13.0; xr=13.0   #vertical
	#cutx1=98.; cuty1=158; cutx2=200; cuty2=187; width=3; x0=79.5; xl = -13.0; xr=13.0     #G1 and ring
        #if (intruder) {cutx1=116; cuty1=103; cutx2=197; cuty2=206; width=3; x0=91.0; xl = -12.0; xr=12.0}
        if (intruder) {cutx1=113; cuty1=187; cutx2=135; cuty2=104; width=3; x0=42.5; xl = -20.0; xr=12.0; ylab=24.0; xlab=25.0}
	} 
	else if (gal == "ngc985") {
	galdir = "ngc985/" 
	x1=139; x2=238; y1=145; y2=244    #[139:238,145:244]
	cutx1=145; cuty1=197; cutx2=225; cuty2=197; width=3; x0=40.0; xl = -17.0; xr=17.0
	if (intruder) {cutx1=145; cuty1=197; cutx2=225; cuty2=197; width=3; x0=40.0; xl = -17.0; xr=17.0; ylab=24.0; xlab=25.0}
	} 
	else if (gal == "ngc2793") {
	galdir = "ngc2793/" 
	x1=31; x2=200; y1=21; y2=190    #[31:200,21:190]
	cutx1=35; cuty1=98; cutx2=158; cuty2=98; width=3; x0=49.0; xl = -19.0; xr=19.0
        if (intruder) {cutx1=40; cuty1=48; cutx2=197; cuty2=174; width=3; x0=55.0; xl = -14.0; xr=23.0; ylab=24.0; xlab=101.0}
	} 
	else if (gal == "ngc5410") {
	galdir = "ngc5410/" 
	x1=91; x2=240; y1=101; y2=270    #[91:240,101:270]
	cutx1=101; cuty1=159; cutx2=215; cuty2=159; width=3; x0=57.0; xl = -29.0; xr=29.0
        if (intruder) {cutx1=115; cuty1=264; cutx2=165; cuty2=102; width=3; x0=119.0; xl = -15.0; xr=14.0; ylab=24.0; xlab=-85.0}
        #if (intruder) {cutx1=165; cuty1=102; cutx2=115; cuty2=264; width=3; x0=95.0; xl = -12.0; xr=12.0}
	} else {
          print("Galaxy name ",gal," is wrong! Please reenter the correct name")
          scan (gal)
          if (gal != "no")goto start
        } 

	disect = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
        rim = galdir//filnam[m]//".fit"//disect
        haim = galdir//filnam[9]//".fit"//disect
	ybyx = 0.5*(y2-y1+1)/(x2-x1+1); ybot = 0.5*(1.0 - ybyx); ytop = ybot + ybyx	
	cutfil = galdir//gal 
	if (intruder) cutfil = galdir//gal//"c"

	wlpars.title=" "
	newcont.list = str(count[1])//","//str(count[3]) #//","//str(count[5]) #//","//str(count[4])//","//str(count[5])//","//str(count[6])
	#newcont.list = str(count[1])//","//str(count[2])//","//str(count[3])//","//str(count[4])//","//str(count[5])//","//str(count[6])
	displ.er=yes; displ.zs=no; displ.zr=no; displ.z1=hz1; displ.z2=hz2; displ.ztrans="log"
	#displ.er=yes; displ.zs=no; displ.zr=no; displ.z1=hz1; displ.z2=hz2; displ.ztrans="linear"
	wcslab.usewcs=no; wlpars.major_g=no; wlpars.minor_g=no; wlpars.dolabel=no
	disconlab.contcol="yellow"
	disconlab.bottom = ybot; disconlab.top= ytop
	disconlab.left=0.00; disconlab.right=0.50
disconlab (haim, frame=inum, cont-, limage=haim)
#disconlab (haim, frame=inum, cont-, limage=haim, left=0.25, right=0.75, bottom=0.50, top=1.00)

	displ.er=no; displ.z1=rz1; displ.z2=rz2
	disconlab.left=0.50; disconlab.right=1.00
disconlab (rim, frame=inum, cimage=haim, label+, limage=haim)
disconlab (rim, frame=inum, cimage=haim, label+, limage=haim)
#disconlab (rim, frame=inum, cimage=haim, label+, limage=haim, left=0.25, right=0.75, bottom=0.00, top=0.50)
#isoimap (rim, "arp143/ARP143Bbg", frame=1, minsma=79.0, maxsma=80, nl=2, full-)
#isoimap ARP143Rbg.fit[36:245,41:250] ARP143Bbg minsma=79.0 maxsma=80 nl=2 full-
#disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.81, bottom=0.52, top=0.92)
#}

	for (i=1; i <=9; i +=1){
	#delete ("cut.dat", ver-, >& "dev$null")
	cut_im = galdir//filnam[i]//".fit"
	cut_vec = galdir//filnam[i]//".dat"
	delete (cut_vec, ver-, >& "dev$null")
	if (filnam[i] != "null"){
pvector (cut_im, x1=cutx1, y1=cuty1, x2=cutx2, y2=cuty2, width=width, theta=INDEF, length=INDEF, vec_out=cut_vec)
	}
	}

	for (i=1; i <=9; i +=1){
	if (filnam[i] != "null"){
        list = galdir//filnam[i]//".dat"
	i2 = 0
        while( fscan(list, line) != EOF ) {
		i2 = i2 + 1
                i1 = fscan(line,x, int_cut)
		if (i==2) {x_cut[i2] = x}    #; int_cut[i2] = y
		datamin = 1.0e-15
	  int_cut = int_cut - skyres[i]
	  if (int_cut < datamin) {int_cut = datamin}
	  if (i==1) {umag_cut[i2] = -2.5*log10(int_cut) - ext[i]*airmass[i]}
	  if (i==2) {bmag_cut[i2] = -2.5*log10(int_cut) - ext[i]*airmass[i]}
	  if (i==3) {vmag_cut[i2] = -2.5*log10(int_cut) - ext[i]*airmass[i]}
	  if (i==4) {rmag_cut[i2] = -2.5*log10(int_cut) - ext[i]*airmass[i]}
	  if (i==5) {imag_cut[i2] = -2.5*log10(int_cut) - ext[i]*airmass[i]}
	  if (i==6) {jmag_cut[i2] = -2.5*log10(int_cut) - ext[i]*airmass[i]}
	  if (i==7) {hmag_cut[i2] = -2.5*log10(int_cut) - ext[i]*airmass[i]}
	  if (i==8) {kmag_cut[i2] = -2.5*log10(int_cut) - ext[i]*airmass[i]}
	  if (i==9) {hamag_cut[i2] = -2.5*log10(int_cut) - ext[i]*airmass[i]}
                }
	delete (galdir//filnam[i]//".dat", ver-, >& "dev$null")
	}
	}
	delete (cutfil//".cut", ver-, >& "dev$null")
	if (intruder) {
	printf("%7.3f %7.3f %7.3f %7.3f %7.3f %5s %5s \n",x0, xl, xr, ylab, xlab, lab_ring, lab_comp) | cat > cutfil//".cut"
	} else {
	printf("%7.3f %7.3f %7.3f \n",x0, xl, xr) | cat > cutfil//".cut"
	}
	printf("#x_pix  mu_B   mu_V   mu_R   mu_I   mu_J   mu_H   mu_K   mu_Ha   mu_bv \n")  | cat >> cutfil//".cut"
	#galdir//gal//".cut"
	for (j=1; j <=i2; j +=1){
	umu_cut[j] = 35.0; bmu_cut[j] = 35.0; vmu_cut[j] = 35.0; rmu_cut[j] = 35.0; imu_cut[j] = 35.0
	jmu_cut[j] = 35.0; hmu_cut[j] = 35.0; kmu_cut[j] = 35.0; ha16_cut[j] = 0.0
	if (filnam[1] != "null" && filnam[2] != "null")umu_cut[j] = umag_cut[j] + alpha[1] + beta[1]*(umag_cut[j] - bmag_cut[j]) + pix2arc
	if (filnam[2] != "null" && filnam[3] != "null")bmu_cut[j] = bmag_cut[j] + alpha[2] + beta[2]*(bmag_cut[j] - vmag_cut[j]) + pix2arc
	if (filnam[2] != "null" && filnam[3] != "null")vmu_cut[j] = vmag_cut[j] + alpha[3] + beta[3]*(bmag_cut[j] - vmag_cut[j]) + pix2arc
	if (filnam[3] != "null" && filnam[4] != "null")rmu_cut[j] = rmag_cut[j] + alpha[4] + beta[4]*(vmag_cut[j] - rmag_cut[j]) + pix2arc
	if (filnam[3] != "null" && filnam[5] != "null")imu_cut[j] = imag_cut[j] + alpha[5] + beta[5]*(vmag_cut[j] - imag_cut[j]) + pix2arc
	if (filnam[6] != "null")kmu_cut[j] = jmag_cut[j] + alpha[6] + pix2arc
	if (filnam[7] != "null")kmu_cut[j] = hmag_cut[j] + alpha[7] + pix2arc
	if (filnam[8] != "null")kmu_cut[j] = kmag_cut[j] + alpha[8] + pix2arc
	if (filnam[9] != "null")ha16_cut[j] = 1.0E+16*alpha[9]*(10**(-0.4*(hamag_cut[j])))
	if (filnam[2] != "null" && filnam[3] != "null")bvmu_cut[j] = bmu_cut[j] - vmu_cut[j] 
	if (filnam[2] != "null" && filnam[4] != "null")brmu_cut[j] = bmu_cut[j] - rmu_cut[j] 
	if (filnam[3] != "null" && filnam[5] != "null")vimu_cut[j] = vmu_cut[j] - imu_cut[j] 
	printf("%6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %7.4f %6.3f \n",x_cut[j], bmu_cut[j], vmu_cut[j], rmu_cut[j], imu_cut[j], jmu_cut[j], hmu_cut[j], kmu_cut[j], ha16_cut[j], bvmu_cut[j] ) | cat >> cutfil//".cut"   #galdir//gal//".cut"
	}
	#print(x_cut,bmu_cut) 

	displ.er=yes

print("Done")

end
