procedure ringprof (infile)

string  infile   = "arp143.in"                {prompt="U image (.ply.1,.tab)"}
string  imagdir  = "home$roberto/"            {prompt="Input file Directory"}
string  trafile  = "trans_coef.dat"           {prompt="Transformation coefficient file(trans_coef.dat)"}
string  extfile  = "ext_coef.dat"           {prompt="Extinction coefficient file(ext_coef.dat)"}
#int     npoly    = 0                          {prompt="Number of polygons"}
#string  calphas  = "22.88 23.49 22.45 20.15" {prompt="Zeropoints"}
#string  cbetas   = "-0.095 0.075 -0.408 0.0" {prompt="Color coefficients"}
#string  ocextin   = "0.45 0.20 0.11 0.07 0.03 0.07"     {prompt="UBVRIHa Extinction coefficients"}
#string  icextin   = "0.03 0.04 0.03"     {prompt="JHK Extinction coefficients"}
#string  run      = "feb"                    {prompt="Month of the run(feb/oct)"}
#bool    skip     = "no"            {prompt="Skip the aperture photometry part?"}

begin

	string  ifile,tfile,efile,tabfil[9],galnam[9],fitsdir,ls1,ls2,filebase,tmp,hfil
	string  galhii[9],tabhii[9]
	real 	skymed[9],skyrms[9],tsec[9],airmass[9],lr1, lr2, lr3, lr4, skyfrac
	real	sma, intensu, intensb, intensv, intensr, intensi, intensj 
	real	intensh, intensk, intensha 
	#real	intensu_err, intensb_err, intensv_err, intensr_err, intensi_err, intensj_err 
	#real	intensh_err, intensk_err, intensha_err 
        real    radminb[199],magu[199],magb[199],magv[199],magr[199],magi[199]
	real	magj[199],magh[199],magk[199],magha[199]
        real    mag0u[199],mag0b[199],mag0v[199],mag0r[199],mag0i[199],mag0j[199],mag0h[199],mag0k[199],mag0ha[199]
        real    mag00u[199],mag00b[199],mag00v[199],mag00r[199],mag00i[199],mag00j[199],mag00h[199],mag00k[199],mag00ha[199]
        real    colub[199],colbv[199],colbr[199],colvi[199],colvk[199],coljk[199],colhk[199],pix2arc
        real    mu0u[199],mu0b[199],mu0v[199],mu0r[199],mu0i[199],mu0j[199],mu0h[199],mu0k[199],mu0ha[199]
        real    mu00u[199],mu00b[199],mu00v[199],mu00r[199],mu00i[199],mu00j[199],mu00h[199],mu00k[199],mu00ha[199]
        real    mu_ub[199],mu_bv[199],mu_br[199],mu_vi[199],mu_vk[199],mu_jk[199],mu_hk[199]
	real	dmu[199],dmb[199],dmv[199],dmr[199],dmi[199],dmj[199],dmh[199],dmk[199]
	real	dmub[199],dmbv[199],dmbr[199],dmvi[199],dmvk[199],dmjk[199],dmhk[199],dmha[199]
        real    me0u[199],me0b[199],me0v[199],me0r[199],me0i[199],me0j[199],me0h[199],me0k[199],me0ha[199]
        real    me00u[199],me00b[199],me00v[199],me00r[199],me00i[199],me00j[199],me00h[199],me00k[199],me00ha[199]
        real    me_ub[199],me_bv[199],me_br[199],me_vi[199],me_vk[199],me_jk[199],me_hk[199]
	real	emu[199],emb[199],emv[199],emr[199],emi[199],emj[199],emh[199],emk[199]
	real	emub[199],embv[199],embr[199],emvi[199],emvk[199],emjk[199],emhk[199],emha[199]
	real	Fe_ha,eF_ha
	real	dIu[199],dIb[199],dIv[199],dIr[199],dIi[199],dIj[199],dIh[199],dIk[199],dIha[199]
	real	dIub[199],dIbv[199],dIbr[199],dIvi[199],dIvk[199],dIjk[199],dIhk[199]
	real	rad,apmag,area,sqN[199], h1, h2, h3, h4, h5, h6
	real    ext[9],alpha[9],beta[9], a1, a2, a3, a4, a5, a6, a7, a8, a9, ac[9]
	real    F_ha,dF_ha,F_ew,dF_ew,I_ha,dI_ha,I_ew,dI_ew
	real	dF_r,dI_r, K_ha,F_r_vega, Npix[199],count,sigma,datamin,gain
	int     i,j,i1,i2,i3,li1,runid[9],len,runno,jj,nap
	real	skyres[9], texp[9], lr5, sig1, sig2, sig3, flux, flux_cor, xcf
	real    siga1, siga2, siga3, sigb1, sigb2, sigb3, delmag,anupix[199]
	real	tfluxu,tfluxb,tfluxv,tfluxr,tfluxi,tfluxj,tfluxh,tfluxk,totpix,tfluxha
	bool    image[9]
        struct  line

	pix2arc = -0.35

	skyfrac = 0.001
	datamin = 1.0E-06
	gain = 5.0

	fitsdir = imagdir; ifile = infile; tfile = trafile; efile = extfile
	list = ifile
	len = strlen(ifile); filebase = substr(ifile, 1, len-3)
	#print(filebase)

	#galhii[1] = "N2793HIIU"; galhii[2] = "N2793HIIB"; galhii[3] = "N2793HIIV"
	#galhii[4] = "N2793HIIR"; galhii[5] = "N2793HIII"; galhii[6] = "N2793HIIJJ"
	#galhii[7] = "N2793HIIHH"; galhii[8] = "N2793HIIKK"; galhii[9] = "N2793HIIHa"
        i1 = fscan(list, line)
	for (i=1; i <=9; i +=1){
        i1 = fscanf(list, "%s %g %g %g %g %d %s %g", ls1, lr1, lr2, lr3, lr4, li1, ls2, lr5) 
		galnam[i] = ls1; skyres[i] = lr1; skyrms[i] = lr2/lr3; tsec[i] = lr3
		airmass[i] = lr4; runid[i] = li1; texp[i] = lr5 
		if (i == 9)hfil=ls2
  		tabfil[i] = fitsdir//galnam[i]
  		#tabhii[i] = fitsdir//galhii[i]
		#skymed[i] = skyres[i]    #Should be the original sky counts/sec; used in noise estimation
		skymed[i] = 0.0   #skyres[i]    #Should be the original sky counts/sec; used in noise estimation
					 #but the noise.cl uses the rms, instead of median to estimate noise.
		#skyres[i] = 0.0
	}
	skymed[6] = 150.0; skymed[7] = 300.0; skymed[8] = 900.0;

	list = efile
	i1 = fscan(list, a1,a2,a3,a4,a5,a6,a7,a8,a9)
        ext[1] = a1; ext[2] = a2; ext[3] = a3; ext[4] = a4; ext[5] = a5
        ext[6] = a6; ext[7] = a7; ext[8] = a8; ext[9] = a9

	list = tfile
        while( fscan(list, line) != EOF ) {
	tmp = substr (line, 1, 1)
	if (tmp != "#") {
	i1 = fscan(line, runno, a1,a2,a3,a4,a5,a6,a7,a8,h1,h2,h3,h4,h5,h6)
	ac[1] = a1; ac[2]=a2; ac[3]=a3; ac[4]=a4; ac[5]=a5; ac[6]=a6; ac[7]=a7; ac[8]=a8
	for (i=1; i <=8; i +=1){
		if (runid[i] == runno){alpha[i] = ac[i]}
	#print (runid[i], runno, alpha[i], "a"//str(i) )
	}
	if (runid[9] == runno && hfil == "H656") alpha[9] = h1
	if (runid[9] == runno && hfil == "H662") alpha[9] = h2
	if (runid[9] == runno && hfil == "H668") alpha[9] = h3
	if (runid[9] == runno && hfil == "H674") alpha[9] = h4
	if (runid[9] == runno && hfil == "H680") alpha[9] = h5
	if (runid[9] == runno && hfil == "H686") alpha[9] = h6
	i1 = fscan(list, runno, a1,a2,a3,a4,a5,a6,a7,a8,a9)
	ac[1] = a1; ac[2]=a2; ac[3]=a3; ac[4]=a4; ac[5]=a5; ac[6]=a6; ac[7]=a7; ac[8]=a8; ac[9]=a9
	for (i=1; i <=9; i +=1){
		if (runid[i] == runno){beta[i] = ac[i]}
	}

	}
	}

	for (i=1; i <=9; i +=1){
	   image[i] = no
	   if (galnam[i] != "null") image[i] = yes
  	   if (galnam[i] != "null") {
		delete(tabfil[i]//".mag", ver-, >& "dev$null")
    		txdump (tabfil[i]//".ply.1", "MINRAD MAG AREA FLUX",expr=yes) | cat > tabfil[i]//".mag"
		txdump (tabfil[i]//".fit.ply.1", "MINRAD MAG AREA FLUX",expr=yes) | wc | scan(nap)
    		txdump (tabfil[i]//".fit.ply.1", "MINRAD MAG AREA FLUX",expr=yes) | cat >> tabfil[i]//".mag"
    		#txdump (tabfil[i]//".fit.ply.1", "MINRAD MAG AREA FLUX",expr="ID=1") | cat >> tabfil[i]//".mag"
    		#txdump (tabhii[i]//".ply.1", "MINRAD MAG AREA FLUX",expr=yes) | cat > tabfil[i]//".mag"
  	   }
	}

	print("---------------------------------------------------------------")
	print("FIL         File         RMS     EXT  AIRMASS ID  Alpha    Beta")
	for (i=1; i <=9; i +=1){
	if (image[i]) {
	#if (galnam[i] != "null") {
		if (i < 9) {
		printf("%2d  %15s %9.4f %7.3f %7.3f %2d %7.3f %7.3f \n",i,galnam[i],skyrms[i],ext[i],airmass[i],runid[i],alpha[i], beta[i])
		} else {
		printf("%2d  %15s %9.4f %7.3f %7.3f %2d %9.4e %7.3f \n",i,galnam[i],skyrms[i],ext[i],airmass[i],runid[i],alpha[i], beta[i])
		}
		#printf("%2d  %15s %9.4f %7.3f %2d \n",i,galnam[i],skyrms[i],airmass[i],runid[i])
        	i1 = 0
        	list = tabfil[i]//".mag"
        	while( fscan(list, rad, apmag, area, flux) != EOF ) {
                	i1=i1+1
                	if (i == 2)radminb[i1] = rad
                	if (i == 2)sqN[i1] = sqrt(area)
                	if (i == 2)Npix[i1] = area
			flux_cor = flux-area*skyres[i]
			if (flux_cor < datamin) flux_cor = datamin
                	if (i == 1)magu[i1] = -2.5*log10(flux_cor)
                	if (i == 2)magb[i1] = -2.5*log10(flux_cor)
                	if (i == 3)magv[i1] = -2.5*log10(flux_cor)
                	if (i == 4)magr[i1] = -2.5*log10(flux_cor)
                	if (i == 5)magi[i1] = -2.5*log10(flux_cor)
                	if (i == 6)magj[i1] = -2.5*log10(flux_cor)
                	if (i == 7)magh[i1] = -2.5*log10(flux_cor)
                	if (i == 8)magk[i1] = -2.5*log10(flux_cor)
                	if (i == 9)magha[i1] = -2.5*log10(flux_cor)
        	}
        }
		delete(tabfil[i]//".mag", ver-, >& "dev$null")
	}
	print("Number of apertures = ",i1)
	print("Number of polygons= ",nap)

	
	delete(filebase//"_el.mag", ver-, >& "dev$null")
	delete(filebase//"_el.col", ver-, >& "dev$null")
	delete(filebase//"_ap.mag", ver-, >& "dev$null")
	delete(filebase//"_ap.col", ver-, >& "dev$null")
	delete(filebase//"_sb.mag", ver-, >& "dev$null")
	delete(filebase//"_sb.col", ver-, >& "dev$null")
	delete(filebase//"_ha.flu", ver-, >& "dev$null")
	if (galnam[9] != "null" && galnam[4] != "null") {
	printf("%1s %4s %5s %6s %7s %6s %12s  %6s %6s %6s %6s %7s %6s %7s %6s  %11s %6s %6s %6s %12s  %6s \n","#","Rad","B","db","B-V","dbv","F_Halpha","dF_Ha","EW_Ha","dEW","SMA","I_B","dIb","I_BV","dIbv","I_Ha","dI_Ha","I_EW","dEW","F_Halpha","dF_Ha")  | cat >> filebase//"_ha.flu"
	}
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n","#","Rad","U","du","B","db","V","dv","R","dr","I","di","J","dj","H","dh","K","dk","B-V","dbv")  | cat >> filebase//"_el.mag"
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n", "#","Rad","B","db","K","dk","U-B","dub","B-V","dbv","B-R","dbr","V-I","dvi","V-K","dvk","J-K","djk","H-K","dhk")  | cat >> filebase//"_el.col"
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n","#","Rad","U","du","B","db","V","dv","R","dr","I","di","J","dj","H","dh","K","dk","B-V","dbv")  | cat >> filebase//"_ap.mag"
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n", "#","Rad","B","db","K","dk","U-B","dub","B-V","dbv","B-R","dbr","V-I","dvi","V-K","dvk","J-K","djk","H-K","dhk")  | cat >> filebase//"_ap.col"
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n","#","SMA","U","du","B","db","V","dv","R","dr","I","di","J","dj","H","dh","K","dk","B-V","dbv")  | cat >> filebase//"_sb.mag"
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n", "#","SMA","B","db","K","dk","U-B","dub","B-V","dbv","B-R","dbr","V-I","dvi","V-K","dvk","J-K","djk","H-K","dhk")  | cat >> filebase//"_sb.col"

	unlearn("tprint")
		tprint.showrow=no; tprint.showhdr=no; tprint.showuni=no
		#tprint.columns="SMA INTENS INT_ERR TFLUX_E"
		tprint.columns="SMA INTENS TFLUX_E NPIX_E"
	unlearn ("noise")
		noise.fracsky = skyfrac
		noise.ccdgain = gain

	for (j=1; j <=i1; j +=1){
	# Calculate extinction-corrected aperture magnitudes
        if (galnam[1] != "null") mag0u[j] = magu[j] - ext[1]*airmass[1]
        if (galnam[2] != "null") mag0b[j] = magb[j] - ext[2]*airmass[2]
        if (galnam[3] != "null") mag0v[j] = magv[j] - ext[3]*airmass[3]
        if (galnam[4] != "null") mag0r[j] = magr[j] - ext[4]*airmass[4]
        if (galnam[5] != "null") mag0i[j] = magi[j] - ext[5]*airmass[5]
        if (galnam[6] != "null") mag0j[j] = magj[j] - ext[6]*airmass[6]
        if (galnam[7] != "null") mag0h[j] = magh[j] - ext[7]*airmass[7]
        if (galnam[8] != "null") mag0k[j] = magk[j] - ext[8]*airmass[8]
        if (galnam[9] != "null") mag0ha[j] = magha[j] - ext[9]*airmass[9]

	# Transform instrumental aperture magnitudes to standard
	mag00u[j] = 25.00; mag00b[j] = 25.00; mag00v[j] = 25.00; mag00r[j] = 25.00; mag00i[j] = 25.00 
	mag00j[j] = 25.00; mag00h[j] = 25.00; mag00k[j] = 25.00; 
        if (galnam[1] != "null" && galnam[2] != "null") mag00u[j] = mag0u[j] + alpha[1] + beta[1]*(mag0u[j] - mag0b[j])
        if (galnam[2] != "null") mag00b[j] = mag0b[j] + alpha[2] + beta[2]*(mag0b[j] - mag0v[j])
        if (galnam[3] != "null") mag00v[j] = mag0v[j] + alpha[3] + beta[3]*(mag0b[j] - mag0v[j])
        if (galnam[4] != "null") mag00r[j] = mag0r[j] + alpha[4] + beta[4]*(mag0v[j] - mag0r[j])
        if (galnam[5] != "null") mag00i[j] = mag0i[j] + alpha[5] + beta[5]*(mag0v[j] - mag0i[j])
        if (galnam[6] != "null") mag00j[j] = mag0j[j] + alpha[6]
        if (galnam[7] != "null") mag00h[j] = mag0h[j] + alpha[7]
        if (galnam[8] != "null") mag00k[j] = mag0k[j] + alpha[8]

	# Obtain useful colors from aperture magnitudes
	colub[j] = -5.00; colbv[j] =  -5.00; colbr[j] =  -5.00; colvi[j] =  -5.00 
	colvk[j] =  -5.00; coljk[j] =  -5.00; colhk[j] =  -5.00
        if (galnam[1] != "null" && galnam[2] != "null") colub[j] = mag00u[j] - mag00b[j]
        if (galnam[2] != "null" && galnam[3] != "null") colbv[j] = mag00b[j] - mag00v[j]
        if (galnam[2] != "null" && galnam[4] != "null") colbr[j] = mag00b[j] - mag00r[j]
        if (galnam[3] != "null" && galnam[5] != "null") colvi[j] = mag00v[j] - mag00i[j]
        if (galnam[3] != "null" && galnam[8] != "null") colvk[j] = mag00v[j] - mag00k[j]
        if (galnam[6] != "null" && galnam[8] != "null") coljk[j] = mag00j[j] - mag00k[j]
        if (galnam[7] != "null" && galnam[8] != "null") colhk[j] = mag00h[j] - mag00k[j]

	# Calculate errors on the aperture magnitudes
	dmu[j] = 35.00; dmb[j] = 35.00; dmv[j] = 35.00; dmr[j] = 35.00; dmi[j] = 35.00 
	dmj[j] = 35.00; dmh[j] = 35.00; dmk[j] = 35.00; 
	 dmub[j] = -5.00;  dmbv[j] =  -5.00;  dmbr[j] =  -5.00;  dmvi[j] =  -5.00 
	 dmvk[j] =  -5.00;  dmjk[j] =  -5.00;  dmhk[j] =  -5.00

	if (image[1]) noise(magu[j],skymed[1],skyrms[1],texp[1],Npix[j]) | scan(dmu[j], siga1, siga2, siga3)
	if (image[2]) noise(magb[j],skymed[2],skyrms[2],texp[2],Npix[j]) | scan(dmb[j], sigb1, sigb2, sigb3)
		if (image[1] && image[2])dmub[j] = 1.086*sqrt((siga1-sigb1)**2 + siga2**2 + siga3**2 + sigb2**2 + sigb3**2)
	if (image[4]) noise(magr[j],skymed[4],skyrms[4],texp[4],Npix[j]) | scan(dmr[j], siga1, siga2, siga3)
		if (image[2] && image[4])dmbr[j] = 1.086*sqrt((sigb1-siga1)**2 + sigb2**2 + sigb3**2 + siga2**2 + siga3**2)
	if (image[3]) noise(magv[j],skymed[3],skyrms[3],texp[3],Npix[j]) | scan(dmv[j], siga1, siga2, siga3)
		if (image[2] && image[3])dmbv[j] = 1.086*sqrt((sigb1-siga1)**2 + sigb2**2 + sigb3**2 + siga2**2 + siga3**2)
	if (image[5]) noise(magi[j],skymed[5],skyrms[5],texp[5],Npix[j]) | scan(dmi[j], sigb1, sigb2, sigb3)
		if (image[3] && image[5])dmvi[j] = 1.086*sqrt((sigb1-siga1)**2 + sigb2**2 + sigb3**2 + siga2**2 + siga3**2)
	if (image[6]) noise(magj[j],skymed[6],skyrms[6],texp[6],Npix[j]) | scan(dmj[j], siga1, siga2, siga3)
	if (image[7]) noise(magh[j],skymed[7],skyrms[7],texp[7],Npix[j]) | scan(dmh[j], siga1, siga2, siga3)
	if (image[8]) noise(magk[j],skymed[8],skyrms[8],texp[8],Npix[j]) | scan(dmk[j], siga1, siga2, siga3)
        if (image[3] && image[8] ) dmvk[j] =     sqrt(dmv[j]**2 + dmk[j]**2)
        if (image[6] && image[8] ) dmjk[j] =     sqrt(dmj[j]**2 + dmk[j]**2)
        if (image[7] && image[8] ) dmhk[j] =     sqrt(dmh[j]**2 + dmk[j]**2)
	#if (image[9]) noise(magha[j],skymed[9],skyrms[9],texp[9],Npix[j]) | scan(dmha[j], sig1, sig2, sig3)

	#}
	#for (j=1; j <=i1-1; j +=1){
	# Read the intensity profiles
	intensu = datamin; intensb = datamin; intensv = datamin; intensr = datamin
	intensi = datamin; intensj = datamin; intensh = datamin; intensk = datamin 
	tfluxu = datamin; tfluxb = datamin; tfluxv = datamin; tfluxr = datamin
	tfluxi = datamin; tfluxj = datamin; tfluxh = datamin; tfluxk = datamin 
	jj = j
	if (j > (i1-nap)) jj = i1 - nap
        if (galnam[1] != "null")tprint (tabfil[1],rows=jj) | scan(sma, intensu, tfluxu, totpix)
        if (galnam[2] != "null")tprint (tabfil[2],rows=jj) | scan(sma, intensb, tfluxb, totpix)
        if (galnam[3] != "null")tprint (tabfil[3],rows=jj) | scan(sma, intensv, tfluxv, totpix)
        if (galnam[4] != "null")tprint (tabfil[4],rows=jj) | scan(sma, intensr, tfluxr, totpix)
        if (galnam[5] != "null")tprint (tabfil[5],rows=jj) | scan(sma, intensi, tfluxi, totpix)
        if (galnam[6] != "null")tprint (tabfil[6],rows=jj) | scan(sma, intensj, tfluxj, totpix)
        if (galnam[7] != "null")tprint (tabfil[7],rows=jj) | scan(sma, intensh, tfluxh, totpix)
        if (galnam[8] != "null")tprint (tabfil[8],rows=jj) | scan(sma, intensk, tfluxk, totpix)
        if (galnam[9] != "null")tprint (tabfil[9],rows=jj) | scan(sma, intensha, tfluxha, totpix)
	anupix[j] = totpix
	#if (j == 1){anupix[j] = totpix}
	#if (j > 1) {anupix[j] = totpix - anupix[j-1]}

	#if (intensu < (skyres[1]+skyrms[1])) { intensu = skyres[1] + skyrms[1] + datamin }
	#if (intensb < (skyres[2]+skyrms[2])) { intensb = skyres[2] + skyrms[2] + datamin }
	#if (intensv < (skyres[3]+skyrms[3])) { intensv = skyres[3] + skyrms[3] + datamin }
	#if (intensr < (skyres[4]+skyrms[4])) { intensr = skyres[4] + skyrms[4] + datamin }
	#if (intensi < (skyres[5]+skyrms[5])) { intensi = skyres[5] + skyrms[5] + datamin }
	#if (intensj < (skyres[6]+skyrms[6])) { intensj = skyres[6] + skyrms[6] + datamin }
	#if (intensh < (skyres[7]+skyrms[7])) { intensh = skyres[7] + skyrms[7] + datamin }
	#if (intensk < (skyres[8]+skyrms[8])) { intensk = skyres[8] + skyrms[8] + datamin }
	#if (intensha< (skyres[9]+skyrms[9])) { intensha= skyres[9] + skyrms[9] + datamin }

	if (intensu < (skyres[1]+datamin  )) { intensu = skyres[1] + datamin }
	if (intensb < (skyres[2]+datamin  )) { intensb = skyres[2] + datamin }
	if (intensv < (skyres[3]+datamin  )) { intensv = skyres[3] + datamin }
	if (intensr < (skyres[4]+datamin  )) { intensr = skyres[4] + datamin }
	if (intensi < (skyres[5]+datamin  )) { intensi = skyres[5] + datamin }
	if (intensj < (skyres[6]+datamin  )) { intensj = skyres[6] + datamin }
	if (intensh < (skyres[7]+datamin  )) { intensh = skyres[7] + datamin }
	if (intensk < (skyres[8]+datamin  )) { intensk = skyres[8] + datamin }
	if (intensha< (skyres[9]+datamin  )) { intensha= skyres[9] + datamin }

	tfluxu = tfluxu-totpix*skyres[1]; if (tfluxu < datamin) tfluxu = datamin
	tfluxb = tfluxb-totpix*skyres[2]; if (tfluxb < datamin) tfluxb = datamin
	tfluxv = tfluxv-totpix*skyres[3]; if (tfluxv < datamin) tfluxv = datamin
	tfluxr = tfluxr-totpix*skyres[4]; if (tfluxr < datamin) tfluxr = datamin
	tfluxi = tfluxi-totpix*skyres[5]; if (tfluxi < datamin) tfluxi = datamin
	tfluxj = tfluxj-totpix*skyres[6]; if (tfluxj < datamin) tfluxj = datamin
	tfluxh = tfluxh-totpix*skyres[7]; if (tfluxh < datamin) tfluxh = datamin
	tfluxk = tfluxk-totpix*skyres[8]; if (tfluxk < datamin) tfluxk = datamin
	tfluxha= tfluxha-totpix*skyres[9]; if (tfluxha< datamin) tfluxha = datamin

	# Convert the elliptical aperture fluxes into mag
        if (galnam[1] != "null") me0u[j] = -2.5*log10(tfluxu) - ext[1]*airmass[1]
        if (galnam[2] != "null") me0b[j] = -2.5*log10(tfluxb) - ext[2]*airmass[2]
        if (galnam[3] != "null") me0v[j] = -2.5*log10(tfluxv) - ext[3]*airmass[3]
        if (galnam[4] != "null") me0r[j] = -2.5*log10(tfluxr) - ext[4]*airmass[4]
        if (galnam[5] != "null") me0i[j] = -2.5*log10(tfluxi) - ext[5]*airmass[5]
        if (galnam[6] != "null") me0j[j] = -2.5*log10(tfluxj) - ext[6]*airmass[6]
        if (galnam[7] != "null") me0h[j] = -2.5*log10(tfluxh) - ext[7]*airmass[7]
        if (galnam[8] != "null") me0k[j] = -2.5*log10(tfluxk) - ext[8]*airmass[8]
        if (galnam[9] != "null") me0ha[j] = -2.5*log10(tfluxha) - ext[9]*airmass[9]

	# Transform instrumental elliptical aperture magnitudes to standard
	me00u[j] = 35.00; me00b[j] = 35.00; me00v[j] = 35.00; me00r[j] = 35.00; me00i[j] = 35.00 
	me00j[j] = 35.00; me00h[j] = 35.00; me00k[j] = 35.00; 
        if (galnam[1] != "null" && galnam[2] != "null") me00u[j] = me0u[j] + alpha[1] + beta[1]*(me0u[j] - me0b[j])
        if (galnam[2] != "null") me00b[j] = me0b[j] + alpha[2] + beta[2]*(me0b[j] - me0v[j]) 
        if (galnam[3] != "null") me00v[j] = me0v[j] + alpha[3] + beta[3]*(me0b[j] - me0v[j]) 
        if (galnam[4] != "null") me00r[j] = me0r[j] + alpha[4] + beta[4]*(me0v[j] - me0r[j]) 
        if (galnam[5] != "null") me00i[j] = me0i[j] + alpha[5] + beta[5]*(me0v[j] - me0i[j]) 
        if (galnam[6] != "null") me00j[j] = me0j[j] + alpha[6] 
        if (galnam[7] != "null") me00h[j] = me0h[j] + alpha[7] 
        if (galnam[8] != "null") me00k[j] = me0k[j] + alpha[8] 

	# Obtain useful colors from elliptical aperture magnitudes
	me_ub[j] = -5.00; me_bv[j] =  -5.00; me_br[j] =  -5.00; me_vi[j] =  -5.00 
	me_vk[j] =  -5.00; me_jk[j] =  -5.00; me_hk[j] =  -5.00
        if (galnam[1] != "null" && galnam[2] != "null") me_ub[j] = me00u[j] - me00b[j]
        if (galnam[2] != "null" && galnam[3] != "null") me_bv[j] = me00b[j] - me00v[j]
        if (galnam[2] != "null" && galnam[4] != "null") me_br[j] = me00b[j] - me00r[j]
        if (galnam[3] != "null" && galnam[5] != "null") me_vi[j] = me00v[j] - me00i[j]
        if (galnam[3] != "null" && galnam[8] != "null") me_vk[j] = me00v[j] - me00k[j]
        if (galnam[6] != "null" && galnam[8] != "null") me_jk[j] = me00j[j] - me00k[j]
        if (galnam[7] != "null" && galnam[8] != "null") me_hk[j] = me00h[j] - me00k[j]
	
	# Calculate errors on the elliptical aperture magnitudes
	emu[j] = 35.00; emb[j] = 35.00; emv[j] = 35.00; emr[j] = 35.00; emi[j] = 35.00 
	emj[j] = 35.00; emh[j] = 35.00; emk[j] = 35.00; 
	 emub[j] = -5.00;  embv[j] =  -5.00;  embr[j] =  -5.00;  emvi[j] =  -5.00 
	 emvk[j] =  -5.00;  emjk[j] =  -5.00;  emhk[j] =  -5.00

	if (image[1]) noise(me0u[j],skymed[1],skyrms[1],texp[1],Npix[j]) | scan(emu[j], siga1, siga2, siga3)
	if (image[2]) noise(me0b[j],skymed[2],skyrms[2],texp[2],Npix[j]) | scan(emb[j], sigb1, sigb2, sigb3)
		if (image[1] && image[2])emub[j] = 1.086*sqrt((siga1-sigb1)**2 + siga2**2 + siga3**2 + sigb2**2 + sigb3**2)
	if (image[4]) noise(me0r[j],skymed[4],skyrms[4],texp[4],Npix[j]) | scan(emr[j], siga1, siga2, siga3)
		if (image[2] && image[4])embr[j] = 1.086*sqrt((sigb1-siga1)**2 + sigb2**2 + sigb3**2 + siga2**2 + siga3**2)
	if (image[3]) noise(me0v[j],skymed[3],skyrms[3],texp[3],Npix[j]) | scan(emv[j], siga1, siga2, siga3)
		if (image[2] && image[3])embv[j] = 1.086*sqrt((sigb1-siga1)**2 + sigb2**2 + sigb3**2 + siga2**2 + siga3**2)
	if (image[5]) noise(me0i[j],skymed[5],skyrms[5],texp[5],Npix[j]) | scan(emi[j], sigb1, sigb2, sigb3)
		if (image[3] && image[5])emvi[j] = 1.086*sqrt((sigb1-siga1)**2 + sigb2**2 + sigb3**2 + siga2**2 + siga3**2)
	if (image[6]) noise(me0j[j],skymed[6],skyrms[6],texp[6],Npix[j]) | scan(emj[j], siga1, siga2, siga3)
	if (image[7]) noise(me0h[j],skymed[7],skyrms[7],texp[7],Npix[j]) | scan(emh[j], siga1, siga2, siga3)
	if (image[8]) noise(me0k[j],skymed[8],skyrms[8],texp[8],Npix[j]) | scan(emk[j], siga1, siga2, siga3)
        if (image[3] && image[8] ) emvk[j] =     sqrt(emv[j]**2 + emk[j]**2)
        if (image[6] && image[8] ) emjk[j] =     sqrt(emj[j]**2 + emk[j]**2)
        if (image[7] && image[8] ) dmhk[j] =     sqrt(emh[j]**2 + emk[j]**2)

	# Convert the intensity profiles into surface brightness in mag
        if (galnam[1] != "null") mu0u[j] = -2.5*log10(intensu - skyres[1]) - ext[1]*airmass[1]
        if (galnam[2] != "null") mu0b[j] = -2.5*log10(intensb - skyres[2]) - ext[2]*airmass[2]
        if (galnam[3] != "null") mu0v[j] = -2.5*log10(intensv - skyres[3]) - ext[3]*airmass[3]
        if (galnam[4] != "null") mu0r[j] = -2.5*log10(intensr - skyres[4]) - ext[4]*airmass[4]
        if (galnam[5] != "null") mu0i[j] = -2.5*log10(intensi - skyres[5]) - ext[5]*airmass[5]
        if (galnam[6] != "null") mu0j[j] = -2.5*log10(intensj - skyres[6]) - ext[6]*airmass[6]
        if (galnam[7] != "null") mu0h[j] = -2.5*log10(intensh - skyres[7]) - ext[7]*airmass[7]
        if (galnam[8] != "null") mu0k[j] = -2.5*log10(intensk - skyres[8]) - ext[8]*airmass[8]
        if (galnam[9] != "null") mu0ha[j] = -2.5*log10(intensha - skyres[9]) - ext[9]*airmass[9]

	# Transform instrumental surface magnitudes to standard
	mu00u[j] = 35.00; mu00b[j] = 35.00; mu00v[j] = 35.00; mu00r[j] = 35.00; mu00i[j] = 35.00 
	mu00j[j] = 35.00; mu00h[j] = 35.00; mu00k[j] = 35.00; 
        if (galnam[1] != "null" && galnam[2] != "null") mu00u[j] = mu0u[j] + alpha[1] + beta[1]*(mu0u[j] - mu0b[j]) + pix2arc
        if (galnam[2] != "null") mu00b[j] = mu0b[j] + alpha[2] + beta[2]*(mu0b[j] - mu0v[j]) + pix2arc
        if (galnam[3] != "null") mu00v[j] = mu0v[j] + alpha[3] + beta[3]*(mu0b[j] - mu0v[j]) + pix2arc
        if (galnam[4] != "null") mu00r[j] = mu0r[j] + alpha[4] + beta[4]*(mu0v[j] - mu0r[j]) + pix2arc
        if (galnam[5] != "null") mu00i[j] = mu0i[j] + alpha[5] + beta[5]*(mu0v[j] - mu0i[j]) + pix2arc
        if (galnam[6] != "null") mu00j[j] = mu0j[j] + alpha[6] + pix2arc
        if (galnam[7] != "null") mu00h[j] = mu0h[j] + alpha[7] + pix2arc
        if (galnam[8] != "null") mu00k[j] = mu0k[j] + alpha[8] + pix2arc

	# Obtain useful colors from surface magnitudes
	mu_ub[j] = -5.00; mu_bv[j] =  -5.00; mu_br[j] =  -5.00; mu_vi[j] =  -5.00 
	mu_vk[j] =  -5.00; mu_jk[j] =  -5.00; mu_hk[j] =  -5.00
        if (galnam[1] != "null" && galnam[2] != "null") mu_ub[j] = mu00u[j] - mu00b[j]
        if (galnam[2] != "null" && galnam[3] != "null") mu_bv[j] = mu00b[j] - mu00v[j]
        if (galnam[2] != "null" && galnam[4] != "null") mu_br[j] = mu00b[j] - mu00r[j]
        if (galnam[3] != "null" && galnam[5] != "null") mu_vi[j] = mu00v[j] - mu00i[j]
        if (galnam[3] != "null" && galnam[8] != "null") mu_vk[j] = mu00v[j] - mu00k[j]
        if (galnam[6] != "null" && galnam[8] != "null") mu_jk[j] = mu00j[j] - mu00k[j]
        if (galnam[7] != "null" && galnam[8] != "null") mu_hk[j] = mu00h[j] - mu00k[j]

	# Calculate errors on the surface magnitudes
	dIu[j] = 35.00; dIb[j] = 35.00; dIv[j] = 35.00; dIr[j] = 35.00; dIi[j] = 35.00 
	dIj[j] = 35.00; dIh[j] = 35.00; dIk[j] = 35.00; 
	 dIub[j] = -5.00;  dIbv[j] =  -5.00;  dIbr[j] =  -5.00;  dIvi[j] =  -5.00 
	 dIvk[j] =  -5.00;  dIjk[j] =  -5.00;  dIhk[j] =  -5.00
	#print(sma, totpix, anupix[j]) | cat >> "temp111.dat"
	#totpix = anupix[j]
	if (j == 1){totpix = anupix[j]} else {totpix = anupix[j] - anupix[j-1]}
	if (totpix == 0) totpix = 1.0
	delmag = -2.5*log10(totpix)
	mu0u[j] = mu0u[j] + delmag; mu0b[j] = mu0b[j] + delmag; mu0v[j] = mu0v[j] + delmag
	mu0r[j] = mu0r[j] + delmag; mu0i[j] = mu0i[j] + delmag; mu0j[j] = mu0j[j] + delmag
	mu0h[j] = mu0h[j] + delmag; mu0k[j] = mu0k[j] + delmag   #; mu0v[j] = mu0v[j] + delmag
	if (image[1]) noise(mu0u[j],skymed[1],skyrms[1],texp[1],totpix) | scan(dIu[j], siga1, siga2, siga3)
	if (image[2]) noise(mu0b[j],skymed[2],skyrms[2],texp[2],totpix) | scan(dIb[j], sigb1, sigb2, sigb3)
		if (image[1] && image[2])dIub[j] = 1.086*sqrt((siga1-sigb1)**2 + siga2**2 + siga3**2 + sigb2**2 + sigb3**2)
	if (image[4]) noise(mu0r[j],skymed[4],skyrms[4],texp[4],totpix) | scan(dIr[j], siga1, siga2, siga3)
		if (image[2] && image[4])dIbr[j] = 1.086*sqrt((sigb1-siga1)**2 + sigb2**2 + sigb3**2 + siga2**2 + siga3**2)
	if (image[3]) noise(mu0v[j],skymed[3],skyrms[3],texp[3],totpix) | scan(dIv[j], siga1, siga2, siga3)
                if (image[2] && image[3])dIbv[j] = 1.086*sqrt((sigb1-siga1)**2 + sigb2**2 + sigb3**2 + siga2**2 + siga3**2)
	if (image[5]) noise(mu0i[j],skymed[5],skyrms[5],texp[5],totpix) | scan(dIi[j], sigb1, sigb2, sigb3)
                if (image[3] && image[5])dIvi[j] = 1.086*sqrt((sigb1-siga1)**2 + sigb2**2 + sigb3**2 + siga2**2 + siga3**2)
	if (image[6]) noise(mu0j[j],skymed[6],skyrms[6],texp[6],totpix) | scan(dIj[j], sig1, sig2, sig3)
	if (image[7]) noise(mu0h[j],skymed[7],skyrms[7],texp[7],totpix) | scan(dIh[j], sig1, sig2, sig3)
	if (image[8]) noise(mu0k[j],skymed[8],skyrms[8],texp[8],totpix) | scan(dIk[j], sig1, sig2, sig3)
        if (image[3] && image[8] ) dIvk[j] =     sqrt(dIv[j]**2 + dIk[j]**2)
        if (image[6] && image[8] ) dIjk[j] =     sqrt(dIj[j]**2 + dIk[j]**2)
        if (image[7] && image[8] ) dIhk[j] =     sqrt(dIh[j]**2 + dIk[j]**2)
	#print(j, sma, totpix, anupix[j], dIj[j], dIh[j], dIk[j], sig1, sig2, sig3) | cat >> "temp111.dat"

	#K_ha = 1.0E-15
	K_ha = alpha[9]
	F_r_vega = 1.76E-09
	if (galnam[9] != "null" && galnam[4] != "null") {
          	F_ha = K_ha*(10**(-0.4*(magha[j] - ext[9]*airmass[9])))
          	F_ew = F_ha/(F_r_vega*10**(-0.4*(mag00r[j])))
                Fe_ha = K_ha*10**(-0.4*me0ha[j]) 
          	#Fe_ew = Ie_ha/(F_r_vega*10**(-0.4*(me00r[j])))
          	#tprint (tabfil[9],rows=j) | scan(sma, intensha, intensha_err)
		#if (intensha < (skyres[9]+skyrms[9]) ) { intensha = skyres[9]+skyrms[9]+datamin }
		#skyrms[4] = intensr_err
		#skyrms[9] = intensha_err
          	I_ha = K_ha*10**(-0.4*(mu0ha[j]+ pix2arc))   
		#(intensha-skyres[9])*10**(0.4*ext[9]*airmass[9] - pix2arc)   #Note added on 13/03/2006
			#The equation for I_ha in the old version is wrong: "pix2arc" also should have been multiplied by 0.4!
          	#I_ha = K_ha*(intensha-skyres[9])*10**(0.4*ext[9]*airmass[9] - pix2arc)
          	I_ew = I_ha/(F_r_vega*10**(-0.4*(mu00r[j])))
		#noise(magha[j],skymed[9],skyrms[9],texp[9],Npix[j]) | scan(dmha[j], sig1, sig2, sig3)
        	#mu0ha[j] = -2.5*log10(intensha - skyres[9]) - ext[9]*airmass[9]
        	#me0ha[j] = -2.5*log10(tfluxha - skyres[9]) - ext[9]*airmass[9]
		noise(magha[j],skymed[9],skyrms[9],texp[9],Npix[j]) | scan(dmha[j], sig1, sig2, sig3)
		noise(me0ha[j],skymed[9],skyrms[9],texp[9],Npix[j]) | scan(emha[j], sig1, sig2, sig3)
		mu0ha[j] = mu0ha[j] + delmag
		noise(mu0ha[j],skymed[9],skyrms[9],texp[9],totpix) | scan(dIha[j], sig1, sig2, sig3)
		dF_ha = dmha[j]/1.086; dF_r = dmr[j]/1.086; dI_ha = dIha[j]/1.086; dI_r = dIr[j]/1.086
         	dF_ew = F_ew*(dF_ha + dF_r); dI_ew = I_ew*(dI_ha + dI_r)
		if (dIha[j] == 0.0) {I_ew = 0.0; dI_ew = 0.0}
		eF_ha = emha[j]/1.086

	printf("%6.1f %7.3f %6.3f %7.3f %6.3f %11.4e %6.3f %6.1f %6.2f %6.1f %7.3f %6.3f %7.3f %6.3f %11.4e %6.3f %6.1f %6.2f %11.4e %6.3f \n",radminb[j],mag00b[j],dmb[j],colbv[j],dmbv[j],F_ha,dF_ha,F_ew,dF_ew,sma,mu00b[j],dIb[j],mu_bv[j],dIbv[j],I_ha,dI_ha,I_ew,dI_ew,Fe_ha,eF_ha)  | cat >> filebase//"_ha.flu"
		printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", radminb[j], mag00u[j],dmu[j],mag00b[j],dmb[j],mag00v[j],dmv[j],mag00r[j],dmr[j],mag00i[j],dmi[j],mag00j[j],dmj[j],mag00h[j],dmh[j], mag00k[j],dmk[j],colbv[j],dmbv[j])  | cat >> filebase//"_ap.mag"
	printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", radminb[j], mag00b[j],dmb[j],mag00k[j],dmk[j],colub[j],dmub[j],colbv[j],dmbv[j],colbr[j],dmbr[j],colvi[j],dmvi[j],colvk[j],dmvk[j],coljk[j],dmjk[j],colhk[j],dmhk[j])  | cat >> filebase//"_ap.col"
			}
if (j <= (i1-nap)){
		printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", radminb[j], me00u[j],emu[j],me00b[j],emb[j],me00v[j],emv[j],me00r[j],emr[j],me00i[j],emi[j],me00j[j],emj[j],me00h[j],emh[j], me00k[j],emk[j],me_bv[j],embv[j])  | cat >> filebase//"_el.mag"
	printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", radminb[j], me00b[j],emb[j],me00k[j],emk[j],me_ub[j],emub[j],me_bv[j],embv[j],me_br[j],embr[j],me_vi[j],emvi[j],me_vk[j],emvk[j],me_jk[j],emjk[j],me_hk[j],emhk[j])  | cat >> filebase//"_el.col"
	printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", sma, mu00u[j],dIu[j],mu00b[j],dIb[j],mu00v[j],dIv[j],mu00r[j],dIr[j],mu00i[j],dIi[j],mu00j[j],dIj[j],mu00h[j],dIh[j], mu00k[j],dIk[j],mu_bv[j],dIbv[j])  | cat >> filebase//"_sb.mag"
	printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", sma, mu00b[j],dIb[j],mu00k[j],dIk[j],mu_ub[j],dIub[j],mu_bv[j],dIbv[j],mu_br[j],dIbr[j],mu_vi[j],dIvi[j],mu_vk[j],dIvk[j],mu_jk[j],dIjk[j],mu_hk[j],dIhk[j])  | cat >> filebase//"_sb.col"
	}
	}


print ("DONE")

end
