procedure sky_stat(galnam)

string  galnam = "arp143"      {prompt="Ring Gal Name (arp141|arp143|VIIZw466|Izw45 etc.)"}
int     nsky     = 5           {prompt="Number of sky positions"}
int     boxwid   = 21          {prompt="XY width of sky box"}
real    fracsiz  = 1.5         {prompt="Fractional size to display wrt the good image"}

#string  imagdir  = "home$roberto/" {prompt="Image Directory"}

begin

        #string  imfile[4],ifile[4],fitsdir,skyreg,gal
        #real    obstime[4], ymean[4], yrms[4], ymed[4]
        string  imfile[9],skyreg,regfil,imfil[9]
        real    ymean[9], yrms[9], ymed[9], frac, yrms_old[9]
        int     xb1,xb2,yb1,yb2,x1,x2,y1,y2,x,y,ns,nwid,dx,x0,nxywid
        string  gal,ls1,ls2,filnam[9],disect,galdir,filt[9],ans
        real    lr1, lr2, lr3, lr4, lr5, h1, h2, h3, h4, h5, h6, lr6, lr7, lr8
        real    texp[9],skyres[9],skyrms[9],tsec[9],airmass[9]
        int     i,i1,li1,runid[9],nx,ny,nx_disp

        gal = galnam
        #fitsdir = imagdir
	ns      = nsky
	nwid    = boxwid/2
	frac    = fracsiz


start:
        if (gal == "arp141")        { galdir = "arp141/";   x1=96; x2=250; y1=71;  y2=270} #[96:250,71:270] } 
        else if (gal == "arp142")   { galdir = "arp142/";   x1=121; x2=280; y1=91;  y2=300} #[121:280,91:300] } 
        else if (gal == "arp143")   { galdir = "arp143/";   x1=36;  x2=245; y1=41;  y2=250} #[36:245,41:250]  }
        else if (gal == "arp144")   { galdir = "arp144/";   x1=66;  x2=225; y1=66;  y2=225} #[66:225,66:225]  }
        else if (gal == "arp145")   { galdir = "arp145/";   x1=85;  x2=250; y1=85;  y2=250} #[85:250,85:250]  }
        else if (gal == "arp147")   { galdir = "arp147_new/";   x1=126; x2=225; y1=121; y2=220} #[126:225,121:220]}
        else if (gal == "arp148")   { galdir = "arp148/";   x1=101; x2=200; y1=111; y2=210} #[101:200,111:210]} 
        else if (gal == "arp291")   { galdir = "arp291/";   x1=101; x2=230; y1=101; y2=230} #[101:230,101:230]} 
        else if (gal == "iihz4")    { galdir = "hz4/";      x1=101; x2=230; y1=101; y2=230} #[101:230,101:230]}
        else if (gal == "izw45")    { galdir = "izw45/";    x1=141; x2=220; y1=141; y2=230} #[141:220,141:230]}
        else if (gal == "iizw28")   { galdir = "iizw28/";   x1=161; x2=250; y1=131; y2=220} #[161:250,131:220]}
        else if (gal == "viizw466") { galdir = "viizw466/"; x1=96;  x2=205; y1=101; y2=210} #[96:205,101:210] }
        else if (gal == "ngc985")   { galdir = "ngc985/";   x1=139; x2=238; y1=145; y2=244} #[139:238,145:244]} 
        else if (gal == "ngc2793")  { galdir = "ngc2793/";  x1=31;  x2=200; y1=21;  y2=190} #[31:200,21:190]  } 
        else if (gal == "ngc5410")  { galdir = "ngc5410/";  x1=91;  x2=240; y1=101; y2=270} #[91:240,101:270] } 
        else {
          print("Galaxy name ",gal," is wrong! Please reenter the correct name")
          scan (gal)
          if (gal != "no")goto start
        }

        #list = galdir//gal//".in"
        list = gal//".in"

        i1 = fscan(list, line)
        for (i=1; i <=9; i +=1){
        i1 = fscanf(list, "%s %g %g %g %g %d %s %g", ls1, lr1, lr2, lr3, lr4, li1, ls2, lr5)
                imfile[i] = ls1//".fit"; skyres[i] = lr1; skyrms[i] = lr2/lr3; tsec[i] = lr3
                airmass[i] = lr4; runid[i] = li1; texp[i] = lr5; filt[i] = ls2
                imfil[i] = ls1
                #skyres[i] = 0.0; imfil[i] = ls1
        }

        imgets (galdir//imfile[2], "i_naxis1"); nx = int(imgets.value)
        imgets (galdir//imfile[2], "i_naxis2"); ny = int(imgets.value)
	dx = x2 - x1 + 1; x0 = x1 + dx/2; x1 = x0 - frac*dx/2; x2 = x0 + frac*dx/2
	dx = y2 - y1 + 1; x0 = y1 + dx/2; y1 = x0 - frac*dx/2; y2 = x0 + frac*dx/2
        disect = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
	#nx_disp = int(frac*dx)
	if (x1 < 1 || x2 > nx || y1 < 1 || y2 > ny ) {disect = "[*,*]" }
	#if (nx_disp > nx ) {disect = "[*,*]" }

#for (i=2; i <=9; i +=1){
	i1 = i-1
	#if (imfile[9] != "null.fit") {display (galdir//imfile[9]//disect, 4)}
	if (imfile[8] != "null.fit") {display (galdir//imfile[8]//disect, 2)}
	#if (imfile[6] != "null.fit") {display (galdir//imfile[6]//disect, 2)}
	if (imfile[2] != "null.fit") {display (galdir//imfile[2]//disect, 1)}
	#display (galdir//imfile[2], 1)
#}

	nxywid = 2*nwid + 1
        delete(gal//"_skymed.log", ver-, >& "dev$null")
        delete(gal//"_skyrms.log", ver-, >& "dev$null")
	print (ns, " ",nxywid, " 9  ",gal) | cat > gal//"_skymed.log"
	print (ns, " ",nxywid, " 9 ",gal) | cat > gal//"_skyrms.log"
  print ("**** select ",ns," regions for measuring sky and hit spacebar")

        regfil = galdir//gal//"_sky_box.reg"
        delete(regfil, ver-, >& "dev$null")
        print ("# Region file format: DS9 version 4.0", > regfil)
        print ("# Filename: ",galdir//imfile[2]//".fits", >> regfil)
        printf ("global color=green font=\"helvetica 10 normal\" select=1 highlite=1 edit=1 move=1 delete=1 include=1 fixed=0 source \nphysical \n", >> regfil)

for (j=1; j <=ns; j +=1){
next_sky:

  = fscan (imcur, x, y)

  xb1=x-nwid
  yb1=y-nwid
  xb2=x+nwid
  yb2=y+nwid
  skyreg = "["//str(xb1)//":"//str(xb2)//","//str(yb1)//":"//str(yb2)//"]"
  #print(skyreg) 
                printf ("box(%d,%d,%d,%d)\n",x,y,nxywid,nxywid,  >> regfil)

for (i=2; i <=9; i +=1){
	if (j > 1) {yrms_old[i] = yrms[i] 
		} 
	if (imfile[i] != "null.fit") {	
  imstat (galdir//imfile[i]//skyreg, fields="mean,stddev,midpt", format- ) | scan (ymean[i], yrms[i], ymed[i])
	  #keypar (imfile[i], "EXPTIME")
	  #obstime[i] = real(keypar.value)
  #printf ("%8.1f %10.3f %8.3f %10.3f %c \n", obstime[i], ymean[i], yrms[i], ymed[i], ifile[i])
  printf ("%d %10.3f %8.3f %10.3f %c \n", j, ymean[i], yrms[i], ymed[i], imfile[i])
		if (j > 1 && yrms[i] > 2.0*yrms_old[i]) 
                      {printf ("The region not good, select new sky Region \n"); goto next_sky}
}
}

        #ans = "yes"
	#printf ("Is the sky region ok? [yes,no] ")
        #    scan (ans)
        #    if (ans=="no") { goto next_sky }
	
  printf ("%3d %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %c \n", j,ymed[2],ymed[3],ymed[4],ymed[5],ymed[6],ymed[7],ymed[8],ymed[9],skyreg) | cat >> gal//"_skymed.log"
  printf ("%3d %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %c \n", j,yrms[2],yrms[3],yrms[4],yrms[5],yrms[6],yrms[7],yrms[8],yrms[9],skyreg) | cat >> gal//"_skyrms.log"

}
	
        delete("stat_ring.in", ver-, >& "dev$null")
	print (gal//"_skyrms.log") | cat >> "stat_ring.in"
	print (gal//"_skymed.log") | cat >> "stat_ring.in"

	!stat_ring.out

        list = "fort.44"

        #i1 = fscan(list, line)
        for (i=1; i <=4; i +=1){
        i1 = fscan(list, lr1, lr2, lr3, lr4, lr5, lr6, lr7, lr8)
		if (i == 1) {
		skyrms[2] = lr1; skyrms[3] = lr2; skyrms[4] = lr3; skyrms[5] = lr4 
		skyrms[6] = lr5; skyrms[7] = lr6; skyrms[8] = lr7; skyrms[9] = lr8
		}
		#if (i == 4) {
		#skyres[2] = lr1; skyres[3] = lr2; skyres[4] = lr3; skyres[5] = lr4 
		#skyres[6] = lr5; skyres[7] = lr6; skyres[8] = lr7; skyres[9] = lr8
		#}
		}
        delete(gal//"_new.in", ver-, >& "dev$null")
	print(line) | cat >> gal//"_new.in"
        for (i=1; i <=9; i +=1){
		printf("%16c %10.5f %10.5f %10.5f %10.5f %2d %8s %4g \n", imfil[i], skyres[i], skyrms[i], tsec[i], airmass[i], runid[i], filt[i], texp[i]) | cat >> gal//"_new.in"
       	}

	

print("Done")


end
