procedure	sdss_mag_flux(photfil)

string  photfil    = "J140229.58+541655.5_sdss.phot"     {prompt="File name containing SDSS Photometry"}
#string  dirstar    = "segue_spectra_stars/"     {prompt="Directory name containing SDSS spectral fits"}


begin
	string	magfil, tmp
	real	clight, fv0, lam, mag, flux, norm_flux, fwhm
	int	i1, i2
        struct  line

	magfil = photfil   #"J140229.58+541655.5_sdss.phot"
	#magfil = "J140231.12+541403.9_sdss.phot"
	clight = 2.9979E+10
	fv0 = 3631.0E-23       #3631 Jy  Vega V-band flux density
	norm_flux = 1.0E-17    #erg/s/cm2/Ang
	fwhm = 18.0
	
	i1 = 0
        list = magfil
        while( fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#") {
          i1=i1+1
	  i2 = fscanf(line, "%g  %g ", lam, mag)
	  flux = (clight*1.0E+08/lam**2)*fv0*10**(-(0.4*mag))/norm_flux
	  print (lam, mag, flux)
                        }
                }

end

