procedure apinputs(filein)

string	filein = "apinputs.dat"		{prompt="Input datafile"}
string	image  = "imname"		{prompt="The image name"}
string	dbase  = "database/"		{prompt="Directory to store apall database file"}
real   	ypix   = 1300.0			{prompt="Y pixel for the spatial profile"}

begin
	string	infil, cdum, bg_func, bg_samp1,  bg_samp2, c1 
	string	apfile, imname, datadir
	real	xcen, llim, ulim, ycut, xmin, xmax, bg1, bg2
	int	ncoef, apno, bg_ord, i1, i2
        struct  line, date

	infil = filein; imname = image; datadir = dbase
	apfile = datadir//"ap"//imname
	ycut = ypix; xmin = 100.0; xmax = 100.0

	#fields (infil, "1-2") | grep "curve" | scan(cdum, ncoef)
	#fields (infil, 1, lines=2//"-"//str(ncoef))

	delete (apfile, ver-, >& "dev$null")
	delete ("tmp_table", ver-, >& "dev$null")
	list = infil
	c1 = " "
        while( fscan(list,line) != EOF && c1 != "#") {
        c1 = substr(line,1,1)
	if (c1 != "#") {print(line, >> "tmp_table")}
	}

        while( fscan(list,line) != EOF ) {
	i2 = fscan(line, apno, xcen, llim, ulim, bg_func, bg_ord,  bg_samp1,  bg_samp2)
	#print (apno, xcen, llim, ulim, bg_func, " ",bg_ord, " ", bg_samp1, " ", bg_samp2)
	#len = strlen(bg_samp1)
	#i1 = stridx(":", bg_samp1) - 1
	bg1 = real(substr(bg_samp1, 1, stridx(":", bg_samp1)-1)) - xcen
	bg2 = real(substr(bg_samp1, stridx(":", bg_samp1)+1, strlen(bg_samp1))) - xcen
	bg_samp1 = str(bg1)//":"//str(bg2)
	bg1 = real(substr(bg_samp2, 1, stridx(":", bg_samp2)-1)) - xcen
	bg2 = real(substr(bg_samp2, stridx(":", bg_samp2)+1, strlen(bg_samp2))) - xcen
	bg_samp2 = str(bg1)//":"//str(bg2)
	print(apno, " ",xcen, " ",bg_samp1, " ",bg_samp2)
	#print(bg1, bg2)

	llim = -2.0; ulim = 2.0
	date | scan (date)	
	print("# ",date, >> apfile)
	print("begin   aperture ", imname, " ", apno, xcen, ycut, >> apfile)
        print("        image   ", imname, >> apfile)
	print("        aperture       ", apno, >> apfile)
	print("        beam   ", apno, >> apfile)
	print("        center  ", xcen, ycut, >> apfile)
	print("        low     ", llim, -ycut, >> apfile)
	print("        high    ", ulim, ycut, >> apfile)
        print("        background", >> apfile)
        print("                xmin ", xmin, >> apfile)
        print("                xmax ", xmax, >> apfile)
        print("                function ", bg_func, >> apfile)
        print("                order ", bg_ord, >> apfile)
        print("                sample ", bg_samp1, " ",bg_samp2, >> apfile)
        print("                naverage ", -3, >> apfile)
        print("                niterate ", 0, >> apfile)
        print("                low_reject ", 3.0, >> apfile)
        print("                high_reject ", 3.0, >> apfile)
        print("                grow ", 0., >> apfile)
        print("        axis    ", 1, >> apfile)
	type ("tmp_table", >> apfile)
        print("      ", >> apfile)
	}

end
