procedure bncflat(infile, outfile)

string  infile  = " "              {prompt="BnC input combined flat"}
string  outfile = " "              {prompt="BnC output Master flat"}
int     xwin    = "3"              {prompt="X window size of median filter"}
int     ywin    = "3"              {prompt="Y window size of median filter"}
bool    del     = "yes"            {prompt="Delete all intermediate files?"}

begin

string  object, outnam
int     xw, yw
bool    delete

        object = infile
	xw     = xwin
	yw     = ywin
	outnam = outfile
	delete = del

    imdelete (object//"med", veri=no, >& "dev$null")
    imdelete (object//"nor", veri=no,  >& "dev$null")
    imdelete (object//"llu", veri=no,  >& "dev$null")
    imdelete (outnam, veri=no,  >& "dev$null")

print ("Step 1: Running a median filter to the image")
median (object, object//"med", xw=xw, yw=yw)
print ("Step 2: Normalization --- original/median ")
imarith (object, "/", object//"med", object//"nor", verb=no)
print ("Step 3: Illumination correction")
illum (object//"med", object//"ill", functio="spline3", order=3)
print ("Step 4: Master Flat = FlatNorm*FlatIllum")
imarith (object//"nor", "*", object//"ill", outnam, verb=no)

if (delete) {
    imdelete (object//"med", veri=no, >& "dev$null")
    imdelete (object//"nor", veri=no,  >& "dev$null")
    imdelete (object//"ill", veri=no,  >& "dev$null")
}

print (" *** Done *** ")


end
