procedure efosc_ident(filnew)

################################################
#A simple script to guess the bright lines in the linelist of arclamps based on
#one set of solution using the bright 3 or 4 lines
####################################################

string  filnew = "identify.lis"      {prompt="Input file containing Filenames to be identified"}
string  filref = "ref1"      {prompt="Name of reference File "}
string  filcoo = "idhear1.dat"      {prompt="Name of linelist file "}
#string  filnew = "test4"      {prompt="File name where the lines to be identified"}


begin
        string tfile, filin, fref, clin, dum1, dum2, dum3, dum4, coolist, fillist
	string  tmp
	real	xin, x1, lamin, xdifin, xref, lamref, i1, i2
        int    nlines, ncoef
        struct  line


        #filin = filnew
        fillist = filnew
        fref = "database/id"//filref
	coolist = filcoo

	#for (i=1; i <= nlines; i +=1) {
	#fields(fillist, fields="1-3", lines=1) | scan (filin, xin, lamin)
	#print(filin, xin, lamin)
	#}

	i1 = 0
	list = fillist
        while( fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#") {
          i1=i1+1
	  i2 = fscan(line, filin, xin, lamin)
	#print(filin, xin, lamin)

	fields (fref, fields=2, lines=7) | scan (nlines)

	clin = str(8)//"-"//str(7+nlines)
	print("Number of lines to be identified = ",nlines)

	tfile = "database/id"//filin
        delete(tfile, ver-, >& "dev$null")
	print ("begin    identify ", filin//"[12,*]", > tfile)
	print ("         id      ", filin, >> tfile)
	print ("         task    ", filin//"[12,*]", >> tfile)
	print ("         units     Angstroms", >> tfile)
	print ("         features  ", nlines, >> tfile)

	fields (fref, fields="1,3-7", lines=str(8) ) | scan (xref, lamref, dum1, dum2, dum3, dum4)
	if (abs(lamref - lamin) < 1.0 ) {xdifin = xin - xref} 

	for (i=1; i <= nlines; i +=1) {
	#clin = str(8)//"-"//str(7+i)
	fields (fref, fields="1,3-7", lines=str(7+i) ) | scan (xref, lamref, dum1, dum2, dum3, dum4)
	#x1 = xref - 40.0
	x1 = xref + xdifin
	#printf("            %6.2f %12.3f %12.3f %6s %2s %2s %s %6.2f \n", x1, lamref, lamref, dum1, dum2, dum3, dum4, xin)
	printf("       	    %6.2f %12.3f %12.3f %6s %2s %2s %s \n", x1, lamref, lamref, dum1, dum2, dum3, dum4, >> tfile)
	}
	
	for (i=1; i <= 9; i +=1) {
	fields (fref, fields="1-2", lines=str(7+nlines+i) ) | scan (dum1, dum2)
	printf("     %s %s \n", dum1, dum2, >> tfile)
	}
	ncoef = int(dum2)
	#print(ncoef)
	for (i=1; i <= ncoef; i +=1) {
	fields (fref, fields="1", lines=str(16+nlines+i) ) | scan (dum1)
	printf("         %s \n", dum1, >> tfile)
	}
	print ("end", >> tfile)

	identify (filin, sec="mid col", coo=coolist)

	}
	}
end

