procedure mfluxcalc2d(infile, fibbeg, fibend)

string  infile  = "test_megara_lrb_2d"  {prompt="Input root filename to measure flux"}
int     fibbeg  = 0                     {prompt="First Fiber number to analyze?"}
int     fibend  = 0                     {prompt="Last  Fiber number to analyze?"}

begin
	string	filein, s1, vel_type
        int     fib_beg, fib_end, fno

        filein = infile; fib_beg = fibbeg; fib_end = fibend

	if (!imaccess(filein//"_csub")){imexpr ("a*0.0", filein//"_csub", filein, verb-)}
	if (!imaccess(filein//"_cont")){imexpr ("a*0.0", filein//"_cont", filein, verb-)}
	if (!imaccess(filein//"_totrms")){imexpr ("a*0.0", filein//"_totrms", filein, verb-)}
	if (!imaccess(filein//"_snr")){imexpr ("a*0.0", filein//"_snr", filein, verb-)}

        for (fno=fib_beg; fno <= fib_end; fno +=1) { 
	  mfluxcalc (filein, linelist="megara_lrb_neblines.dat", snrgood=2.0, errfwhm=2.0, skyrms-, skyshi-, inter-, apno=fno, veltyp="median")
                match ("Velocity", filein//"_ap"//str(fno)//"_1_fluxobs.dat") | scan (s1, s1, s1, s1, s1, s1, s1, s1, vel_type)
	        delete(filein//"_ap"//str(fno)//"_1_fluxobs.dat", ver-, >& "dev$null")
	  mfluxcalc (filein, linelist="megara_lrb_neblines.dat", snrgood=2.0, errfwhm=2.0, skyrms-, skyshi-, inter-, apno=fno, veltyp=vel_type)
	  type (filein//"_ap"//str(fno)//"_1_fluxobs.dat", >> filein//"_fiber_fluxobs.dat")
	  delete (filein//"_ap"//str(fno)//"_1_fluxobs.dat", ver-, >& "dev$null")
	  imcopy (filein//"_dop"//str(fno)//"_1_csub", filein//"_csub[*,"//str(fno)//"]")
	  imdel  (filein//"_dop"//str(fno)//"_1_csub", ver-, >& "dev$null")
	  imcopy (filein//"_dop"//str(fno)//"_1_cont", filein//"_cont[*,"//str(fno)//"]")
	  imdel  (filein//"_dop"//str(fno)//"_1_cont", ver-, >& "dev$null")
	  imcopy (filein//"_dop"//str(fno)//"_1_totrms", filein//"_totrms[*,"//str(fno)//"]")
	  imdel  (filein//"_dop"//str(fno)//"_1_totrms", ver-, >& "dev$null")
	  imcopy (filein//"_dop"//str(fno)//"_1_snr", filein//"_snr[*,"//str(fno)//"]")
	  imdel  (filein//"_dop"//str(fno)//"_1_snr", ver-, >& "dev$null")
	  imdel  (filein//"_dop"//str(fno)//"_1", ver-, >& "dev$null")
	  imdel  (filein//"_dop"//str(fno)//"_1_rms", ver-, >& "dev$null")
	  imdel  (filein//"_ap"//str(fno)//"_1_rms", ver-, >& "dev$null")
	}
end
