procedure	omspestat(filnam)

string  filnam  = ""      	{prompt="File Name"}
real	xposlit = 22.0		{prompt="X position of the slitlet"}
real	yposlit = 1011.0	{prompt="Y position of the slitlet"}
real    contflux= 1.0           {prompt="Continuum flux (0 ==> cont level is zero)"}
real    basepix = 10.0          {prompt="Basewidth of a line in pixeles"}
string	cursor  = ""		{prompt="Cursor File Name"}
string  graphics="stdgraph"     {prompt="Output graphics device"}
string  splotlog=""     	{prompt="File for saving line parameter file [empty=no save]"}
real	xref    = 1040.0	{prompt="Ref X position of the slit"}
real	yref    =  995.0	{prompt="Ref Y position of the slit"}
string  logfile = ""      {prompt="File Name"}

begin
	string filin, statsecl, statsecr, splotfilcur, splotfillog, cdisp
	string graphtyp, curfile, linelog
	real	slityx, slitx, disp, basewid, yl1, yl2, yr1, yr2 
	real	lint, rint, yl, yr, cflux, basewidpix, xcen, ycen
	real	center, cont, flux, eqw, core, gfwhm, lfwhm

        filin = filnam; slityx=yposlit; slitx=xposlit; graphtyp=graphics 
	disp = 1.0; cdisp = "1.0"; cflux = contflux; basewidpix = basepix
	curfile = cursor; xcen = xref; ycen = yref; linelog = splotlog
	hselect (filin, "CDELT2", expr+) | scan(cdisp)
	if (cdisp != " " && real(cdisp) > 0.01) {disp = real(cdisp)}
	basewid = basewidpix*disp
	yl = slityx - 2.0*basewid; yr = slityx + 2.0*basewid
	yl1 = yl - 0.5*basewid; yl2 = yl + 0.5*basewid
	yr1 = yr - 0.5*basewid; yr2 = yr + 0.5*basewid

	splotfilcur = "splot_auto_cont.cursor"
	splotfillog = "splot_auto_cont.log"
        delete (splotfilcur, ver-, >& "dev$null")
        delete (splotfillog, ver-, >& "dev$null")
	print (yl1, " 0.0  1 m", >> splotfilcur)
	print (yl2, " 0.0  1 m", >> splotfilcur)
	print (yr1, " 0.0  1 m", >> splotfilcur)
	print (yr2, " 0.0  1 m", >> splotfilcur)
	print (yr2, " 0.0  1 q", >> splotfilcur)
	if (graphtyp == "stdgraph"){
	splot (filin, line=slitx, band=1, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic=graphtyp) 
	} else {
	splot (filin, line=slitx, band=1, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic=graphtyp, >& "dev$null") 
	}
	fields (splotfillog, fields="2", lines=3) | scan (lint)
	fields (splotfillog, fields="2", lines=4) | scan (rint)
	#print(disp, " ",lint, " ", rint)

        if (cflux == 0.0) {lint = 0.0; rint = 0.0}
	splotfilcur = "splot_auto_gaussfit.cursor"
	splotfillog = "splot_auto_gaussfit.log"
        delete (splotfilcur, ver-, >& "dev$null")
        delete (splotfillog, ver-, >& "dev$null")

	print (yl, " ", lint, " 1 k", >> splotfilcur)
	print (yr, " ", rint, " 1 k", >> splotfilcur)
	print (yr, " ", rint, " 1 q", >> splotfilcur)
	if (curfile != "") {splotfilcur = curfile}

	if (graphtyp == "stdgraph"){
	splot (filin, line=slitx, band=1, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic="stdgraph")
	} else {
	splot (filin, line=slitx, band=1, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic=graphtyp, >& "dev$null")
	}

	if (linelog != "") {
	##fields (splotfillog, fields="1,6", lines=3)
	fields (splotfillog, fields="1-7", lines=4) | scan (center, cont, flux, eqw, core, gfwhm, lfwhm)

	slitx = slitx - xcen; center = center - ycen
	printf ("%9.2f %9.2f %9.2f %9.0f %9.3f %9.2f %6.2f %6.2f\n", slitx, center, cont, flux, eqw, core, gfwhm, lfwhm, >> linelog)
	}

	#omlinefit.logfile = splotfillog

end
