	#print("ID=", id, " Function=", func, " Line=",ii, " norder=",norder, " MinMax=[", ymin, ymax,"]")
	print("ID=", id, " Function=", func, norder=",norder, " MinMax=[", ymin, ymax,"]")

	datfil = ofil//".dat"; delete (datfil, ver-, >& "dev$null")
	if (suffix == "ap"){
	print("# Region file format: DS9 version 4.1", >> regfil)
	print("global color=green dashlist=8 3 width=1 select=1 highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1", >> regfil)
	print("image", >> regfil)
	}
	ipix = 0
	#procedure calcfunc(func, cc, norder, ymin, ymax, istep, center, low, high, suffix)
        for (k = int(ymin)-1; k <= int(ymax)-1; k = k + 1) {
	ipix = ipix + 1
        y = real(k)
	if (ipix == 1 && suffix == "ap"){y = refpix}
        n = (2.0*y - (ymax + ymin))/(ymax - ymin)
        yfit = 0.0

	if (func == "spline3" || func == "spline1"){
        s = real(norder)*(y - ymin)/(ymax - ymin); j = int(s)
        aa = real(j)+1.0 - s; bb = s - real(j)
	}
	if (func == "spline1"){yfit = cc[j+1]*aa + cc[j+1+1]*bb}
	if (func == "spline3"){
        zz[1] = aa**3
        zz[2] = 1.0 + 3.0*aa*(1.0 + aa*bb)
        zz[3] = 1.0 + 3.0*bb*(1.0 + aa*bb)
        zz[4] = bb**3
        for (i = 1; i <= 4; i = i + 1) { yfit = yfit + cc[i+j]*zz[i] }
	}

	if (func == "chebyshev") {
        zz[1] = 1; zz[2] = n 
        for (i = 1; i <= norder; i = i + 1) {
		if (i>2){zz[i] = 2.0*n*zz[i-1] - zz[i-2]}
                yfit = yfit + cc[i]*zz[i]
        }
        }

	if (func == "legendre") {
        zz[1] = 1; zz[2] = n 
        for (i = 1; i <= norder; i = i + 1) {
		#if (i>2){zz[i] = (2.0*real(i-3))*n*zz[i-1] - real(i-2)*zz[i-2]/real(i-1)}
		#if (i>2){zz[i] = ((2.0*real(i-3))*n*zz[i-1] - real(i-2)*zz[i-2])/real(i-1)}
		if (i>2){zz[i] = ((2.0*real(i)-3.0)*n*zz[i-1] - real(i-2)*zz[i-2])/real(i-1)}
                yfit = yfit + cc[i]*zz[i]
        }
        }

	if (ipix == 1 && suffix == "ap"){
		shift = center - yfit
	#if (plotbg) {for (kk=1; kk <= ibg; kk = kk + 1) {shift_skyl[kk] = bl[kk] + center - yfit; shift_skyl[kk] = br[kk] + center - yfit}}
		} else {
	yfit = shift + yfit + real(i1) - 1.0
	#if (plotbg) {for (kk=1; kk <= ibg; kk = kk + 1) {yfit_skyl[kk] = shift_skyl[kk] + yfit; yfit_skyr[kk] = shift_skyr[kk] + yfit}}
        print (y, yfit, >> datfil)

	if (suffix == "ap"){
        if (boxtyp == "box" && mod(k, istep) == 0){comm1 = "box("//str(yfit+low+high)//","//str(y)//","//str(high-low)//","//str(istep)//","//str(0)//")";   print(comm1, >> regfil) } 
	}
	}    #ipix!=1

	}    #k

        graph (datfil, wx1=ymin*0.9, wx2=1.1*ymax, wy1 = INDEF, wy2=INDEF, pointmode-,szmarke=0.02, marker = "circle")
	if (suffix == "id"){
	fields (dfile, fields="1,2", lines=cline) | graph (append+,  pointmode+, szmarke=0.02, marker = "circle")} else { print("The function stored in XY table = ", datfil, " and ds9 region ", boxtyp, " file = ",regfil)}

	#----------------------  popygon generator
	if (suffix == "ap" && boxtyp != "box"){
	print("global color=green dashlist=8 3 width=1 select=1 highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1", >> regfil)
	#print(k, low, high)
        comm1 = "polygon("
        comm_left = ""
        comm_right = ""
        for (k = int(ymin); k <= int(ymax)-1; k = k + istep) {
        fields (datfil, fields="2", lines=k) | scan (yfit)
	y = yfit+low; printf("%6.1f", y) | scan(ystr)
	#print(k, yfit, y, ystr)
        comm_left = comm_left//ystr//","//str(k)//","
	}
        comm_left = comm_left//ystr//","//str(ymax)//","

        for (k = int(ymax); k >= int(ymin)+istep; k = k - istep) {
        fields (datfil, fields="2", lines=k) | scan (yfit)
	y = yfit+high; printf("%6.1f", y) | scan(ystr)
	#print(k, yfit, y, ystr)
        comm_right = comm_right//ystr//","//str(k)//","
	}
	comm1 = "polygon("//comm_left//comm_right//ystr//","//str(ymin)//")"
	#print("polygon("//comm_left, >> regfil)
	#print(comm_right//str(y)//","//str(ymin)//")", >> regfil)
	print(comm1, >> regfil)
	}

	if (suffix == "ap" && boxtyp != "box" && plotbg){
	print("global color=blue dashlist=8 3 width=1 select=1 highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1", >> regfil)
	#print(k, low, high)
	#for (kk=1; kk <= ibg; kk = kk + 1) {shift_skyl[kk] = bl[kk] + center - yfit; shift_skyl[kk] = br[kk] + center - yfit}
	#for (kk=1; kk <= ibg; kk = kk + 1) {print(kk, center, bl[kk] + center, br[kk] + center)}
        for (kk=1; kk <= ibg; kk = kk + 1) {
	print(bl[kk], br[kk])
        comm1 = "polygon("
        comm_left = ""
        comm_right = ""
	#print(kk, center, bl[kk] + center, br[kk] + center)
	low = bl[kk]; high = br[kk]
        for (k = int(ymin); k <= int(ymax)-1; k = k + istep) {
        fields (datfil, fields="2", lines=k) | scan (yfit)
	y = yfit+low; printf("%6.1f", y) | scan(ystr)
	#print(k, yfit, y, ystr)
        comm_left = comm_left//ystr//","//str(k)//","
	}
        comm_left = comm_left//ystr//","//str(ymax)//","

        for (k = int(ymax); k >= int(ymin)+istep; k = k - istep) {
        fields (datfil, fields="2", lines=k) | scan (yfit)
	y = yfit+high; printf("%6.1f", y) | scan(ystr)
	#print(k, yfit, y, ystr)
        comm_right = comm_right//ystr//","//str(k)//","
	}
	comm1 = "polygon("//comm_left//comm_right//ystr//","//str(ymin)//")"
	#print("polygon("//comm_left, >> regfil)
	#print(comm_right//str(y)//","//str(ymin)//")", >> regfil)
	print(comm1, >> regfil)
	}
	}   #kk = 1, ibg

	#APCEN//id = center low high
	#APFUN//id = nfunc norder ncoef cc[k]
	#APSKY//id//kk = bsamp
	#headfun = str(nfunc)//" "//str(norder)//" "//str(ncoef)
	#headbg = str(ibg)//" "//bfunc//" "//str(border)//" " 
	#for (kk=1; kk <= ibg; kk = kk + 1) {headbg[id] = headbg[id]//" "//str(bl[kk])//" "//str(br[kk])}
        #for (k = 1; k <= ncoef; k = k+1) {headfun[id] = headfun[id]//" "//str(cc[k])}
	print(headcen[id])
	hedit (spe1d, "APCEN"//str(id), headcen[id], add+, addonly+, verify-, show-, update+)
	hedit (spe1d, "APFUN"//str(id), headfun[id], add+, addonly+, verify-, show-, update+)
	hedit (spe1d, "APSKY"//str(id), headbg[id], add+, addonly+, verify-, show-, update+)
	}  # id=irec
	#}  #nap
	#}}}    # coeff, line, EOF  

exit:
	print(" DONE")

end
