procedure velcor

string  spec_inp = ""               {prompt="Input spectrum"}
string  spec_out = ""            {prompt="Output spectrum"}
string  skyline  ="skylines.dat" {prompt="Skyline filename"}
#string  objline  ="objlines.dat" {prompt="Objline filename"}

#real	wave_O5577 = 5577.338       {prompt="Observed wl of O5577 line"}
#real	wave_O6300 = 6300.304       {prompt="Observed wl of O6300 line"}


begin
	string tsections2,spec_in,skyfil,c1,sky_range
	real   wl1,wl_air,wl2
	int    i2, i3, nsky
        struct  line

	spec_in = spec_inp
	skyfil = skyline  #; objfil = objline
	#wl_O5577_air = 5577.338; wl_O6300_air = 6300.304
	
        i2 = 0
        i3 = 0
        list = skyfil
        while( fscan(list,line) != EOF ) {
        c1 = substr(line,1,1)
        #print(line, " ", c1)
        if (c1 !="#") {
        #i2 = fscan(line,wl_obs,wl_air)
        i2 = fscan(line,wl_air)
          i3 = i3 + 1
	
        tsections2 = mktemp ("tmps2")
	delete(tsections2, ver-, >& "dev$null")
        printf("%10f \n",wl_air, "INDEF g 10", >> tsections2)

	wl1 = wl_air - 20.0; wl2 = wl_air + 20.0
	sky_range = str(wl1)//" "//str(wl2)
	delete("plotfil", ver-, >& "dev$null")
	imdelete("temp1_fit", ver-, >& "dev$null")

	fitprofs (spec_in, bands=2, reg=sky_range, pos=tsections2, plotfil="plotfil", output="temp1_fit", fitback+)
	delete(tsections2, ver-, >& "dev$null")

	#wl_dif = wl_air - wl_obs
        #id[i3] = cid
        } }
        nsky  = i3

	#wl_O5577_obs = wave_O5577; wl_O6300_obs = wave_O6300
	#calculate mean shift
	#O5577_dif = wl_O5577_air - wl_O5577_obs
	#O6300_dif = wl_O6300_air - wl_O6300_obs
	#mean_shi = (O5577_dif+O6300_dif)/2.0
	#spec_shi = spec_in//"_shi"
	#imdel(spec_shi)
	#imcopy (spec_inp, spec_shi)
	#specshift(spec_shi, mean_shi)

	#calculate Doppler shift

	#Read a textfile with col1=rest_wl col2=obs_wl0
	#To do this Use a template spectrum with all possible lines there, and uncomment the lines
	#where measurements are available

	#v = c*(lambda_obs**2/lamda_rest**2 - 1.0)/(lambda_obs**2/lamda_rest**2 + 1.0)

end

