procedure  canholr(image, newimage)

string   image    = ""          	{prompt="Input Image Name"}
string   newimage = ""          	{prompt="Output Image Name"}
real	 ksigma   = 2			{prompt="k-sigma rejection threshold"}
string   fquad1   = "0.008 0.008 0.008" {prompt="Hole size in Q1 because of stars in Q2,Q3 & Q4 [f21,f31,f41]" }
string   fquad2   = "0.008 0.008 0.008" {prompt="Hole size in Q2 because of stars in Q1,Q3 & Q4 [f12,f32,f42]" }
string   fquad3   = "0.008 0.008 0.008" {prompt="Hole size in Q3 because of stars in Q1,Q2 & Q4 [f13,f23,f43]" }
string   fquad4   = "0.008 0.008 0.008" {prompt="Hole size in Q1 because of stars in Q1,Q2 & Q3 [f14,f24,f34]" }

begin

        string  infile, ofile, q1, q2, q3, q4, fil_q1, fil_q2, fil_q3, fil_q4
	string  tfile1, tfile2, tfile3, tfile4, comm1, comm2, comm3, comm4
	real	f21, f31, f41, f12, f32, f42, f13, f23, f43, f14, f24, f34, ksig
	real	bg1, bg2, bg3, bg4, rms1, rms2, rms3, rms4
	int	i1

        infile = image
        ofile = newimage
	ksig = ksigma

	i1 = fscan(fquad1, f21, f31, f41)
	i1 = fscan(fquad2, f12, f32, f42)
	i1 = fscan(fquad3, f13, f23, f43)
	i1 = fscan(fquad4, f14, f24, f34)

        q1 = "[1:512,1:512]"
        q2 = "[513:1024,1:512]"
        q3 = "[513:1024,513:1024]"
        q4 = "[1:512,513:1024]"

	fil_q1 = "tttqqq1"; fil_q2 = "tttqqq2"; fil_q3 = "tttqqq3"; fil_q4 = "tttqqq4"
	tfile1 = "tttqqQ1"; tfile2 = "tttqqQ2"; tfile3 = "tttqqQ3"; tfile4 = "tttqqQ4"
        imdelete("tttqq*", ver-, >& "dev$null")
        imdelete(ofile, ver-, >& "dev$null")

        imcopy (infile, ofile, ver-)
	imstat (infile//q1, fields="mode, stddev", format- ) | scan (bg1, rms1) 
	imstat (infile//q2, fields="mode, stddev", format- ) | scan (bg2, rms2) 
	imstat (infile//q3, fields="mode, stddev", format- ) | scan (bg3, rms3) 
	imstat (infile//q4, fields="mode, stddev", format- ) | scan (bg4, rms4) 
	bg1 = bg1 + ksig*rms1; bg2 = bg2 + ksig*rms2 
	bg3 = bg3 + ksig*rms3; bg4 = bg4 + ksig*rms4 

	comm1 = "a >"//str(bg1)//" ? a : 0"; imexpr (comm1, fil_q1, infile//q1, verb-)
	comm2 = "a >"//str(bg2)//" ? a : 0"; imexpr (comm2, fil_q2, infile//q2, verb-)
	comm3 = "a >"//str(bg3)//" ? a : 0"; imexpr (comm3, fil_q3, infile//q3, verb-)
	comm4 = "a >"//str(bg4)//" ? a : 0"; imexpr (comm4, fil_q4, infile//q4, verb-)
	print (bg4, " ", rms4, " ",comm4)

        #imexp ("min(a,b,c,d)", tfile, infile//q1, infile//q2, infile//q3, infile//q4, verb-)
        #imexp (a-f21*b-f31*c-f41*d, tfile1, infile//q1, infile//q2, infile//q3, infile//q4, verb-)

	comm1 = "a+"//str(f21)//"*b+"//str(f31)//"*c+"//str(f41)//"*d"
	comm2 = "a+"//str(f12)//"*b+"//str(f32)//"*c+"//str(f42)//"*d"
	comm3 = "a+"//str(f13)//"*b+"//str(f23)//"*c+"//str(f43)//"*d"
	comm4 = "a+"//str(f14)//"*b+"//str(f24)//"*c+"//str(f34)//"*d"
	print (comm4)

        imexp (comm1, tfile1, infile//q1, fil_q2, fil_q3, fil_q4, verb-)
        imexp (comm2, tfile2, infile//q2, fil_q1, fil_q3, fil_q4, verb-)
        imexp (comm3, tfile3, infile//q3, fil_q1, fil_q2, fil_q4, verb-)
        imexp (comm4, tfile4, infile//q4, fil_q1, fil_q2, fil_q3, verb-)

        #imexp ("a-f21*b-f31*c-f41*d", tfile1, infile//q1, fil_q2, fil_q3, fil_q4, verb-)
        #imexp ("a-f12*b-f32*c-f42*d", tfile2, infile//q2, fil_q1, fil_q3, fil_q4, verb-)
        #imexp ("a-f13*b-f23*c-f43*d", tfile3, infile//q3, fil_q1, fil_q2, fil_q4, verb-)
        #imexp ("a-f14*b-f24*c-f34*d", tfile4, infile//q4, fil_q1, fil_q2, fil_q3, verb-)

        imcopy (tfile1, ofile//q1, verb-)
        imcopy (tfile2, ofile//q2, verb-)
        imcopy (tfile3, ofile//q3, verb-)
        imcopy (tfile4, ofile//q4, verb-)

	displ (ofile, 1, zs+, fill+)

end

