procedure canref(imref, refcoo)

int     imref    = "1"     {prompt="No of the ref image (2 for as40k002 etc.)"}
string  refcoo   = "ref.coo" {prompt="file (ref.coo) with ref star position or as40k002ref"}
string  crpix    = "center"  {prompt="[center/refstar] XY pixels of RA-Dec"}
string  shifil= ""           {prompt="XY shift file [shi=ref-in] if refcoo=as40k002ref"}
bool    oriima= yes          {prompt="Find centroid in original or sky-subtracted?"}
#string  rakey    = "AR"	     {prompt="Right Ascension Keyword name in the input image"}

begin
	string 	cmn,froot,seq,refim,coofil,xyfil,cfile,ra_key,suffix1,suffix2
	int 	iref,im1,im2,imn,npass,i1,kref,nx,ny,nxf,nyf
	real    xref, yref, xcoo, ycoo, xmin, xmax, ymin, ymax
	real	x1, x2, y1, y2, xerr, yerr
        string  cm[99], ra, dec, num, c1, sign, shift, canreflog
        int     nm[99],i,len,k,intra[99],m1,rlen,intdec[99],m2
        real    decdeg[99],rahour[99],radeg[99],xshi[99],yshi[99],scal,racor
	bool	origim
 
        cfile = refcoo; iref = imref; froot  = canobj.root; shift = shifil
        im1 = canobj.imbeg; im2 = canobj.imend; ra_key = canobj.rakey 
	origim = oriima
	suffix1 = canobj.suffix
	if (origim) {suffix2 = suffix1} else {suffix2 = "sf"}
	npass = im2 - im1 + 1

	imn = iref
	kref = imn - im1 + 1
        cmn = froot//str(imn)
        if (imn < 100) cmn = froot//"0"//str(imn)
        if (imn < 10) cmn = froot//"00"//str(imn)

	len = strlen(cfile)
	c1 = substr(cfile,len-3,len)
	#print(len,c1)
	refim  = cmn//"ref"
	if (c1 != ".coo") refim = cfile
        coofil = refim//".coo"
        xyfil  = refim//".xy"
	seq    = cmn//".seq"
	if (c1 != ".coo") {
		cfile = coofil
	} else {
        	delete(coofil, ver-, >& "dev$null")
        	delete(xyfil, ver-, >& "dev$null")
        	imdelete(refim, ver-, >& "dev$null")
        	imcopy (cmn//"sf", refim, verbose=no)
	}
	hselect (refim, "NAXIS1 NAXIS2", yes) | scan(x2, y2)
	x1 = 50.0; y1 = 50.0; x2 = x2 - 50.0; y2 = y2 - 50.0

	i1 = 0
        list = cfile
	i1 = fscan(list,xref,yref)
        #while( fscan(list,x,y ) != EOF ) {
        #        i1=i1+1
	#	xref = x
	#	yref = y
		if (c1 == ".coo") {
        		print(xref, yref, >> coofil)
        		print(xref, yref, >> xyfil)
			#copy (coofil, xyfil)
                }
        #}

	canreflog = "canref.log"
        delete (canreflog, ver-, >& "dev$null")

#	Finding the image shifts using the header coordinates

	k = 0
        for (imn=im1; imn<= im2; imn +=1){
        	cmn = froot//str(imn)
        	if (imn < 100) cmn = froot//"0"//str(imn)
        	if (imn < 10) cmn = froot//"00"//str(imn)
		k = k + 1
		#cm[k] = cmn//"_I.fits"
		cm[k] = cmn//suffix2
   if (imn == iref)printf("%c %8.3f %8.3f %c \n", "#",xref, yref,cm[kref])
   if (imn == iref)printf("%c %8.3f %8.3f %c \n", "#",xref, yref, cm[kref], >> canreflog)
   if (imn == iref)printf("%c \n", "#   X_DIF     Y_DIF       RA       DEC     Image", >> canreflog)
   if (imn == iref)printf("%c \n", "#   X_DIF     Y_DIF       RA       DEC     Image")
   #if (imn == iref)printf("%c %c %8.3f %8.3f \n", "xref ", cm[kref],xref, yref)
   #if (imn == iref)printf("%c %c %8.3f %8.3f \n", "xref ", cm[kref],xref, yref, >> canreflog)
        i1 = 0
        m1 = 0
        intra[4] = 0
        #imgets (cm[k], "AR")
        #imgets (cm[k], ra_key)
        imgets (cmn//suffix1, ra_key)
        ra = (imgets.value)
        rlen = strlen(ra)
        if (rlen < 2){
          print(rlen)
          print("RA keyword is empty in ",cm[k], ". Exiting....")
          goto exit
        }
        for (i=1; i <= rlen+1; i +=1){
          c1 = substr(ra,i,i)
          if (c1 != ":" && i != rlen+1){
                i1 = i1 + 1
          } else {
              m1 = m1 + 1
              if (i1 == 3) {
                intra[m1] = int(substr(ra,i-i1,i-2))
                intra[m1+1] = int(substr(ra,i-1,i-1))
              } else {
              intra[m1] = int(substr(ra,i-i1,i-1))
              }
                i1 = 0
         }
         }
        i1 = 0
        m2 = 0
        sign = "+"
        intdec[4] = 0
        #imgets (cm[k], "DEC")
        imgets (cmn//suffix1, "DEC")
        dec = (imgets.value)
        rlen = strlen(dec)
        for (i=1; i <= rlen+1; i +=1){
          c1 = substr(dec,i,i)
          if (c1 != ":" && i != rlen+1){
            if (c1 == "-")sign="-"
            if (c1 != "," && c1 != "-" && c1 != "+") i1 = i1 + 1
          } else {
              m2 = m2 + 1
              if (i1 == 3) {
                intdec[m2] = int(substr(dec,i-i1,i-2))
                intdec[m2+1] = int(substr(dec,i-1,i-1))
              } else {
              intdec[m2] = int(substr(dec,i-i1,i-1))
              }
                i1 = 0
         }
	}

        decdeg[k] = intdec[1]+intdec[2]/60.0+intdec[3]/3600.0+intdec[4]/36000.0
        if (sign == '-')decdeg[k] = -1.0*decdeg[k]
        rahour[k] = intra[1]+intra[2]/60.0+intra[3]/3600.0+intra[4]/36000.0
        racor = cos(decdeg[k]/57.2957795)
        radeg[k] = 15.0*rahour[k]
        }

	cancen (cm[kref], xref, yref, shifil=shift, checkma-, verb+)
	xref = cancen.xout; yref = cancen.yout
        delete (seq, ver-, >& "dev$null")
        scal = 0.32
        for (k=1; k <= npass; k +=1){
          xshi[k] = 3600.0*racor*(radeg[kref] - radeg[k])/scal
          yshi[k] = 3600.0*(decdeg[kref] - decdeg[k])/scal
	  xcoo = xref + xshi[k]
	  ycoo = yref + yshi[k]
	  if (k == 1){xmax = xcoo; xmin = xcoo; ymax = ycoo; ymin = ycoo}
	  #xmax = max(xmax,xcoo,1024.0); xmin = min(xmin,xcoo,0.0)
	  #ymax = max(ymax,ycoo,1024.0); ymin = min(ymin,ycoo,0.0)
	  xmax = max(xmax,xcoo); xmin = min(xmin,xcoo)
	  ymax = max(ymax,ycoo); ymin = min(ymin,ycoo)
	xerr = 0; yerr = 0.0
	if (xcoo > x1 && xcoo < x2 && ycoo > y1 && ycoo < y2) {
          #printf("%8.3f %8.3f \n",xcoo, ycoo)
	cancen (cm[k], xcoo, ycoo, shifil="", checkma+, verb-) 
	xerr = xcoo - cancen.xout; yerr = ycoo - cancen.yout
	xcoo = cancen.xout; ycoo = cancen.yout  
	if (!cancen.cfound){xcoo = -1.0*xcoo; xerr = -1.0*xcoo}
				}
          printf("%8.3f %8.3f \n",xcoo, ycoo, >> seq)
        printf("%9.3f %9.3f %h %h %c %8.3f %8.3f %8.3f %8.3f \n",xshi[k],yshi[k],rahour[k],decdeg[k],cm[k], xcoo, ycoo, xerr, yerr)
        printf("%9.3f %9.3f %h %h %c %8.3f %8.3f %8.3f %8.3f \n",xshi[k],yshi[k],rahour[k],decdeg[k],cm[k], xcoo, ycoo, xerr, yerr, >> canreflog)
        #printf("%c %c %h %c %h %8.3f %8.3f \n",cm[k], " RA =",rahour[k]," Dec =",decdeg[k], xshi[k],yshi[k])
        #printf("%c %c %h %c %h %8.3f %8.3f \n",cm[k], " RA =",rahour[k]," Dec =",decdeg[k], xshi[k],yshi[k], >> canreflog)
        }
	  nxf = int((xmax-xmin)/1024.0)+1 ; nyf = int((ymax-ymin)/1024.0) + 1
	  if (xmax < 1024.0 && xmax > 0.0) xmax = 1024.0; if (xmin < 1024.0 && xmin > 0.0) xmin = 0.0
	  if (xmax > 1024.0) xmax = 1024.0*nxf; if (xmin < 0.0) xmin = 0.0 - 1024.0*nxf
	  if (ymax < 1024.0 && ymax > 0.0) ymax = 1024.0; if (ymin < 1024.0 && ymin > 0.0) ymin = 0.0
	  if (ymax > 1024.0) ymax = 1024.0*nyf; if (ymin < 0.0) ymin = 0.0 - 1024.0*nyf

	#printf("%8.3f %8.3f %8.3f %8.3f %3d  %3d \n",xmin,xmax,ymin,ymax,nxf,nyf)
        graph (seq, wx1=xmin, wx2=xmax, wy1=ymin, wy2=ymax, pointmo+, marker="box", szmarke=0.01, xlabel="X [pix]", ylabel="Y [pix]", overplo-, app- )	

        print ("                                     ", >> froot//"-canica.log")
        print (" --- CANREF REDUCTION PARAMETERS --- ", >> froot//"-canica.log")
	type(canreflog) | cat >> froot//"-canica.log"

exit:
        print(" ")

        canobj.refimag = refim
        canobj.sequenc = seq
        canobj.iref = iref
        canobj.seqbeg= im1
        canobj.xshi = 0
        canobj.yshi = 0
        canobj.crval1= radeg[kref]
        canobj.crval2= decdeg[kref]
        canobj.epoch = 2000.0
	canobj.cdelt1 = scal/3600.0
	canobj.cdelt2 = scal/3600.0


	if (crpix == "refstar") {
		canobj.crpix1 = xref
		canobj.crpix2 = yref
	} else {
        	imgets (cm[iref], "i_naxis1")
        	nx = int(imgets.value)
        	imgets (cm[iref], "i_naxis2")
        	ny = int(imgets.value)
		canobj.crpix1 = nx/2.0 + 0.5
		canobj.crpix2 = ny/2.0 + 0.5
	}


end
