procedure canwcs

#string  root     = "as40k"              {prompt="Root Image Name"}
#real    crval1   = ""           {prompt="RA of the header (in degrees)"}
#real    crval2   = "0.0"           {prompt="Dec of the header (in degrees)"}
#real    crpix1   = "512.5"        {prompt="X-Pixel corresponding to the RA-Dec"}
#real    crpix2   = "512.5"        {prompt="Y-Pixel corresponding to the RA-Dec"}
bool     align    = no             {prompt="Input Image Aligned?"}

begin

	string	froot, mosfil
	int	iref0
        real    raval,decval,xradec,yradec,rapix,decpix,obsyr

	froot  = canobj.root
        iref0  = canobj.iref

        mosfil = froot//"_"//iref0
	if (align) {
		mosfil = froot//"_"//iref0//"a"
		     }

	imgets (mosfil, "CRVAL1")
        raval  = real(imgets.value)
	imgets (mosfil, "CRVAL2")
        decval = real(imgets.value)
	imgets (mosfil, "CRPIX1")
        xradec = real(imgets.value)
	imgets (mosfil, "CRPIX2")
        yradec = real(imgets.value)
	imgets (mosfil, "EQUINOX")
        obsyr  = real(imgets.value)

	hedit.value = raval; print ("Enter RA value: CRVAL1")
    	hedit (mosfil, fields="CRVAL1", add+, delete-, verify-, show+, update+)
	hedit.value = decval; print ("Enter Dec value: CRVAL2")
    	hedit (mosfil, fields="CRVAL2",  add+, delete-, verify-, show+, update+)
	hedit.value = xradec; print ("Enter X Pixel value: CRPIX1")
    	hedit (mosfil, fields="CRPIX1", add+, delete-, verify-, show+, update+)
	hedit.value = yradec; print ("Enter Y Pixel value: CRPIX2")
    	hedit (mosfil, fields="CRPIX2", add+, delete-, verify-, show+, update+)
	hedit.value = obsyr; print ("Enter Epoch of RA-Dec: EQUINOX")
    	hedit (mosfil, fields="EQUINOX", add+, delete-, verify-, show+, update+)
    #hedit (mosfil, fields="CRVAL1", value=raval, add+, delete-, verify-, show-, update+)

	end
