procedure canwcsfix(image, crval1, crval2, crpix1, crpix2)

string  image    = "as40k"              {prompt="Image Name"}
real    crval1   = 0.0        		{prompt="RA of the header (in degrees)"}
real    crval2   = 0.0           	{prompt="Dec of the header (in degrees)"}
real    crpix1   = 512.5        	{prompt="X-Pixel corresponding to the RA-Dec"}
real    crpix2   = 512.5        	{prompt="Y-Pixel corresponding to the RA-Dec"}
real    equinox  = 2000.0       	{prompt="Equinox of the coordinates"}
bool    verify   = no             	{prompt="Verify WCS parameters before forcing?"}

begin

	string	froot, mosfil
	int	iref0
        real    raval,decval,xradec,yradec,epoch   #rapix,decpix,obsyr
	bool	ask

	#froot  = canobj.root
        #iref0  = canobj.iref

        #mosfil = froot//"_"//iref0
	#if (align) {
	#	mosfil = froot//"_"//iref0//"a"
	#	     }

	mosfil = image; ask = verify
	raval = crval1; decval = crval2; xradec = crpix1; yradec = crpix2; epoch = equinox

	#imgets (mosfil, "CRVAL1")
        #raval  = real(imgets.value)
	#imgets (mosfil, "CRVAL2")
        #decval = real(imgets.value)
	#imgets (mosfil, "CRPIX1")
        #xradec = real(imgets.value)
	#imgets (mosfil, "CRPIX2")
        #yradec = real(imgets.value)
	#imgets (mosfil, "EQUINOX")
        #obsyr  = real(imgets.value)

	#hedit.value = raval #; print ("Enter RA value: CRVAL1")
    	hedit (mosfil, "CRVAL1", raval, add+, delete-, verify=ask, show+, update+)
	#hedit.value = decval #; print ("Enter Dec value: CRVAL2")
    	hedit (mosfil, "CRVAL2",  decval, add+, delete-, verify=ask, show+, update+)
	#hedit.value = xradec #; print ("Enter X Pixel value: CRPIX1")
    	hedit (mosfil, "CRPIX1", xradec, add+, delete-, verify=ask, show+, update+)
	#hedit.value = yradec #; print ("Enter Y Pixel value: CRPIX2")
    	hedit (mosfil, "CRPIX2", yradec, add+, delete-, verify=ask, show+, update+)
	#hedit.value = epoch #; print ("Enter Epoch of RA-Dec: EQUINOX")
    	hedit (mosfil, "EQUINOX", epoch, add+, delete-, verify=ask, show+, update+)
    #hedit (mosfil, fields="CRVAL1", value=raval, add+, delete-, verify=ask, show-, update+)

	end
