procedure hstwcs(image, coolist)

string  image    = ""           {prompt="Input image"}
string  coolist  = "ref.coo"    {prompt="RADEC coofile"}
bool    ccmap    = no		{prompt="run ccmap?"}
bool    update   = no		{prompt="Update headers if ccmap=yes?"}
string  projtyp  = "tnx"    	{prompt="Type of projection if ccmap=yes?"}

begin
        string  infil, coofil, starcenout, ccmapdb, ptype, starcenlog
	int	nmatch
	bool	cmap, uphead

        infil = image; coofil = coolist; starcenout = infil//"_hstwcs.coo"
	cmap = ccmap; uphead = update; ptype = projtyp; starcenlog = infil//"_starcen.log"
	ccmapdb = infil//"_starcen.db"
        delete(starcenout, ver-, >& "dev$null")
        delete(ccmapdb, ver-, >& "dev$null")
        delete(starcenlog, ver-, >& "dev$null")

	skyxymatch (infil, infil, "STDOUT", coords=coofil, rwxf="%12.6f", rwyf="%12.6f", wxf="%12.6f", wyf="%12.6f") | fields ("STDIN", "3-6", lines="19-", > starcenout)
	#print ("Finding the centroids of the star in ", infil)
	starcen(infil, starcenout, radec+)  
	type (infil//"_starcen.coo")
	wc infil//"_starcen.coo" | scan (nmatch)
	print("-------------------------------------------------")
	print ("XY and RADEC of ", nmatch, " common stars are stored in ", infil//"_starcen.coo")
	print("-------------------------------------------------")
	if (cmap) {
	ccmap (infil//"_starcen.coo", ccmapdb, images=infil, xc=4, yc=5, lngc=6, latc=7, lngunit="degree", latunit="degree", update=uphead, proj=ptype)
	}

end

