procedure       regtoxy(regfil)

string  regfil  = "test.reg"     {prompt="Input ds9 region file"}
string  xyfil   = "test.xy"      {prompt="Output xy file"}
string  shape   = "circle"       {prompt="The shape of the region to extract"}
string  separ   = ","       	 {prompt="The separator between the numbers"}
int	entry	= 0		 {prompt="The occurence number of the shape [0===>all]"}
int	nshape	= 0		 {prompt="Total number of shapes (circle, ellipse, box)"}
bool    verbose = yes           {prompt="Verbose each operation"}
string  values  = ""       	 {prompt="String containing output values"}

begin
        string  regf, xyf, tfil, tline, symbol, comma, value
        real    xc, yc, radius, val[5]
	int	nsym, j, i, len, nf, ilin, ipos[9]
	bool	talk

	regf = regfil; symbol = shape; comma = separ
	ilin = entry; talk = verbose
        tfil = "temp_regtomask.lis"
        delete(tfil, ver-, >& "dev$null")


        fields (regf, "1-", lines="1-") | match (symbol, >> tfil)
        fields (regf, "1-", lines="1-") | match (symbol) | wc | scan(nsym)
        if (talk) print(" Number of shapes (", symbol, " ) = ", nsym)
	ilin = min(ilin, nsym)
	#if (ilin == 0) ilin = nsym

#        for (j=1; j <= ncir; j +=1) {
#          fields (tfil, "1-", lines=j) | scan(tline)
#          #print(tline)
#          #=strstr("(", "circle(7330.2258,8259.4902,6.5446082)")
#          len = strlen(tline)
#          i1 = strstr("(", tline)
#          i2 = strstr(",", tline)
#          #print(i2)
#          xc = real(substr(tline, i1+1, i2-1))
#          i1 = strstr(",", substr(tline, i2+1, len))
#          yc = real(substr(tline, i2+1, i2+i1-1))
#          i3 = strstr(")", tline)
#          radius = real(substr(tline, i2+i1+1, i3-1))
#          print(xc, yc, radius)
#        }

	if (nsym > 0) {
	if (strlwr(symbol) == "circle") {nf = 2} else {nf = 4}
        for (j=1; j <= nsym; j +=1) {
          fields (tfil, "1-", lines=j) | scan(tline)
          len = strlen(tline)
		  ipos[1] = strstr("(", tline)
		if (ilin == j || ilin == 0) {
        	for (i=1; i <= nf; i +=1) {
          	  ipos[i+1] = strstr(comma, substr(tline, ipos[i]+1, len)) + ipos[i]
                  val[i] = real(substr(tline, ipos[i]+1, ipos[i+1]-1))
	          if (i == 1) {value = val[i]} else {value = value//" "//str(val[i])}
		}
	  ipos[i+1] = strstr(")", tline) 
	  val[i] = real(substr(tline, ipos[i]+1, ipos[i+1]-1))
	  value = value//" "//str(val[i])
	#if (nf == 2) {print(val[1], val[2], val[3])}
	#if (nf == 4) {print(val[1], val[2], val[3], val[4], val[5])}
	if (talk)print(value)
	}
	}
	} else {value = ""}

	nshape = nsym
	values = value

end

