procedure ringdisp(galnam)

string  galnam       {prompt="Ring Gal Name (arp141|arp143|VIIZw466|arp291|Izw45)"}
int     frame        {prompt="frame to be written into"}

begin

string rim,haim,gal,haew
int    inum

gal = galnam
inum = frame

#wlpars.axis1_title="RIGHT ASCENSION (2000)"
#wlpars.axis2_title="DECLINATION (2000)"
wlpars.axis1_title=" "
wlpars.axis2_title=" "
	wlpars.label_s=2.0
        wlpars.title_size=2.0
        wlpars.axis_ti=2.0

start:

 if (gal == "arp143") {
	rim = "arp143/arp143Radd[66:215,41:251]"
	haim = "arp143/arp143Hasb[66:215,41:251]"
	haew = "arp143/arp143Haew[66:215,41:251]"
	wlpars.title=" "
	newcont.floor=0.05
	newcont.ceiling=3.20
        newcont.ncontou=7
	displ.er=yes
	displ.z1=-0.05
	displ.z2=10.0
        wlpars.axis1_s="top"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cont-, limage=haim, left=0.20, right=0.50, bottom=0.52, top=0.92)
	displ.er=no
	displ.z1=-0.1
	displ.z2=2.0
        wlpars.axis1_s="top"
        wlpars.axis2_s="right"
disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.81, bottom=0.52, top=0.92)
	displ.er=no
	displ.z1=-0.05
	displ.z2=5.0
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cimage=haim, limage=haim, left=0.20, right=0.50, bottom=0.10, top=0.50)
	displ.er=no
	displ.z1=-0.1
	displ.z2=2.0
	displ.z1=0.0
	displ.z2=500.0
        newcont.floor=20.0
        newcont.ceiling=500.0
        newcont.ncontou=3
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="right"
disconlab (haew, frame=inum, cont-, limage=rim, left=0.51, right=0.81, bottom=0.10, top=0.50)
displ.er=yes
}
	else if (gal == "arp141") {
	#rim = "arp141/arp141Radd[116:230,71:230]"
	rim = "arp141/arp141Radd[116:230,71:270]"
	haim = "arp141/arp141Hasb[116:230,71:270]"
	haew = "arp141/arp141Haew[116:230,71:270]"
	wlpars.title=" "
	newcont.floor=0.04
	newcont.ceiling=0.64
        newcont.ncontou=5
	displ.er=yes
	displ.z1=-0.05
	displ.z2=10.0
	wlpars.axis1_s="top"
	wlpars.axis2_s="left"
#disconlab (rim, frame=inum, cont-, limage=haim, left=0.19, right=0.49, bottom=0.52, top=0.92)
disconlab (rim, frame=inum, cont-, limage=haim, left=0.21, right=0.49, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=0.01
	displ.z2=0.5
	wlpars.axis1_s="top"
	wlpars.axis2_s="right"
disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.79, bottom=0.51, top=0.96)
#disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.81, bottom=0.52, top=0.92)
	displ.er=no
	displ.z1=-0.05
	displ.z2=3.0
	wlpars.axis1_s="bottom"
	wlpars.axis2_s="left"
disconlab (rim, frame=inum, cimage=haim, limage=haim, left=0.21, right=0.49, bottom=0.04, top=0.49)
	displ.er=no
	displ.z1=-0.01
	displ.z2=0.5
	displ.z1=0.0
	displ.z2=500.0
	displ.fill = no
	displ.xcen = 0.66
	displ.ycen = 0.28
	displ.xmag = 0.2
	displ.ymag = 0.2
        newcont.floor=20.0
        newcont.ceiling=500.0
        newcont.ncontou=3
	wlpars.axis1_s="bottom"
	wlpars.axis2_s="right"
disconlab (haew, frame=inum, cont-, limage=haim, left=0.51, right=0.79, bottom=0.04, top=0.49)
#isoimap (haew, "arp141/arp141Hagaucntrep0", fulltab-, minsma=37.18, 
#maxsma=37.19, nlevels=2, color="r", frame=inum)
	displ.er=yes
}
        else if (gal == "arp142") {
        rim = "arp142/arp142Rcnt[136:260,91:300]"
        haim = "arp142/arp142Hasb[136:260,91:300]"
        haew = "arp142/arp142Haew[136:260,91:300]"
        wlpars.title=" "
        newcont.floor=0.12
        newcont.ceiling=1.92
        newcont.ncontou=5
	displ.er=yes
	displ.z1=-0.05
	displ.z2=10.0
        wlpars.axis1_s="top"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cont-, limage=haim, left=0.24, right=0.49, bottom=0.50, top=0.90)
	displ.er=no
	displ.z1=0.02
	displ.z2=1.5
        wlpars.axis1_s="top"
        wlpars.axis2_s="right"
disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.76, bottom=0.50, top=0.90)
	displ.er=no
	displ.z1=-0.05
	displ.z2=3.0
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="left"
	wlpars.label_s=1.5
disconlab (rim, frame=inum, cimage=haim, limage=haim, left=0.24, right=0.49, bottom=0.09, top=0.49)
	displ.er=no
	displ.z1=0.02
	displ.z2=1.5
	displ.z1=0.0
	displ.z2=700
        newcont.floor=20.0
        newcont.ceiling=500.0
        newcont.ncontou=3
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="right"
disconlab (haew, frame=inum, cont-, limage=haim, left=0.51, right=0.76, bottom=0.09, top=0.49)
	displ.er=yes
	displ.ztrans="linear"
}
        else if (gal == "arp291") {
        rim = "arp291/arp291R1cnt[101:230,101:230]"
        haim = "arp291/arp291Hasb[101:230,101:230]"
        haew = "arp291/arp291Haew[101:230,101:230]"
        wlpars.title=" "
        newcont.floor=0.10
        newcont.ceiling=1.6
        newcont.ncontou=5
	displ.er=yes
	displ.z1=-0.05
	displ.z2=10.0
        wlpars.axis1_s="top"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cont-, limage=haim, left=0.14, right=0.49, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=0.02
	displ.z2=1.5
        wlpars.axis1_s="top"
        wlpars.axis2_s="right"
disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=-0.05
	displ.z2=3.0
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cimage=haim, limage=haim, left=0.14, right=0.49, bottom=0.14, top=0.59)
	displ.er=no
	displ.z1=0.02
	displ.z2=1.5
	displ.z1=0.0
	displ.z2=500
        newcont.floor=20.0
        newcont.ceiling=500.0
        newcont.ncontou=3
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="right"
disconlab (haew, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.14, top=0.59)
	displ.er=yes
}
        else if (gal == "VIIZw466") {
	rim = "VIIzw466/VIIzw466R2[91:200,91:220]"
        haim = "VIIzw466/VIIzw466Hasb[91:200,91:220]"
        haew = "VIIzw466/VIIzw466Haew[91:200,91:220]"
        wlpars.title=" "
        newcont.floor=0.12
        newcont.ceiling=1.92
        newcont.ncontou=5
	displ.er=yes
	displ.z1=-0.05
	displ.z2=10.0
        wlpars.axis1_s="top"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cont-, limage=haim, left=0.14, right=0.49, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=0.02
	displ.z2=1.5
        wlpars.axis1_s="top"
        wlpars.axis2_s="right"
disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=-0.05
	displ.z2=2.0
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cimage=haim, limage=haim, left=0.14, right=0.49, bottom=0.07, top=0.52)
	displ.er=no
	displ.z1=0.0
	displ.z2=500.0
        newcont.floor=20.0
        newcont.ceiling=500.0
        newcont.ncontou=3
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="right"
disconlab (haew, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.07, top=0.52)
	displ.er=yes
}
        else if (gal == "Izw45") {
        rim = "Izw45/n7izw45R1cnt[141:220,151:220]"
        haim = "Izw45/izw45Hasb[141:220,151:220]"
        haew = "Izw45/izw45Haew[141:220,151:220]"
        wlpars.title=" "
        newcont.floor=0.15
        newcont.ceiling=2.4
        newcont.ncontou=5
	displ.er=yes
	displ.z1=-0.05
	displ.z2=10.0
        wlpars.axis1_s="top"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cont-, limage=haim, left=0.14, right=0.49, bottom=0.51, top=0.86)
	displ.er=no
	displ.z1=0.05
	displ.z2=1
        wlpars.axis1_s="top"
        wlpars.axis2_s="right"
disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.51, top=0.86)
	displ.er=no
	displ.z1=0.05
	displ.z2=3.0
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cimage=haim, limage=haim, left=0.14, right=0.49, bottom=0.14, top=0.58)
	displ.er=no
	displ.z1=-1.0
	displ.z2=300
        newcont.floor=20.0
        newcont.ceiling=500.0
        newcont.ncontou=3
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="right"
disconlab (haew, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.14, top=0.58)

	displ.er=yes
}
        else if (gal == "ngc2793") {
        #rim = "n2793/ngc2793R1cnt[121:250,121:250]"
        rim = "n2793/ngc2793R1cnt[131:280,131:280]"
        haim = "n2793/ngc2793Hasb[131:280,131:280]"
        haew = "n2793/ngc2793Haew[131:280,131:280]"
        wlpars.title=" "
        newcont.floor=0.10
        newcont.ceiling=1.6
        newcont.ncontou=5
	displ.er=yes
	displ.z1=-0.05
	displ.z2=10.0
        wlpars.axis1_s="top"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cont-, limage=haim, left=0.14, right=0.49, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=0.02
	displ.z2=1.5
        wlpars.axis1_s="top"
        wlpars.axis2_s="right"
disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=-0.05
	displ.z2=3.0
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cimage=haim, limage=haim, left=0.14, right=0.49, bottom=0.14, top=0.59)
	displ.er=no
	displ.z1=0.0
	displ.z2=500
        newcont.floor=20.0
        newcont.ceiling=500.0
        newcont.ncontou=3
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="right"
disconlab (haew, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.14, top=0.59)
	displ.er=yes
}
        else if (gal == "iihz4") {
        rim = "iihz4/n7iihz4Rcnt[121:220,131:230]"
        haim = "iihz4/iihz4Hasb[121:220,131:230]"
        haew = "iihz4/iihz4Haew[121:220,131:230]"
        wlpars.title=" "
        newcont.floor=0.12
        newcont.ceiling=1.92
        newcont.ncontou=5
	displ.er=yes
	displ.z1=-0.05
	displ.z2=10.0
        wlpars.axis1_s="top"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cont-, limage=haim, left=0.14, right=0.49, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=0.02
	displ.z2=1.5
        wlpars.axis1_s="top"
        wlpars.axis2_s="right"
disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=0.20
	displ.z2=3.0
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cimage=haim, limage=haim, left=0.14, right=0.49, bottom=0.14, top=0.59)
	displ.er=no
	displ.z1=0.0
	displ.z2=750
        newcont.floor=20.0
        newcont.ceiling=500.0
        newcont.ncontou=3
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="right"
disconlab (haew, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.14, top=0.59)
	displ.er=yes
}
        else if (gal == "iizw28") {
        rim = "IIzw28/n6iizw28R1[186:235,141:190]"
        haim = "IIzw28/iizw28Hasb[186:235,141:190]"
        haew = "IIzw28/iizw28Haew[186:235,141:190]"
        wlpars.title=" "
        newcont.floor=0.15
        newcont.ceiling=2.4
        newcont.ncontou=5
	displ.er=yes
	displ.z1=-0.05
	displ.z2=10.0
        wlpars.axis1_s="top"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cont-, limage=haim, left=0.14, right=0.49, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=0.02
	displ.z2=1.5
        wlpars.axis1_s="top"
        wlpars.axis2_s="right"
disconlab (haim, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.51, top=0.96)
	displ.er=no
	displ.z1=-0.05
	displ.z2=3.0
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="left"
disconlab (rim, frame=inum, cimage=haim, limage=haim, left=0.14, right=0.49, bottom=0.15, top=0.60)
	displ.er=no
	displ.z1=0.0
	displ.z2=500
        newcont.floor=20.0
        newcont.ceiling=500.0
        newcont.ncontou=3
        wlpars.axis1_s="bottom"
        wlpars.axis2_s="right"
disconlab (haew, frame=inum, cont-, limage=haim, left=0.51, right=0.86, bottom=0.15, top=0.60)
	displ.er=yes
}

        else {
          print("Galaxy name ",gal," is wrong! Please reenter the correct name")
          scan (gal)
          if (gal != "no")goto start
        }

print("Done")

end
