procedure s0sky(infileB,infileV,infileR,infileK)

string  infileB  = "ugc7880b_n"              {prompt="B image file name"}
string  infileV  = "ugc7880v_n"              {prompt="V image file name"}
string  infileR  = "ugc7880r_n"              {prompt="R image file name"}
string  infileK  = "u7880k_gau_n"            {prompt="K image file name"}
string  imagdir  = "home$s0/aperture_phot/images/" {prompt="Image Directory"}
int     nsky     = "5"                       {prompt="Number of sky positions"}

begin

        string  imfile[4],ifile[4],fitsdir,skyreg
        real    obstime[4], ymean[4], yrms[4], ymed[4]
        int     x1,x2,y1,y2,x,y,ns
	real    bmean,bmed,brms,bmedps,bmedmag
	real    vmean,vmed,vrms,vmedps,bvmed
	real    rmean,rmed,rrms,rmedps,brmed
	real    kmean,kmed,krms,vkmed

        fitsdir = imagdir
	ns      = nsky
        ifile[1] = infileB
        ifile[2] = infileV
        ifile[3] = infileR
        ifile[4] = infileK

        imfile[1] = fitsdir//ifile[1]
        imfile[2] = fitsdir//ifile[2]
        imfile[3] = fitsdir//ifile[3]
        imfile[4] = fitsdir//ifile[4]

  display (imfile[1])
  print ("**** select ",ns," regions for measuring sky and hit spacebar")
for (j=1; j <=ns; j +=1){
  = fscan (imcur, x, y)

  x1=x-2
  y1=y-2
  x2=x+2
  y2=y+2
  skyreg = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
  #print(skyreg) 

for (i=1; i <=4; i +=1){
  keypar (imfile[i], "EXPTIME")
  obstime[i] = real(keypar.value)
}
  imstat (imfile[1]//skyreg, fields="mean,stddev,midpt", format- ) | scan (bmean, brms, bmed)
  imstat (imfile[2]//skyreg, fields="mean,stddev,midpt", format- ) | scan (vmean, vrms, vmed)
  imstat (imfile[3]//skyreg, fields="mean,stddev,midpt", format- ) | scan (rmean, rrms, rmed)
  imstat (imfile[4]//skyreg, fields="mean,stddev,midpt", format- ) | scan (kmean, krms, kmed)

#for (i=1; i <=4; i +=1){
#  imstat (imfile[i]//skyreg, fields="mean,stddev,midpt", format- ) | scan (ymean[i], yrms[i], ymed[i])
#  keypar (imfile[i], "EXPTIME")
#  obstime[i] = real(keypar.value)
#
#  printf ("%8.1f %10.3f %8.3f %10.3f %c \n", obstime[i], ymean[i], yrms[i], ymed[i], ifile[i])
#}
	bmedps = bmed/obstime[1]
	vmedps = vmed/obstime[2]
	rmedps = rmed/obstime[3]
	bvmed = vmedps/bmedps
	brmed = rmedps/bmedps
	kmed  = kmed+1200.0
	vkmed = kmed/vmedps
	#bvmedmag = 2.5*log10(bvmed)
	bmedmag = -2.5*log10(bmedps) - 0.095*2.5*log10(bvmed) + 22.88
  printf ("%3d %10.3f %10.3f %10.5f %10.5f %10.5f %c \n", j, bmedps, vmedps, bvmed, brmed, vkmed, skyreg)
  printf ("%3d %8.4f %8.4f %8.4f %8.2f %9.5f %9.5f %9.5f %8.3f %c \n", j, bmedps, vmedps, rmedps, kmed, bvmed, brmed, vkmed, bmedmag, skyreg) | cat >> ifile[1]//"_skystat.log"
}

end
