procedure	wcstoxy(catal)

string  catal  = "m81csc_bright.cat"         	{prompt="Catalog name with RADEC of objects"}
string  refim  = "../m81acs/m81acs05_I2m"    	{prompt="Reference WCS image name"}
string  outxy  = "wcstoxy.cat"    		{prompt="Output XY list"}
int     idcol   = 1              		{prompt="ID column number"}
int     xcol    = 2              		{prompt="X column number"}
int     ycol    = 3              		{prompt="Y column number"}
int     rcol    = 0              		{prompt="Another optional size column"}
string  sizuni = "arcsec"    			{prompt="Size unit of rcol [arcsec|degree|pixel]"}
#string  outcol = ""    				{prompt="Output XY column[idcol xcol ycol rcol]"}

begin
	string 	cat_wcs, cat_xy, filnam, sunit
	string	ttt_xy, ttt_xy1, ttt_xy2, ttt_xy0, columns, column_rad 
	real	conv
	int	xc, yc, id, zc

	cat_wcs = catal; filnam = refim; cat_xy = outxy
	xc = xcol; yc = ycol; id = idcol; zc = rcol; sunit = sizuni
	inscale(filnam, units=sunit, verbose-); conv = inscale.scale


        ttt_xy = "ttt_xy.cat"
        ttt_xy0 = "ttt_xy0.cat"
        ttt_xy1 = "ttt_xy1.cat"
        ttt_xy2 = "ttt_xy2.cat"
        delete(cat_xy, ver-, >& "dev$null")
        delete(ttt_xy, ver-, >& "dev$null")
        delete(ttt_xy0, ver-, >& "dev$null")
        delete(ttt_xy1, ver-, >& "dev$null")
        delete(ttt_xy2, ver-, >& "dev$null")
        wcsxymatch (filnam, filnam, ttt_xy, coords=cat_wcs, xc=xc, yc=yc, verbose-)
	if (zc>0){
        fields (cat_wcs, str(zc), lines="1-", >> ttt_xy1)
	tcalc (ttt_xy1, "size_pix", "c1/"//str(conv), datatype="real")
        fields (ttt_xy1, "2", lines="3-", >> ttt_xy2)
        delete(ttt_xy1, ver-, >& "dev$null")
	}
        if (id>0) {fields (cat_wcs, str(id), lines="1-", >> ttt_xy1)}
        fields (ttt_xy, fields="1-2", lines="11-", >> ttt_xy0)
	if (zc>0){column_rad = ","//ttt_xy2} else {column_rad= ""}
	if (id != 0 && id < xc){columns = ttt_xy1//","//ttt_xy0//column_rad}
	if (id != 0 && id > yc){columns = ttt_xy0//","//ttt_xy1//column_rad}
	if (id == 0){columns = ttt_xy0//column_rad}
	print(columns)
	joinlin (columns, output=cat_xy)
	#joinlin (ttt_xy1//","//ttt_xy0//","//ttt_xy2, output=cat_xy)

end

