procedure	lineflux(filnam)

string  filnam  = ""      	{prompt="File Name"}
int  	lineno  = 1 		{prompt="Line number of spectrum"}
int  	bandno  = 1 		{prompt="band number of spectrum"}
#real    contflux= 1.0           {prompt="Continuum flux (0 ==> cont level is zero)"}
real    wb 	= 4600.0        {prompt="Wavelength in Ang to measure blue continuum"}
real    wr 	= 4725.0        {prompt="Wavelength in Ang to measure red  continuum"}
real    wid 	= 10.0          {prompt="Width of the window in Ang to measure continuum"}
string	cursor  = ""		{prompt="Cursor File Name"}
#string  graphics="stdgraph"     {prompt="Output graphics device"}
#string  splotlog=""     	{prompt="File for saving line parameter file [empty=no save]"}
string  logfile = ""      {prompt="File Name"}

begin
	string filin, splotfilcur, splotfillog
	string graphtyp, curfile, linelog, splotkey, c1
	real	basewid, yl1, yl2, yr1, yr2 
	real	lint, rint, yl, yr  #, cflux, basewidpix, xcen, ycen
	real	center, cont, flux, eqw, core, gfwhm, lfwhm
	real	x0, y0
	int	lno, bno, i1, icode
	struct 	line

        filin = filnam; graphtyp= "stdgraph"; lno = lineno; bno = bandno 
	curfile = cursor  #; linelog = splotlog

	#disp = 1.0; cdisp = "1.0"; cflux = contflux; basewidpix = basepix
	#xcen = xref; ycen = yref
	#hselect (filin, "CDELT2", expr+) | scan(cdisp)
	#if (cdisp != " " && real(cdisp) > 0.01) {disp = real(cdisp)}
	#basewid = basewidpix*disp
	#yl = slityx - 2.0*basewid; yr = slityx + 2.0*basewid

	yl = wb; yr = wr; basewid = wid
	yl1 = yl - 0.5*basewid; yl2 = yl + 0.5*basewid
	yr1 = yr - 0.5*basewid; yr2 = yr + 0.5*basewid

	splotfilcur = "splot_auto_cont.cursor"
	splotfillog = "splot_auto_cont.log"
        delete (splotfilcur, ver-, >& "dev$null")
        delete (splotfillog, ver-, >& "dev$null")
	print (yl1, " 0.0  1 m", >> splotfilcur)
	print (yl2, " 0.0  1 m", >> splotfilcur)
	print (yr1, " 0.0  1 m", >> splotfilcur)
	print (yr2, " 0.0  1 m", >> splotfilcur)
	print (yr2, " 0.0  1 q", >> splotfilcur)
	if (graphtyp == "stdgraph"){
	splot (filin, line=lno, band=bno, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic=graphtyp) 
	} else {
	splot (filin, line=lno, band=bno, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic=graphtyp, >& "dev$null") 
	}
	fields (splotfillog, fields="2", lines=3) | scan (lint)
	fields (splotfillog, fields="2", lines=4) | scan (rint)
	#print(disp, " ",lint, " ", rint)

        #if (cflux == 0.0) {lint = 0.0; rint = 0.0}
	splotfilcur = "splot_auto_lineflux.cursor"
	splotfillog = "splot_auto_lineflux.log"
        delete (splotfilcur, ver-, >& "dev$null")
        #delete (splotfillog, ver-, >& "dev$null")

	if (curfile == "") {
		print (yl, " ", lint, " 1 k", >> splotfilcur)
		print (yr, " ", rint, " 1 k", >> splotfilcur)
		print (yr, " ", rint, " 1 q", >> splotfilcur)
	} else {
	list = curfile
        i1 = 0
        while( fscan(list,line) != EOF ) {
          i1 = i1 + 1
	fields (curfile, fields="1-4", lines=str(i1)) | scan (x0, y0, icode, splotkey)
	#print(x0, y0, icode, splotkey)
        if (i1 == 1){x0 = yl; y0 = lint}; if (i1 == 2){x0 = yr; y0 = rint}
	print (x0, y0, icode, splotkey, >> splotfilcur)
        }
	}
	#type (splotfilcur)

	if (graphtyp == "stdgraph"){
	splot (filin, line=lno, band=bno, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic="stdgraph")
	} else {
	splot (filin, line=lno, band=bno, xmin=yl1, xmax=yr2, save_fi=splotfillog, cursor=splotfilcur, graphic=graphtyp, >& "dev$null")
	}

	#if (linelog != "") {
	#fields (splotfillog, fields="1-7", lines=4) | scan (center, cont, flux, eqw, core, gfwhm, lfwhm)
	#slitx = slitx - xcen; center = center - ycen
	#printf ("%9.2f %9.2f %9.2f %9.0f %9.3f %9.2f %6.2f %6.2f\n", slitx, center, cont, flux, eqw, core, gfwhm, lfwhm, >> linelog)
	#}

	lineflux.logfile = splotfillog

end
