procedure bnchedit(infile, outfile, filter, datatyp, grating)

string  infile  = " "              {prompt="BnC file name"}
string  outfile = " "              {prompt="Header edited file (can be input)"}
#string  objlis  = "object.lis"    {prompt="List containing Objects"}
string  filter = "blu-spe"        {prompt="Spectral region (blu, red etc)"}
string  datatyp= "object"         {prompt="Data-type"}
string  grating= "150/2.40"       {prompt="Grating (lines/mm)/angle"}
string  trimsec = "[*,41:480]"    {prompt="CCD section containing the slit"}
string  observa= " "              {prompt="Name of the Observer"}
string  telesco= "OAGH 2.12-m "   {prompt="Telescope"}
string  instrum= "B&C "           {prompt="Instrument+Grating"}
string  longitu= "-110:23:05.00"  {prompt="Longitude of Observatory"}
real    latitud= "31.05   "       {prompt="Latitude of Observatory"}
#string  latitud= "+31:03:10"      {prompt="Latitude of Observatory"}
string  gain   = "1.85"           {prompt="Electrons/ADU conversion factor"}
string  readnoi= "3.7"            {prompt="Readout noise (electrons)"}
int     dispaxis = "1"            {prompt="Dispersion axis 1=horizontal"}
#string  obsdate= "01/01/99"       {prompt="Date of Observation DD/MM/YY"}
#string  utime  = "00:00:00.00"    {prompt="Universal Time"}
#real    inttime="1"               {prompt="Integration time in secs"}
#string         = ""         {prompt=""}
bool    verbo = "no"              {prompt="Print record of each hedit"}

begin

string	object, obtrim, filt, dattyp, trims
int     dispax
bool    log

	obtrim = infile
	object = outfile
#	object = "2d"//obtrim
#	object = "@"//objlis
	filt   = filter
	dattyp = datatyp
	trims  = trimsec
	dispax = dispaxis
	log    = verbo

imcopy(input=obtrim//trims, output=object, verbo=no)
hedit(object, field="DATA-TYP", value=dattyp, add=yes, del=no, veri=no,
show=log, update=log)
hedit(object, field="FILTER", value=filt, add=yes, del=no, veri=no,
show=log, update=yes)
hedit(object, field="DISPAXIS", value=dispax, add=yes, del=no, veri=no, 
show=log, update=yes)
hedit(object, field="WCSDIM", value="2", add=yes, del=no, veri=no, 
show=log, update=yes)
hedit(object, field="LTM3_3", value=" ", add=no, del=yes, veri=no, 
show=log, update=yes)
hedit(object, field="WAT3_001", value=" ", add=no, del=yes, veri=no, 
show=log, update=yes)
hedit(object, field="OBSERVER", value=observa, add=yes, del=no, veri=no, 
show=log, update=yes)
hedit(object, field="TELESCOP", value=telesco, add=yes, del=no, veri=no, 
show=log, update=yes)
hedit(object, field="INSTRUME", value=instrum, add=yes, del=no, veri=no, 
show=log, update=yes)
hedit(object, field="SITELONG", value=longitu, add=yes, del=no, veri=no, 
show=log, update=yes)
hedit(object, field="SITELAT ", value=latitud, add=yes, del=no, veri=no, 
show=log, update=yes)
hedit(object, field="GRATING ", value=grating, add=yes, del=no, veri=no, 
show=log, update=yes)
hedit(object, field="GAIN    ", value=gain, add=yes, del=no, veri=no, 
show=log, update=yes)
hedit(object, field="READNOIS", value=readnoi, add=yes, del=no, veri=no, 
show=log, update=yes)

end
