procedure	skyshift(filenam)
string  filenam    	= "wr1_new1"    	{prompt="Input filename"}
int     apnum 		= 1             	{prompt="Aperture no in infile"}
string  skyline 	="spanal$data/skyline.dat"     {prompt="List containing sky lines to be measured"}

begin
        string  infil, skylist, skylineid[9], tmp, s1, splotfillog, imsec, shifil
        real    skywave[9], r1, wavshi, crval1, center, wavshitot
	int	i1, i2, api, k
        struct  line

        infil = filenam; skylist = skyline; api = apnum

        i1 = 0
        list = skylist
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#" && tmp != "") {
          i1=i1+1
          i2 = fscanf(line, "%s  %g", s1, r1)
          #print(s1, " ", r1)
          skylineid[i1] = s1; skywave[i1] = r1
        }
        }
	shifil = infil//"_shi.dat"
        imdelete("tmpobjfile", ver-, >& "dev$null")
        imdelete("tmpskyfile", ver-, >& "dev$null")
        imdelete("tmpobjfile1", ver-, >& "dev$null")
        delete(shifil, ver-, >& "dev$null")
        imsec = "[*,"//str(api)//","//str(1)//"]" #; print(imsec)
        scopy (infil//imsec, "tmpobjfile", w1=INDEF, w2=INDEF, rebin+)
        imsec = "[*,"//str(api)//","//str(2)//"]" #; print(imsec)
        scopy (infil//imsec, "tmpskyfile", w1=INDEF, w2=INDEF, rebin+)
        #scopy (infil, "tmpobjfile", w1=INDEF, w2=INDEF, aper=api, band=1, rebin+)
        #scopy (infil, "tmpskyfile", w1=INDEF, w2=INDEF, aper=api, band=2, rebin+)
        sarith ("tmpobjfile", "+", "tmpskyfile", "tmpobjfile1", w1=INDEF, w2=INDEF)
        wavshitot = 0.0
        for (k=1; k <= i1; k +=1) {
        omlinefit("tmpobjfile1", xpos=1, yposlit=skywave[k])
        splotfillog = "splot_auto_gaussfit.log"
        fields (splotfillog, fields="1", lines=4) | scan (center)
        wavshi = skywave[k] - center; wavshitot = wavshitot + wavshi
        print(skylineid[k], " ", skywave[k], " ", center, " SHIFT=", wavshi)
        print(skylineid[k], " ", skywave[k], " ", center, " SHIFT=", wavshi, >> shifil)
        }
        wavshi = wavshitot/real(k-1)
        hselect ("tmpobjfile1", "CRVAL1", expr+) | scan(crval1)
        crval1 = crval1 + wavshi
        print("Meanshift = ",wavshi, " CRVAL1 = ", crval1)
        print("Meanshift = ",wavshi, " CRVAL1 = ", crval1, >> shifil)
        hedit (infil, "CRVAL1", crval1, add+, verify-, show+, update+, >> shifil)
        #hselect (infil, "CRVAL1", expr+)

end
